/*
    IO.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "IO.h"
#include "util/schedYield.h"
#if 0
#include "util/PThreadStartRoutine.h"
#endif



const char* IO::getKeySignature (const int sf, const int mi)//XXX
{
#if 0
  //XXX
  const char* const keyDataTable[2][2][7]=//XXX
    //key signature$B$+$i7h$^$k$b$N!#(B      mi  # or b number of (# or b)
{
  {//major (mi=0)
    {//number of #
      "C Major",
      "G Major",
      "D Major",
      "A Major",
      "E Major",
      "B Major",
      "F# Major",
      "C# Major"
     },
    {//number of b
      "C Major",
      "F Major",
      "Bb Major",
      "Eb Major",
      "Ab Major",
      "Db Major",
      "Gb Major",
      ""
     }
  },
    
  {//minor (mi=1)
    {//number of #
      "A Minor"
      "E Minor"
      "B Minor"
      "F# Minor"
      "C# Minor"
      "G# Minor"
      "D# Minor"
      "A# Minor"
    },
   {//number of b
     "A Minor"
      "D Minor"
      "G Minor"
      "C Minor"
      "F Minor"
      "Bb Minor"
      "Eb Minor"
      ""
    }
  }
};//key signature$B$+$i7h$^$k$b$N!#(B
#endif
  return NULL;
}

void* IO::startPlayLoopThread (void* me)
{
  assert (me != NULL);
  static_cast<IO*>(me)->playLoop ();
  return NULL;
}


int IO::createPlayLoopThread (pthread_t* thread, pthread_attr_t* attr)
{
  assert (thread != NULL);
  return pthread_create (thread,attr,IO::startPlayLoopThread,this);
#if 0
  return pthread_create (thread, attr,
			 &PThreadStartRoutine<IO, &IO::playLoop>,
			 static_cast<void*> (this));
#endif
}

void IO::playLoop ()
{
  DEBUG_MESSAGE ("IO::playLoop called");
  uint32 lastTicks = 0;
  for (;;)
    {
      //$B>uBV$NJQ2=BT$A(B
      state->lock ();
      while ((lastTicks == state->songStatus.ticks) &&
	     (state->songStatus.state != SongStatus::DONE))
	state->waitChange ();
      state->getState (&cacheState);
      state->unlock ();
      
      lastTicks = cacheState.songStatus.ticks;

      //$B6qBNE*$J=hM}!#(B
      update ();
      if (cacheState.songStatus.state == SongStatus::DONE)
	break;
      schedYield ();
    }
}
