#include "InfoIO.h"

InfoIO* InfoIO::getInfoIO (DlHandler* handler, const string& name)
{
  assert (handler != NULL);

  string infoIOName;
  infoIOName = "infoIO";
  infoIOName += name;
  InfoIO* info=static_cast<InfoIO*> (handler->sym (infoIOName));
  
  return info;
}

IO* InfoIO::createIO (DlHandler* dlHandler, const string& name, 
		      State* state, WidiController* widiController,
		      Option* option)
{
  assert (dlHandler != NULL);
  assert (state != NULL);
  assert (widiController != NULL);
  assert (option != NULL);
  
  InfoIO* infoio=InfoIO::getInfoIO (dlHandler, name);
  if (infoio != NULL)
    return infoio->newIO (state, widiController, option);
  
  return NULL;
}


