/*
    InfoIO.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef InfioIO_H
#define InfioIO_H

#include "MainIO.h"
#include "util/DlHandler.h"

struct InfoIO
{
  //$B$3$l$G(Bnew$B$9$k!#(B
  IO* (*newIO) (State* state, WidiController* widiController, Option* option);

  //$B$3$l$G(Bnew$B$9$k!#(B
  MainIO* (*newMainIO) (State* state, WidiController* widiController,
			Option* option);

  //$BA4$F$N6J$,1iAU=*N;$7$?;~$K!"(B
  //user$B$+$i$NF~NOBT$A$r$9$k$+(B?$B0?$O!"=*N;$9$k$+(B?
  bool isWaitUserEventWhenFinished;
  
  //$B$3$l$G<B:]$K(BInfoIO$B$r<hF@$9$k!#(B
  static InfoIO* getInfoIO (DlHandler* handler, const string& name);

  //$B$3$l$G(Bnew IO$B$r$9$k!#(B
  static IO* createIO (DlHandler* handler, const string& name,
		       State* state, WidiController* widiController,
		       Option* option);
};
#endif // InfioIO_H
