/*
    MainIONull.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */



#ifndef MainIONull_H
#define MainIONull_H

#include "MainIO.h"

//$B2?$b8@$o$J$$%/%i%9(B for quiet mode
class MainIONull:public  MainIO
{
protected:
  virtual void initialize (){/*do nothing*/};
  virtual void update (){/*do nothing*/};
  virtual void release (){/*do nothing*/};
  virtual void coutLoop (){/*do nothing*/};
  virtual void cerrLoop (){/*do nothing*/};
  virtual void coutMessage (const char* message){/*do nothing*/};
  virtual void cerrMessage (const char* message){/*do nothing*/};
public:
  MainIONull (State* state__, WidiController* widiController__,
	      Option* option__):
    MainIO (state__, widiController__, option__)
    {/*do nothing*/};
  virtual ~MainIONull (){/*do nothing*/};
  //stdout
  virtual void normalMessage (const char* /*message*/){/*do nothing*/};
  virtual void normalMessage (const char* /*message*/,int /*size*/)
    {/*do nothgin*/};
  //stderr
  virtual void errorMessage (const char* /*errorMessage*/){/*do nothing*/};
  virtual void errorMessage (const char* /*errorMessage*/,int /*size*/)
    {/*do nothing*/};
};
#endif
