/*
    LCDInfo.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef LCDInfo_H
#define LCDInfo_H

#include "Widi/State.h"
#include "LevelInfo.h"

class LCDInfo
{
public:
  static const int LCD_LINES = 16;
  //static const int LCD_COLS = State::MAX_PARTS;
  static const int LCD_COLS = MIDI::MAX_CHANNEL*2;

protected:
  //level$B$K1~$8$F(Blcd$B$NCM$r@_Dj$9$k!#(B
  inline void setLevel (const int part, uchar level, uchar maxLevel);
  inline void setLCD (const int page,
		      const uchar dotData[SequencerStatus::PAGE_NUM][SequencerStatus::DOT_SIZE],
		      bool lcd[LCD_LINES][LCD_COLS],
		      const int dataOffset, const int columnOffset);
  inline void setPage (int page, const State& nowState);
  //nowState$B$K1~$8$FI,MW$J$i%Z!<%8$r@_Dj$9$k!#(B
  //$B;~4V$,2a$.$F$$$l$P2?$b$7$J$$!#(B
  //i.e.reset, setLevel,setDotData$B$HB3$1$F8F$Y$PNI$$!#(B
  inline void setDotData (const State& nowState);
  
public:
  LCDInfo ();
  ~LCDInfo ();
  
  bool isOn[LCD_LINES][LCD_COLS];
  //        $B=D(B(y)      $B2#(B(x)
  //     x->
  //   y(0,0) (1,0)          level=16
  //   |(0,1)
  //   v      (x,y)
  //
  //                          level=1
  //    01 02 ...             channel
  void reset ();//$BJQ?t$r=i4|2=$9$k!#(B
  //$BFbMF$r(BnowState$B$H(Blevel,maxLevel$B$K$"$C$?J*$K99?7$9$k!#(B
  void update (const State& nowState,
	       const uchar level[LCD_COLS],
	       const uchar maxLevel[LCD_COLS]);
  void update (const State& nowState,
	       const LevelInfo levelInfo[MIDI::MAX_PORT][MIDI::MAX_CHANNEL]);
};
#endif// LCDInfo_H
