/*
    LevelInfo.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef LevelInfo_H
#define LevelInfo_H
#include "Widi/State.h"

#define MAX_LEVEL (((double) 16383.0)*16383*127*16383)

struct LevelInfo
{
  double maxMachineTicks;
  double maxLevel;
  double nowMachineTicks;
  double nowLevel;
  LevelInfo ():
    maxMachineTicks (0), maxLevel (0), nowMachineTicks (0), nowLevel (0)
    {/*do nothing*/};
  void reset ()
    {
      maxMachineTicks = 0;
      maxLevel = 0;
      nowMachineTicks = 0;
      nowLevel = 0;
    };
  //$B%l%Y%k$r7W;;$9$k!#(B
  //$B$3$l$K$h$j(BmaxLevel,nowLevel$B$r99?7$9$k!#(B
  void getLevel (const State& nowState, const int port, const int channel);
  //$BJL$N7W;;J}K!$G$d$C$F$_$k!#(B
  void getLevel2 (const State& nowState, const int port, const int channel);
};
#endif// LevelInfo_H
