#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <cstdio>
#include <sys/ioctl.h>
#include <iostream>

#include "MainIO.h"
#include "IO/NCurses/IONCurses.h"
#include "IO/NCurses/IONTrace.h"
#include "Sequencer/Sequencer.h"
#include "Sequencer/OSS/MIDI/SequencerMIDI.h"
#include "Song/SMF/SMF.h"
#include "util/threadutil.h"

#define DEVICE_SEQUENCER "/dev/sequencer"

int
main (int argc,const char** argv)
{
  if (argc<=1)
    {
      exit (1);
    }
  
  State state;
  //MainIO* io=new MainIO (&state);
  //MainIO* io=new IONCurses (&state);
  MainIO* io=new IONTrace (&state);

#if 1
  list<const char*> files;
  for (int i=1;i<argc;i++)
    files.push_back (argv[i]);
  io->mainLoop (files);
#endif
  
#define IO_THREAD
#define PLAY_THREAD
  //#undef IO_THREAD
  //#undef PLAY_THREAD
  //  smf.play (*sequencer);
  

#ifdef IO_THREAD
  cerr << "now creating io thread." << endl;
  pthread_t ioThread;
  if (io->createMainLoopThread (&ioThread,NULL)!=0)
    {
      cerr << "create failed." << endl;
    }
#endif //IO_THREAD
#ifdef PLAY_THREAD
  seqfd=open ("/dev/sequencer",O_WRONLY);
  if (seqfd==-1)
    {
      perror ("can not open /dev/sequencer");
      exit (1);
    }
  ioctl(seqfd, SNDCTL_SEQ_RESET);//sequencer$B$N=i4|2=(B
  Sequencer* sequencer=new SequencerMIDI (&state,0);

  cerr << "done.now creating play thread." << endl;
  SMF smf (argv[1],&state,*io);
  cerr << "reading done." << endl;
  pthread_t playThread;
  if (smf.createPlayThread (&playThread,NULL,*sequencer)!=0)
  //if (smf.createPlayThread (&playThread,NULL,&sequencer)!=0)
    {
      cerr << "create failed" << endl;
    }
  cerr << "done." << endl;  

  void* retVal;
  if (pthread_join (playThread,&retVal)!=0)
    {
      cerr << "error:join" << endl;
    }
#endif//PLAY_THREAD
#ifdef IO_THREAD
  void* retVal2;
  if (pthread_join (ioThread,(void**)&retVal2)!=0)
    {
      cerr << "error:join" << endl;
    }
#endif//IO_THREAD
  sleep (10);
  
  cout << "all done" << endl;
  exit (0);
}
