/*
    IONCurses.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef IONCurses_H
#define IONCurses_H

#include <iostream>

#include "IO/MainIO.h"
#include "NCursesBase.h"

using namespace std;

class IONCurses:public NCursesBase,public MainIO
{
protected:
  /////////////////////////////////////////interfaceɽѡ
  virtual void update ();
  virtual void updateInfoWindow ();
  virtual void updateMainWindow ();
  virtual void coutMessage (const char* message);
  virtual void cerrMessage (const char* message){coutMessage (message);};
  virtual void cerrLoop () {/*do nothing*/};
  //cerrcoutˤƤޤΤcerrLoopס

  ///////////////////////////////////////////for ncurses
  //ttyNameǼ륹꡼롣
  WINDOW* infoWindow;
  int infoWindowLines;
  int infoWindowCols;
  WINDOW* mainWindow;
  int mainWindowLines;
  int mainWindowCols;
  WINDOW* messageWindow;
  int messageWindowLines;
  int messageWindowCols;
  
public:
  IONCurses (State* state__, WidiController* widiController__,
	     Option* option__);
  virtual ~IONCurses ();
  virtual void initialize () throw (Error);//Ƽ
  virtual void release ();//Ƽ
  virtual void errorMessage (const char* errorMessage);
  virtual void errorMessage (const char* errorMessage,int size);
};

#endif// IONCurses_H

