/*
    IONWrd.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef IONWrd_H
#define IONWrd_H

#include <iostream>

#include "PlugIn/Wrd/Wrd.h"
#include "NCursesBase.h"

using namespace std;

class IONWrd:public NCursesBase,public Wrd
{
protected:
  /////////////////////////////////////////interfaceɽѡ
  virtual void doUpdate ();
  ///////////////////////////////////////////for ncurses
  WINDOW* mainWindow;
  int mainWindowLines;
  int mainWindowCols;
  void updateMainWindow ();

#define MAX_ATTRIBUTE 47
  bool hasColors;
  int currentAttribute;
  int attribute[MAX_ATTRIBUTE];
  void initColors ();
  static const short BLACK  =0;
  static const short RED    =1;
  static const short GREEN  =2;
  static const short YELLOW =3;
  static const short BLUE   =4;
  static const short MAGENTA=5;
  static const short CYAN   =6;
  static const short WHITE  =7;
  
  
public:
  IONWrd (State* state__, WidiController* widiController__,
	  Option* option__);
  virtual ~IONWrd ();
  virtual void initialize ();//Ƽ
  virtual void release ();//Ƽ
  virtual void prePlay ();
  
protected:
  virtual void doFading (int fadeCount_, uint32 fromPalette_, uint32 toPalette_) {};
  
  virtual void execNextLine () {};
  virtual void execATMARK () {};
  virtual void execCOLOR (uint32 color_) {};
  virtual void execEND () {};
  virtual void execEXEC (const char* filename) {};
  virtual void execFADE (uint32 p1,uint32 p2,int speed) {};
  virtual void execGCIRCLE (uint32 x,uint32 y,uint r,uint32 p1,uint32 sw,uint32 p2) {};
  virtual void execGCLS (uint32 sw) {};
  virtual void execGINIT () {};
  virtual void execGLINE
  (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 p1,uint32 sw,uint32 p2) {};
  virtual void execGMODE (uint32 sw) {};
  virtual void execGMOVE (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 xd,uint32 yd,uint32 vs,uint32 vd,uint32 sw) {};
  virtual void execGON (bool oldIsGraphicOn_, bool isGraphicOn_) {};
  virtual void execGSCREEN (uint32 oldActivePage_, uint32 oldDisplayPage_, uint32 activePage_, uint32 displayPage_) {};
  virtual void execINKEY (uint32 barWaitFor_) {};
  virtual void execLOCATE (uint32 x_,uint32 y_) {};
  virtual void execLOOP (uint32 loop) {};
  virtual void execMAG
  (MagFile& mag, int32 x, int32 y, uint32 s, uint32 p) {};
  virtual void execOFFSET (uint32 offsetBarWaitFor_) {};
  virtual void execPAL (uint32 page,int32 rgb[16]) {};
  virtual void execPALREV (uint32 p) {};
  virtual void execPLOAD (PH0* ph0) {};
  virtual void execREMARK () {};
  virtual void execREST (uint32 barOffsetWaitFor,uint32 stepsWaitFor) {};
  virtual void execSCROLL (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 mode,uint32 color,uint32 chr) {};
  virtual void execSTARTUP (uint32 versoin_) {};
  virtual void execSTOP () {};
  virtual void execTCLS
  (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 color,uint32 chr) {};
  virtual void execTON (uint32 textMode_) {};
  virtual void execWAIT (uint32 barWaitFor_,uint32 steptsWaitFor_) {};
  virtual void execWMODE (uint32 deltaSteps_,uint32 wmode_) {};
  virtual void execFONTM (int32 fontMode_) {};
  virtual void execFONTP (uint32 num,uint32 x_,uint32 y_,uint32 attribute) {};
  virtual void execFONTR (int32 fontNumber,int32 fontData[16]) {};
  virtual void execGSC (int32 mode) {};
  virtual void execLINE (int32 mode) {};
  virtual void execPAL_ (int32 paletteNumber,int32 rgb) {};
  virtual void execREGSAVE (int32 num,int32 value[WRD_REGSAVE_SIZE_MAX]) {};
  virtual void execSCROLL_ (int32 x_,int32 y_) {};
  virtual void execTEXTDOT (int32 textDot_) {};
  virtual void execTMODE (int32 tmode_) {};
  virtual void execTSCRL (int32 lines) {};
  virtual void execVCOPY (int32 sx1,int32 sy1,int32 sx2,int32 sy2,int32 tx,int32 ty,int32 ss,int32 ts,int32 mode) {};
  virtual void execVSGET (int32 page[4]) {};//XXX 4Ƚ񤯤ΤϷʤ
  virtual void execVSRES () {};
  virtual void execXCOPY (int32 sx1,int32 sy1,int32 sx2,int32 sy2,int32 tx,int32 ty,int32 ss,int32 ts,int32 method,int32 opt[5]) {};

#if 0
  virtual void execLYRICS (const char*& lyrics,uint wmode_)
    {Wrd::execLYRICS (lyrics,wmode_);doUpdate ();};
#endif
  virtual void printChar (uint x_,uint y_,char c,int color_) {};
  virtual void printChar2b (uint x_,uint y_,char c1,char c2,int color_) {};
  virtual void doEscapeSequence () {};
  virtual void doRefreshTextScreen (TextScreen& textScreen_){doUpdate ();};
};
#endif// IONWrd_H
