/*
    NCursesBase.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include <cassert>

#include "NCursesBase.h"

using namespace std;

Mutex NCursesBase::cursesLock;

NCursesBase::NCursesBase ():
  screen (NULL)
{
  /*do nothing*/;
}

NCursesBase::~NCursesBase ()
{
  //do nothing
}

SCREEN* NCursesBase::getScreen (const char* ttyName="/dev/tty")
{
  FILE* ttyFd=fopen (ttyName,"r+");
  if (ttyFd==NULL)
    {
      perror ("NCursesBase:can not open /dev/tty.");
      Error error ("NCursesBase:can not open /dev/tty.");
      throw (error);
    }

  SCREEN* tmpScreen=newterm (NULL,ttyFd,ttyFd);//XXX ???
  //SCREEN* tmpScreen=newterm ("kterm",ttyFd,ttyFd);//XXX ???
  //SCREEN* tmpScreen=newterm ("ansi",ttyFd,ttyFd);//XXX ???
  assert (tmpScreen!=NULL);
  
  if (fclose (ttyFd)==EOF)
    {
      perror ("NCursesBase:can not close /dev/tty");
      Error error ("NCursesBase:can not close /dev/tty.");
      throw (error);
    }

  //󡣤ʤ꤯Ԥʤwhy???
  //return tmpScreen;
  initscr ();
  return set_term (tmpScreen);
}
