/*
    NCursesBase.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef NCursesBase_H
#define NCursesBase_H

#include "util/Mutex.h"

#if defined (HAVE_NCURSES_H)
# include <ncurses.h>
#elif defined (HAVE_CURSES_H)
# include <curses.h>
#else
# error ncurses header file is not found.
#endif

//mixin for use ncurses
class NCursesBase
{
  ////////////////////////////////////////////////////////////ncurses lock
  ///////////////(ʤncursesthread safe̵ΤɬפȤʤ롣)
private:
  static Mutex cursesLock;
protected:
  static void lockCurses () {cursesLock.lock ();};
  static void unlockCurses () {cursesLock.unlock ();};
  
  ///////////////////////////////////////////for ncurses
  SCREEN* screen;
  //ttyNameǼ륹꡼롣
  SCREEN* getScreen (const char* ttyName="/dev/tty");
public:
  NCursesBase ();
  virtual ~NCursesBase ();
};

#endif// NCursesBase_H
