#include "SherryCommand.h"

const SherryParameter::ParameterType SherryCommand::PARAMETER_TYPE[8][16][SherryCommand::MAX_PARAMETERS] =
{
  //0x0?
  //system command
  {
    {SherryParameter::END_OF_PARAMETER},//end of data
    {SherryParameter::END_OF_PARAMETER},//start playing

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID}
  },

  //0x1?
  //reserved
  {
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID}
  },
    
  //0x2?
  //allocation command
  {
    {SherryParameter::INVALID},

    {SherryParameter::UINT16_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x21

    {SherryParameter::UINT16_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x22

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},

    {SherryParameter::SCREEN_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x25

    {SherryParameter::UINT16_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x26

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::CHAR_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x27

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID}
  },
    
  //0x3?
  //transfer command
  {
    {SherryParameter::INVALID},

    {SherryParameter::UINT16, SherryParameter::END_OF_PARAMETER},//0x31

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},

    {SherryParameter::UINT16, SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::END_OF_PARAMETER},//0x35

    {SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::END_OF_PARAMETER},//0x36

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID}
  },
    
  //0x4?
  //palette command
  {
    {SherryParameter::INVALID},

    {SherryParameter::UINT16, SherryParameter::PALETTE_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x41

    {SherryParameter::UINT16, SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8, SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT8, SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::END_OF_PARAMETER},//0x42

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::END_OF_PARAMETER},//0x43

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::PALETTE_COPY_MASK,
     SherryParameter::END_OF_PARAMETER},//0x44

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::PALETTE_NUMBER_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x45

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID}
  },
    
  //0x5?
  //drawing command
  {
    {SherryParameter::INVALID},

    {SherryParameter::UINT16,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::CHAR_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x51

    {SherryParameter::UINT16, SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8,
     SherryParameter::END_OF_PARAMETER},//0x52

    {SherryParameter::UINT16, SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8,
     SherryParameter::END_OF_PARAMETER},//0x53

    {SherryParameter::UINT16, SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8,
     SherryParameter::END_OF_PARAMETER},//0x54

    {SherryParameter::UINT16, SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8,
     SherryParameter::END_OF_PARAMETER},//0x55

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID}
  },

  //0x6?
  //copying command
  {
    {SherryParameter::INVALID},

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::END_OF_PARAMETER},//0x61

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT8_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x62

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT8, SherryParameter::UINT8,
     SherryParameter::UINT8,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::END_OF_PARAMETER},//0x63

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID}
  },

  //0x7?
  //debugger infomation
  {
    {SherryParameter::INVALID},

    {SherryParameter::UINT16, SherryParameter::UINT16,
     SherryParameter::END_OF_PARAMETER},//0x71

    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},
    {SherryParameter::INVALID},

    {SherryParameter::CHAR_ARRAY,
     SherryParameter::END_OF_PARAMETER},//0x7f
  }
};

const SherryCommand::CommandType SherryCommand::END_OF_DATA;
const SherryCommand::CommandType SherryCommand::START_PLAYING;
                  			    	     		 
const SherryCommand::CommandType SherryCommand::RESERVED_COMMAND;
                  			    			 
const SherryCommand::CommandType SherryCommand::ALLOCATE_COMMAND;
const SherryCommand::CommandType SherryCommand::NEW_PALETTE;
const SherryCommand::CommandType SherryCommand::DELETE_PALETTE;
const SherryCommand::CommandType SherryCommand::NEW_SCREEN;
const SherryCommand::CommandType SherryCommand::DELETE_SCREEN;
const SherryCommand::CommandType SherryCommand::NEW_SCREEN_AND_LOAD_PNG;
                  			    			 
const SherryCommand::CommandType SherryCommand::TRANSFER_COMMAND;
const SherryCommand::CommandType SherryCommand::TRANSFER_PALETTE;
const SherryCommand::CommandType SherryCommand::TRANSFER_FULL_SCREEN;
const SherryCommand::CommandType SherryCommand::TRANSFER_PARTIAL_SCREEN;
                  			    	     		 
const SherryCommand::CommandType SherryCommand::PALTTE_COMMAND;
const SherryCommand::CommandType SherryCommand::SET_PALETTE;
const SherryCommand::CommandType SherryCommand::MERGE_PALETTE;
const SherryCommand::CommandType SherryCommand::COPY_PALETTE;
const SherryCommand::CommandType SherryCommand::MASK_COPY_PALETTE;
const SherryCommand::CommandType SherryCommand::PARTIAL_COPY_PALETTE;
                  			    	     		 
const SherryCommand::CommandType SherryCommand::DRAWING_COMMAND;
const SherryCommand::CommandType SherryCommand::DRAW_TEXT;
const SherryCommand::CommandType SherryCommand::DRAW_BOX;
const SherryCommand::CommandType SherryCommand::DRAW_VIRTIAL_LINE;
const SherryCommand::CommandType SherryCommand::DRAW_HORIZONTAL_LINE;
const SherryCommand::CommandType SherryCommand::DRAW_LINE;
                  			    			 
const SherryCommand::CommandType SherryCommand::COPY_COMMAND;
const SherryCommand::CommandType SherryCommand::COPY_AREA;
const SherryCommand::CommandType SherryCommand::MASK_COPY;
const SherryCommand::CommandType SherryCommand::PLANE_COPY;
                  			    			 
const SherryCommand::CommandType SherryCommand::DEBUGGER_COMMAND;
const SherryCommand::CommandType SherryCommand::SOURCE_FILE_POSITION;
const SherryCommand::CommandType SherryCommand::DEBUGGER_PRIVATE;


SherryCommand::SherryCommand (uint32 deltaTime__,
			      uint32 totalDeltaTime__,
			      CommandType commandType__,
			      int numberOfParameter__):
  deltaTime (deltaTime__), totalDeltaTime (totalDeltaTime__),
  commandType (commandType__ & 0x7f), skipBitFlag (commandType__ & 0x80),
  sherryParameter (new SherryParameter*[numberOfParameter__]),
  numberOfParameter (numberOfParameter__),nowNumberOfParameter (0)
{
  for (int i = 0; i < numberOfParameter; i++)
    sherryParameter[i] = NULL;
}



SherryCommand::~SherryCommand ()
{
  for (int i = 0; i < numberOfParameter; i++)
    delete sherryParameter[i];
  delete[] sherryParameter;
}



void SherryCommand::appendParameter (char charParameter)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (charParameter);
}

void SherryCommand::appendParameter (uint8 uint8Parameter)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (uint8Parameter);
}

void SherryCommand::appendParameter (uint16 uint16Parameter)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (uint16Parameter);
}

void SherryCommand::appendParameter (uint32 uint32Parameter)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (uint32Parameter);
}
  
void SherryCommand::appendParameter (const char* charArray, int size)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (charArray, size);
}

void SherryCommand::appendParameter (const uint8* uint8Array, int size)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (uint8Array, size);
}

void SherryCommand::appendParameter (const uint16* uint16Array, int size)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (uint16Array, size);
}

void SherryCommand::appendParameter (const SherryParameter::ScreenParameter* screenArray, int size)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (screenArray, size);
}

void SherryCommand::appendParameter (const SherryParameter::PaletteParameter* paletteArray, int size)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (paletteArray, size);
}

void SherryCommand::appendParameter (const uint8 paletteCopyMask[32])
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (paletteCopyMask);
}

void SherryCommand::appendParameter (const SherryParameter::PaletteNumberParameter* paletteNumberArray, int size)
{
  assert (nowNumberOfParameter < numberOfParameter);
  sherryParameter[nowNumberOfParameter++] =
    new SherryParameter (paletteNumberArray, size);
}
