#ifndef SherryPalette_H
#define SherryPalette_H

#include <cassert>

#include "SherryPaletteEntry.h"

using namespace std;

class SherryPalette
{
public:
  static const int MAX_PALETTES = 256;

private:
  SherryPaletteEntry entry[MAX_PALETTES];

public:
  SherryPalette () {};
  ~SherryPalette () {};

  void set (int i, uint8 r, uint8 g, uint8 b) {entry[i].set (r, g, b);};
  void copy (const SherryPalette* source)
    {
      assert (source != NULL);
      for (int i = 0; i < MAX_PALETTES; i++)
	entry[i].copy (source->getEntry (i));
    };
  void copyEntry (int i, const SherryPaletteEntry& sourceEntry)
    {
      entry[i].copy (sourceEntry);
    };
  const SherryPaletteEntry& getEntry (int i) const {return entry[i];};
  void reset ()
    {
      for (int i = 0; i < MAX_PALETTES; ++i)
	entry[i].reset ();
    };
};

#endif // SherryPalette_H
