#ifndef PH0_H
#define PH0_H

#include <string>

#include "util/mytype.h"

using namespace std;

class PH0
{
private:
  uchar* b;
  uchar* r;
  uchar* g;
  uchar* e;
public:
  PH0 (): b (NULL), r (NULL), g (NULL), e (NULL) {};
  ~PH0 ()
    {
      delete[] b;
      delete[] r;
      delete[] g;
      delete[] e;
    };
  class PError {};
  class FileIsNotFound:public PError {};
  class FileIsNotPh0Format:public PError {};
  void load (const string& fileName);
  const uchar* getR () const {return r;};
  const uchar* getG () const {return g;};
  const uchar* getB () const {return b;};
  const uchar* getE () const {return e;};
};

#endif PH0_H
