#ifndef Wrd_H
#define Wrd_H

#include "IO/MainIO.h"
#include "WrdFile.h"
#include "TextScreen.h"
#include "PH0.h"
#include "magfile.h"


//Wrd$B$r:F@8$9$k%/%i%9$N(Binterface$B$r5,Dj$9$kCj>]%/%i%9(B
class Wrd:public IO
{
public:
  static const int GRAPHIC_SIZE_X=640; //grahpic screen size
  static const int GRAPHIC_SIZE_Y=400;
  static const int CHAR_SIZE_X=8;//$B0lJ8;z$NBg$-$5(B(1byte$BJ8;z(B)=640/80
  static const int CHAR_SIZE_Y=16;//=400/25
  static const int MAX_TEXT_COLORS=8;   //text$B$N?'$N?t(B
  static const int MAX_GRAPHIC_DEPTH=4;//graphic $B$O(B16$B?'$G(Bdepth$B$O(B4
  static const int MAX_GRAPHIC_COLORS=16;
  
protected:
  //////////////////////////////////////////////
  Wrd (State* state__, WidiController* widiController__,
       Option* option__);
  virtual ~Wrd ();
  WrdFile* wrdFile;
  
  //mag file$B$r%m!<%I$9$k!#(B
  //MagFile$B$r(Bnew,load ()$B$7$FJV$9!#(B
  //$BLc$C$?B&$O(Bdelete$B$9$kI,MW$,$"$k!#(B
  //file$B$,8+$D$+$i$J$1$l$P(Bthrow MagFileIsNotfoud ()
  class MagFileIsNotFound {};
  MagFile* newLoadMag (const string& fileName_);
  //mag file$B$rI=<($9$k!#(B
  void loadMag (MagFile* mag, int32 x_, int32 y_, uint32 s, uint32 p);
  //$B1iAUA0$K(BsongFileName$B$+$i?dDj$7$F!"(Bmag file$B$,$"$l$P$=$l$rI=<($9$k!#(B
  void loadMag (const string& songFileName_);
  //PH0 file$B$r(Bload$B$9$k!#(B
  //PH0$B$r(Bnew,load$B$7$FJV$9!#Lc$C$?B&$O(Bdelete$B$9$kI,MW$,$"$k!#(B
  //file$B$,8+$D$+$i$J$1$l$P(Bthrow PH0FileIsNotFound
  class PH0FileIsNotFound {};
  PH0* newLoadPH0 (const string& fileName_);
  //ph0 file$B$rI=<($9$k!#(B
  void loadPH0 (PH0* ph0);
  //$B1iAUA0$K(BsongFileName$B$+$i?dDj$7$F(Bph0 file$B$,$"$l$P$=$l$rI=<($9$k!#(B
  void loadPH0FromSongFileName (const string& songFileName_);
  void newOpenWrdFile (const char* midiFileName);//wrd file$BFI$_9~$_!#(B
  void closeWrdFile ()//wrd$B$N:F@8$,=*N;8eGK4~$r$9$k!#(B
    {
      delete wrdFile;
      wrdFile=NULL;
    };


public:
  virtual void prePlay ();
  virtual void postPlay ();
  virtual void playLoop ();
  //for debug(playLoop$B$NBe$j$K8F$S=P$9$H!"BT$A;~4VL5$7$G<B9T$9$k!#(B)
  //isWaitKey$B$O<B9T$4$H$K(Bkey$BBT$A$r$9$k$+$I$&$+!#(B
  virtual void nonstopPlayLoop (bool isWaitKey);
  
protected:
  static const uint32 WRD_TICKS_PER_MEASURE=96;//$B0l>.@aEv$j$N(Bwrd ticks$B?t!#(B
  /////////////////////////////$B:F@8>uBV$r3P$($F$*$/0Y$NJ*!#(B
  WrdCommand* wrdCommand;//$B8=:_<B9TCf$N(Bcommand

  //$B<!$NBT$A;~4V$r7W;;!#(B
  void calculateNextWaitFor
  (uchar delatSteps_,uint mode_,
   uint32* const barWaitFor_,uint32* const stepsWaitFor_);
  
  //command$B<B9T!#(BbarWaitFor,stepsWaitFor$B$r=$@5$7$FJV$k!#(B
  void execute (WrdCommand*& wrdCommand_,
		bool& isInLyrics,const char*& lyrics,bool& isFading_,
		bool& isWaiting_);
  //$B2N;lI=<(Ey$G2~9T$,$"$C$?!#(B
  void nextLine () {textScreen.nextLine ();execNextLine ();};
  virtual void execNextLine ()=0;
  
  //@STARTUP (ver)
  uint32 version;//ver
  
  //@WMODE (n,mode)
  uchar deltaSteps;//n
  uint wmode;//mode

  //@WAIT (bar<,step>),@OFFSET (nnn),@REST (bar<,step>),@INKEY (bar)
  uint32 barWaitFor;//bar !!!NOTE!!!$B0l>.@aL\$+$i;O$^$k$3$H$KCm0U!#(B
  //step !!!NOTE!!!$B$3$l$O(Bwrd$B$N(Bticks$B$G$"$k$3$H$KCm0U!#(B
  //     $B$D$^$j(B1$B>.@aEv$j(B96ticks
  uint32 stepsWaitFor;
  uint32 offsetBarWaitFor;//nnn
  
  //cursor$B0LCV(B,@LOCATE (y;x)  //!!!NOTE!!! $B:8>e$,(B(1,1)$B$G$"$k;v$KCm0U!#(B
  //test$BI=<($N(Bmode,@TON
  //@COLOR
  TextScreen textScreen;
  
  //@GON
  bool isGraphicOn;
  //@GSCREEN (act,dsp)
  uint activePage;
  uint displayPage;

  //@PAL
  static const int MAX_PALETTE=20;//palette$B$N?t(B
  class RGB
  {
  private:
    //!!!NOTE!!! 0<= r,g,b <=16$B$G$"$k;v$KCm0U!#(B
    uchar r,g,b;
  public:
    RGB ():r (0),g (0),b (0) {};
    void set (uchar r_, uchar g_, uchar b_)
      {
	assert (r_ <= 16);
	assert (g_ <= 16);
	assert (b_ <= 16);
	r = r_;
	g = g_;
	b = b_;
      };
    void reverse () {r = 16-r; g = 16-g; b = 16-b;};
    void reset () {r = 0; g = 0; b = 0;};
    uchar getR () const {return r;};
    uchar getG () const {return g;};
    uchar getB () const {return b;};
  };
  class Palette
  {
  public:
    static const int MAX_RGB=16;
    RGB rgb[MAX_RGB];
    Palette () {};
    void set (int32 value[MAX_RGB])
      {//value[i]=0xrgb$B$G$"$k;v$KCm0U!#(B
	for (int i = 0; i < MAX_RGB; i++)
	  rgb[i].set (static_cast<uchar> ((value[i] >> 8) & 0xf),
		      static_cast<uchar> ((value[i] >> 4) & 0xf),
		      static_cast<uchar> ( value[i]       & 0xf));
      };
    void set (Palette& palette_)
      {
	for (int i = 0; i < MAX_RGB; i++)
	  rgb[i].set (palette_.rgb[i].getR (),
		      palette_.rgb[i].getG (),
		      palette_.rgb[i].getB ());
      };
    void reverse ()
      {
	for (int i = 0; i < MAX_RGB; i++)
	  rgb[i].reverse ();
      };
    void reset ()
      {
	for (int i = 0; i < MAX_RGB; i++)
	  rgb[i].reset ();
      };
  };
  Palette palette[MAX_PALETTE];//XXX$B=i4|2=$r$I$&$9$k(B?
  //#0 palette $B<B:]$KI=<($K;H$o$l$F$$$k(Bpalette
  //#1 - #16 $B<+M3$K;HMQ$G$-$k!#(B
  //#17 @MAG$B$N(Bfile$B$N(Bpalette$B>pJs$,3JG<$5$l$k!#(B
  //#18 active$B2hLL$,I=$N;~$N(B@MAG file$B$N(Bpalette
  //#18 active$B2hLL$,N"$N;~$N(B@MAG file$B$N(Bpalette
  
  
  //@FADE (p1,p2<,speed>)
  //XXX
  static const uint32 FADING_TICKS_PER_MEASURE=48*4;
  static const int MAX_FADING_COUNT=16;//fade$B$,2?2s$+$1$FJQ$k$+(B?
  void doFade ();//fade$B$N=hM}!#(B
  virtual void doFading (int fadeCount_, uint32 fromPalette_, uint32 toPalette_)=0;
  uint32 barFading;//fade$B$,;O$^$C$?;~$N(Bticks$B$r3P$($F$*$/!#(B
  uint32 stepsFading;
  uint32 ticksFading;
  int fadeCount;//fade$B$7;O$a$F$+$i2?2s%Q%l%C%H$rJQ99$7$?$+(B?
  //NOTE fadingSpeed$B$HF1$8J,2rG=$G$"$k$3$H$KCm0U!#(B
  bool isFading;
  uint32 fromPalette;//p1
  uint32 toPalette;//p2
  int32 fadingSpeed;//speed

  //@GMODE (sw)
  uchar gmode;//sw

  //@PATH
  string songParentDirectory;//$B6J%U%!%$%k$N$"$k(Bdirectory$B!#(B
  string path;
  //@LOOP
  int loopCount;

  //^TEXTDOT
  int32 textDot;

  //^TMODE
  int32 tmode;

  //^TSCRL
  int32 tscrLines;

  //^LINE
  int32 lineMode;

  //^GSC
  int32 gscMode;

  //^FONTM
  int32 fontMode;

  //^FONTR
  static const int WRD_USER_FONT_NUM=16;
  static const int WRD_USER_FONT_CHAR_NUM=32;
  uchar userfont[WRD_USER_FONT_NUM][WRD_USER_FONT_CHAR_NUM];
  //int32 userfont[WRD_USER_FONT_NUM][16];//???
  
  //^VSGET
  int32 virtualVramPageNum;//$B3NJ]$5$l$F$$$k(Bvirtual vram$B$N8D?t!#(B
  uchar** virtualVram;//$B3NJ]$5$l$?(Bvirtual vram

  static const int WRD_REGSAVE_SIZE_MAX=16;
  //^REGSAVE
  class Register
  {
  public:
    int size;
    int32 value[WRD_REGSAVE_SIZE_MAX];
    Register ():size (0){};
    void set (int32* value_,int size_)
      {
	assert (value_!=NULL);
	size=size_;
	for (int i=0;i<size;i++)
	  value[i]=value_[i];
      };
    void reset () {size=0;};
  };
  static const int WRD_REG_SIZE=10;
  Register reg[WRD_REG_SIZE];
  
  void resetVariables ();//$B3F<oJQ?t$r=i4|2=!#(B
  ///////$B<B:]$K<B9T$r$9$k%a%=%C%I(B
  virtual void execute (WrdCommand*& wrdCommand_);
  
  virtual void execATMARK (WrdCommand*& wrdCommand_);
  virtual void execATMARK ()=0;
  virtual void execCOLOR (WrdCommand*& wrdCommand_);
  virtual void execCOLOR (uint32 color_)=0;
  virtual void execEND (WrdCommand*& wrdCommand_);
  virtual void execEND ()=0;
  virtual void execESC (WrdCommand*& wrdCommand_);
  virtual void execEXEC (WrdCommand*& wrdCommand_);
  virtual void execEXEC (const char* filename)=0;
  //XXX
  virtual void execFADE (WrdCommand*& wrdCommand_);
  virtual void execFADE (uint32 p1,uint32 p2,int speed)=0;
  virtual void execGCIRCLE (WrdCommand*& wrdCommand_);
  virtual void execGCIRCLE (uint32 x,uint32 y,uint r,
			    uint32 p1,uint32 sw,uint32 p2)=0;
  virtual void execGCLS (WrdCommand*& wrdCommand_);
  virtual void execGCLS (uint32 sw)=0;
  virtual void execGINIT (WrdCommand*& wrdCommand_);
  virtual void execGINIT ()=0;
  virtual void execGLINE (WrdCommand*& wrdCommand_);
  virtual void execGLINE
  (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 p1,uint32 sw,uint32 p2)=0;
  virtual void execGMODE (WrdCommand*& wrdCommand_);
  virtual void execGMODE (uint32 sw)=0;
  virtual void execGMOVE (WrdCommand*& wrdCommand_);
  virtual void execGMOVE (uint32 x1,uint32 y1,uint32 x2,uint32 y2,
			  uint32 xd,uint32 yd,uint32 vs,uint32 vd,uint32 sw)=0;
  virtual void execGON (WrdCommand*& wrdCommand_);
  virtual void execGON (bool oldIsGraphicOn_, bool isGraphicOn_)=0;
  virtual void execGSCREEN (WrdCommand*& wrdCommand_);
  virtual void execGSCREEN (uint32 oldActivePage_, uint32 oldDisplayPage_, uint32 activePage_,uint32 displayPage_)=0;
  virtual void execINKEY (WrdCommand*& wrdCommand_);
  virtual void execINKEY (uint32 barWaitFor_)=0;
  virtual void execLOCATE (WrdCommand*& wrdCommand_);
  virtual void execLOCATE (uint32 x_,uint32 y_)=0;
  virtual void execLOOP (WrdCommand*& wrdCommand_);
  virtual void execLOOP (uint32 loop)=0;
  //XXX
  virtual void execMAG (WrdCommand*& wrdCommand_);
  virtual void execMAG
  (MagFile& mag, int32 x, int32 y, uint32 s, uint32 p)=0;
  virtual void execMIDI (WrdCommand*& wrdCommand_);  //XXX
  virtual void execOFFSET (WrdCommand*& wrdCommand_);
  virtual void execOFFSET (uint32 offsetBarWaitFor_)=0;
  virtual void execPAL (WrdCommand*& wrdCommand_);
  virtual void execPAL (uint32 page,int32 rgb[16])=0;
  virtual void execPALCHG (WrdCommand*& wrdCommand_);//XXX
  virtual void execPALREV (WrdCommand*& wrdCommand_);
  virtual void execPALREV (uint32 p)=0;
  virtual void execPATH (WrdCommand*& wrdCommand_);//XXX
  virtual void execPLOAD (WrdCommand*& wrdCommand_);
  virtual void execPLOAD (PH0* ph0)=0;
  virtual void execREM (WrdCommand*& wrdCommand_);
  virtual void execREMARK (WrdCommand*& wrdCommand_);
  virtual void execREMARK ()=0;
  virtual void execREST (WrdCommand*& wrdCommand_);
  virtual void execREST (uint32 barOffsetWaitFor,uint32 stepsWaitFor)=0;
  virtual void execSCREEN (WrdCommand*& wrdCommand_);//XXX ???
  virtual void execSCROLL (WrdCommand*& wrdCommand_);
  virtual void execSCROLL (uint32 x1,uint32 y1,uint32 x2,uint32 y2,
			   uint32 mode,uint32 color,uint32 chr)=0;
  virtual void execSTARTUP (WrdCommand*& wrdCommand_);
  virtual void execSTARTUP (uint32 versoin_)=0;
  virtual void execSTOP (WrdCommand*& wrdCommand_);
  virtual void execSTOP ()=0;
  virtual void execTCLS (WrdCommand*& wrdCommand_);
  virtual void execTCLS
  (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 color,uint32 chr)=0;
  virtual void execTON (WrdCommand*& wrdCommand_);
  virtual void execTON (uint32 textMode_)=0;
  virtual void execWAIT (WrdCommand*& wrdCommand_);
  virtual void execWAIT (uint32 barWaitFor_,uint32 steptsWaitFor_)=0;
  virtual void execWMODE (WrdCommand*& wrdCommand_);
  virtual void execWMODE (uint32 deltaSteps_,uint32 wmode_)=0;
  //ensyutukun mechanism     
  virtual void execFONTM (WrdCommand*& wrdCommand_);
  virtual void execFONTM (int32 fontMode_)=0;
  virtual void execFONTP (WrdCommand*& wrdCommand_);
  virtual void execFONTP (uint32 num,uint32 x_,uint32 y_,uint32 attribute)=0;
  virtual void execFONTR (WrdCommand*& wrdCommand_);
  virtual void execFONTR (int32 fontNumber,int32 fontData[16])=0;
  virtual void execGSC (WrdCommand*& wrdCommand_);
  virtual void execGSC (int32 mode)=0;
  virtual void execLINE (WrdCommand*& wrdCommand_);
  virtual void execLINE (int32 mode)=0;
  virtual void execPAL_ (WrdCommand*& wrdCommand_);
  virtual void execPAL_ (int32 paletteNumber,int32 rgb)=0;
  virtual void execREGSAVE (WrdCommand*& wrdCommand_);
  virtual void execREGSAVE (int32 num,int32 value[WRD_REGSAVE_SIZE_MAX])=0;
  virtual void execSCROLL_ (WrdCommand*& wrdCommand_);
  virtual void execSCROLL_ (int32 x_,int32 y_)=0;
  virtual void execTEXTDOT (WrdCommand*& wrdCommand_);
  virtual void execTEXTDOT (int32 textDot_)=0;
  virtual void execTMODE (WrdCommand*& wrdCommand_);
  virtual void execTMODE (int32 tmode_)=0;
  virtual void execTSCRL (WrdCommand*& wrdCommand_);
  virtual void execTSCRL (int32 lines)=0;
  virtual void execVCOPY (WrdCommand*& wrdCommand_);
  virtual void execVCOPY (int32 sx1,int32 sy1,int32 sx2,int32 sy2,
			  int32 tx,int32 ty,int32 ss,int32 ts,int32 mode)=0;
  virtual void execVSGET (WrdCommand*& wrdCommand_);
  virtual void execVSGET (int32 page[4])=0;//XXX 4$B$H=q$/$N$O7y$@$J$!!D(B
  virtual void execVSRES (WrdCommand*& wrdCommand_);
  virtual void execVSRES ()=0;
  virtual void execXCOPY (WrdCommand*& wrdCommand_);
  virtual void execXCOPY (int32 sx1,int32 sy1,int32 sx2,int32 sy2,
			  int32 tx,int32 ty,int32 ss,int32 ts,
			  int32 method,int32 opt[5])=0;

  //XXX
  virtual void execINVALID (WrdCommand*& wrdCommand_)
    {cerr << "Wrd::execINVALID called." << endl;};
  //wrdCommand$B$K$"$k(Blyrics$B$rI=<($9$k!#$b$7(B_|$BEy$,$"$C$FB3$-$,;D$k$J$i!"(B
  //lyrics$B$K$=$N@h$r@_Dj$7$FJV$k!#;D$j$,$J$1$l$P(Blyrics=NULL$B$K$9$k!#(B
  virtual void execLYRICS (WrdCommand*& wrdCommand_,
			   const char*& lyrics,uint wmode_)
    {lyrics=wrdCommand_->getStr ();execLYRICS (lyrics,wmode_);};
  //lyrics$B$rI=<($9$k!#<!$NI=<($9$k$H$3$m$^$G(Bptr$B$r0\F0$7$FJV$k!#(B
  //$B$=$N9T$rI=<($7=*$($?$i!"(Bptr=NULL$B$H$J$k!#(B
  virtual void execLYRICS (const char*& lyrics,uint wmode_);
  //$B$3$3$G<B:]$K(Blyrics$B$rI=<($9$k!#(B(ptr$B$+$i(Bsize byte$BI=<($9$k!#(B)
  virtual void printLYRICS (const char* ptr,int size);
  //$B$3$3$G<B:]$K(Blyrics$B$r0lJ8;zI=<($9$k!#(B(2byte code$B$H$+(Besc sequencer$B$b4^$a$F!#(B)
  //ptr$B$rI=<($7$?$"$H$KF0$+$7$FJV$9!#A4ItI=<($7=*$($?$i(B.
  //*ptr=='\n' or *ptr=='\p'$B$K$J$k!#(B
  virtual void printLYRICS1 (const char*& ptr);
  //$B<B:]$K$3$l$GI=<($9$k!#(B
  //iso 
  virtual void printChar (uint x_,uint y_,char c,int color_)=0;
  //euc 2byte
  virtual void printChar2b (uint x_,uint y_,char c1,char c2,int color_)=0;
  //$BBT$A;~4VEy$r9MN8$;$:$K(Blyrics$B$rI=<($9$k!#(B
  virtual void execStartupLYRICS (WrdCommand*& wrdCommand_,uint wmode_);
  virtual void execRETURN (WrdCommand*& wrdCommand_)
    {cerr << "Wrd::execRETURN called." << endl;};
  virtual void doEscapeSequence (const char*& ptr);
  virtual void doEscapeSequence ()=0;

  virtual void refreshTextScreen (TextScreen& textScreen_)
    {doRefreshTextScreen (textScreen_); textScreen_.refresh ();};
  virtual void doRefreshTextScreen (TextScreen& textScreen_)=0;
};
#endif // Wrd_H
