#ifndef GtkCallBackTemplate_H
#define  GtkCallBackTemplate_H


#define COMMA ,
//e.g.
//gtk_signal_connect (GTK_OBJECT (widget), "clicked",
//                    GTK_SIGNAL_FUNC (&gtkCallBack<MyClass COMMA &MyClass::callBackMethod>),
//		      static_cast<GtkObject*> (static_cast<gpointer> (this)));
//use COMMA because of `,' is interpreted by cpp

template<typename T, void (T::*realCallBackMethod) ()>
void gtkCallBack (GtkWidget*, gpointer me)
{
  (static_cast<T*> (me)->*realCallBackMethod) ();
};

//e.g.
//gtk_signal_connect_object (GTK_OBJECT (widget), "clicked",
//                           GTK_SIGNAL_FUNC (&gtkCallBack<MyClass COMMA &MyClass::callBackMethod>),
//		             static_cast<GtkObject*> static_cast<gpointer> ((this)));
template<typename T, void (T::*realCallBackMethod) ()>
void gtkObjectCallBack (gpointer me)
{
  (static_cast<T*> (me)->*realCallBackMethod) ();
};

#endif // GtkCallBackTemplate_H
