/*
    ConnectionImpl.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef Connection_H
#define Connection_H

class ConnectionImpl0
{
public:
  ConnectionImpl0* next;
  ConnectionImpl0 ():next (NULL) {/*do nothing*/;};
  virtual void call ()=0;
};

template <class E>
class ConnectionImpl1
{
public:
  ConnectionImpl1<E>* next;
  ConnectionImpl1 ():next (NULL) {/*do nothing*/};
  virtual void call (E e)=0;
};

template <class E,class F>
class ConnectionImpl2
{
public:
  ConnectionImpl2<E,F>* next;
  ConnectionImpl2 ():next (NULL) {/*do nothing*/};
  virtual void call (E e,F f)=0;
};


template <class E,class F,class G>
class ConnectionImpl3
{
public:
  ConnectionImpl3<E,F,G>* next;
  ConnectionImpl3 ():next (NULL) {/*do nothing*/};
  virtual void call (E e,F f,G g)=0;
};



template <class T>
class Connection0:public ConnectionImpl0
{
private:
  T* obj;
  void (T::*method) ();
public:
  Connection0 (T* obj_,void (T::*method_) ()):
    ConnectionImpl0 (),obj (obj_),method (method_){/*do nothing*/};
  virtual void call () {(obj->*method) ();};
};

template <class T,class E>
class Connection1:public ConnectionImpl1<E>
{
private:
  T* obj;
  void (T::*method) (E e);
public:
  Connection1 (T* obj_,void (T::*method_) (E e)):
    ConnectionImpl1<E> (),obj (obj_),method (method_){/*do nothing*/};
  virtual void call (E e) {(obj->*method) (e);};
};

template <class T,class E,class F>
class Connection2:public ConnectionImpl2<E,F>
{
private:
  T* obj;
  void (T::*method) (E e,F f);
public:
  Connection2 (T* obj_,void (T::*method_) (E e,F f)):
    ConnectionImpl2<E,F> (),obj (obj_),method (method_){/*do nothing*/};
  virtual void call (E e,F f) {(obj->*method) (e,f);};
};


template <class T,class E,class F,class G>
class Connection3:public ConnectionImpl3<E,F,G>
{
private:
  T* obj;
  void (T::*method) (E e,F f,G g);
public:
  Connection3 (T* obj_,void (T::*method_) (E e,F f,G g)):
    ConnectionImpl3<E,F,G> (),obj (obj_),method (method_){/*do nothing*/};
  virtual void call (E e,F f,G g) {(obj->*method) (e,f,g);};
};

#endif// Connection_H
