/*
    WdkTyeps.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include <cassert>

#include "WdkTypes.h"

using namespace std;

void WdkColor::allocNamed (Display* display,Colormap colormap,char* colorName)
{
  assert (colorName!=NULL);
  if (!XParseColor (display,colormap,colorName,&color) ||
      !XAllocColor (display,colormap,&color))
    {
      cerr << "Error:WdkColor:can not allocate color:color name="
	   << colorName << endl;
    };

}//XXX error check

void WdkColor::allocNamed2 (Display* display,Colormap colormap,char* colorName)
{
  assert (colorName!=NULL);
  XColor exact;
  if (!XAllocNamedColor (display,colormap,colorName,&color,&exact))
    throw CanNotAllocate();
}

void WdkColor::free (Display* display,Colormap colormap)
{
  XFreeColors (display,colormap,&color.pixel,1,0);
}




void WdkColor::allocMultiplied (WdkColor& color,double multi)
{
  //XXX
  //not implemented yet
}

void WdkColor::allocMiddle (WdkColor& lightColor,WdkColor& darkColor)
{
  //XXX
  //not implemented yet
}

EventState::EventState ():
  isExposed (false),crossing (EVENT_CROSSING_NONE)
{
  isButtonPressed[0]=false;
  isButtonPressed[1]=false;
  isButtonPressed[2]=false;
  isButtonPressed[3]=false;
  isButtonPressed[4]=false;

  isButtonReleased[0]=false;
  isButtonReleased[1]=false;
  isButtonReleased[2]=false;
  isButtonReleased[3]=false;
  isButtonReleased[4]=false;

  isClicked[0]=false;
  isClicked[1]=false;
  isClicked[2]=false;
  isClicked[3]=false;
  isClicked[4]=false;
}

void EventState::reset ()
{
  isExposed=false;
  crossing=EVENT_CROSSING_NONE;

  isButtonPressed[0]=false;
  isButtonPressed[1]=false;
  isButtonPressed[2]=false;
  isButtonPressed[3]=false;
  isButtonPressed[4]=false;

  isButtonReleased[0]=false;
  isButtonReleased[1]=false;
  isButtonReleased[2]=false;
  isButtonReleased[3]=false;
  isButtonReleased[4]=false;

  isClicked[0]=false;
  isClicked[1]=false;
  isClicked[2]=false;
  isClicked[3]=false;
  isClicked[4]=false;
}


WdkEvent::WdkEvent (WdkWindow* window_):
  window (window_),eventState ()
{
  //do nothing
}
