/*
    WdkTypes.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef WdkTypes_H
#define WdkTypes_H
#include <iostream>

#include <X11/Xlib.h>

#include "util/mytype.h"

#define LIGHTNESS_MULTI 1.3
#define DARKNESS_MULTI  0.7

class WdkColor
{
private:
  XColor color;
public:
  WdkColor (){/*do nothing*/};//default constructor
  WdkColor (Display* display,Colormap colormap,char* colorName)
    {allocNamed (display,colormap,colorName);};
  void allocNamed (Display* display,Colormap colormap,char* colorName);
  //allocNamed$B$HF1$8$@$,(Ballocate$B<:GT$9$k$HNc30$,%9%m!<$5$l$k!#(B
  class CanNotAllocate {};
  void allocNamed2 (Display* display,Colormap colormap,char* colorName);
  void free (Display* display,Colormap colormap);//XFreeColor

  void allocMultiplied (WdkColor& color,double multi);//XXX
  void allocMiddle (WdkColor& lightColor,WdkColor& darkColor);//XXX

  /////////////////////////////////////////access method
  ulong getPixel () const {return color.pixel;};
  XColor getColor () const {return color;};
};


///////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////event
///////////////////////////////////////////////////////////////////////////////

enum WdkEventCrossing
{
  EVENT_CROSSING_NONE,
  EVENT_CROSSING_ENTER,
  EVENT_CROSSING_LEAVE,
};

class WdkExposureEvent
{
public:
  Display* display;
  Window window;
  int x;
  int y;
  int width;
  int heigth;
};


class EventState
{
public:
  EventState ();
  void reset ();
  
  bool isExposed;
  //???
  //WdkExposureEvent* exposedEvent;
  //$B$3$l$G(B==NULL$B$+$I$&$+$GH=Dj$7$?J}$,NI$$$N$+$J$!!)(B
  WdkEventCrossing crossing;
  bool isButtonPressed[5];//5$B$O(Bmouse button$B$N?t!#(B
  bool isButtonReleased[5];//5$B$O(Bmouse button$B$N?t!#(B
  //XXX key$BF~NO$O$I$&$7$?$iNI$$$N$+(B?
  bool isClicked[5];//5$B$O(Bmouse button$B$N?t!#(B
};



class WdkWindow;

class WdkEvent
{
public:
  WdkWindow* window;
  EventState eventState;
  
  WdkEvent (WdkWindow* window_);
};

#endif// WdkTypes_H
