/*
    WtkEvent.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef WtkEvent_H
#define WtkEvent_H

#include "WtkWidget.h"

class WtkEvent
{
public:
  WtkWidget* widget;
  EventState eventState;

  WtkEvent (WtkWidget* widget_):
    widget (widget_),eventState ()
    {
      //do nothing
    };
  void buttonPressed (XEvent* event)
    {eventState.isButtonPressed[event->xbutton.button]=true;};
  void buttonReleased (XEvent* event)
    {
      if (eventState.isButtonPressed[event->xbutton.button])
	{
	  eventState.isButtonPressed[event->xbutton.button]=false;
	  eventState.isClicked[event->xbutton.button]=true;
	}
      else
	{
	  eventState.isButtonReleased[event->xbutton.button]=true;
	}
    };
  void enterNotify (XEvent* event)
    {eventState.crossing=EVENT_CROSSING_ENTER;};
  void leaveNotify (XEvent* event)
    {
      if (eventState.crossing==EVENT_CROSSING_ENTER)
	eventState.crossing=EVENT_CROSSING_NONE;
      else
	eventState.crossing=EVENT_CROSSING_LEAVE;
    };
  void keyPressed (XEvent* event){/*do nothing yet*/};
  void keyReleased (XEvent* event){/*do nothing yet*/};
  void exposed (XEvent* event){eventState.isExposed=true;};
  void updateEventState ()
    {
      widget->updateEventState (eventState);
      eventState.reset ();
    };
};
#endif// WtkEvent_H
