/*
    WtkLabel.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef WtkLabel_H
#define WtkLabel_H

#include "WtkWidget.h"

enum Justify
{
  JUSTIFY_RIGHT,
  JUSTIFY_CENTER,
  JUSTIFY_LEFT,
};

class WtkLabel:public WtkWidget
{
protected:
  static const char* const defaultResource;
  
  char* label;
  Justify justify;
  int labelX;
  int labelY;
  XRectangle logical;//XTextExtentslogicalʬФƤ
  void calculateLocate ();
  void overWrite ();
  
  void initialize ();//non virtual
  Justify getResouceJustify (char* resourceName,char* resouceClass);
  void getResource ();//resource manager non virtual
  char* getResource (char* resourceName,char* resouceClass)
    {return WtkWidget::getResource (resourceName,resouceClass);};
  void setResource (){};//resourceꡣ non virtual
public:
  //for create toplevel
  //get from resource manager if x<0,y<0,width==0,height==0
  //ignored if resourceFileName==NULL
  WtkLabel (Display* display,const char* className_,const char* name_,
	    int x_,int y_,uint width_,uint height_,
	    int depth,Visual* visual,Colormap colormap_,
	    char* resourceFileName);
  WtkLabel (Display* display,const char* className_,const char* name_,
	    int x_,int y_,uint width_,uint height_,
	    int depth,Visual* visual,Colormap colormap_,
	    XrmDatabase displayRdb_);
  //for create child of some widget
  //get from resource manager if x,y,width,height==0
  WtkLabel (WtkWidget* parent,const char* className_,const char* name_,
	    int x_,int y_,uint width_,uint height_);
  virtual ~WtkLabel ();

  virtual void setLabel (const char* toBeSet);//ɽʸꤹ롣
  //toBeSetnull-terminated
  virtual void setLabel (const int value);//valueοɽ롣
  virtual void setJustify (Justify justify_);//centeringꤹ롣
  //virtual void expose (WtkExposureEvent* exposureEvent);
  virtual void exposed (XEvent* event);//expose event롣
};
#endif // WtkLabel_H
