#include "WtkLockedRange.h"

WtkLockedRange::WtkLockedRange (Display* display,
				const char* className_, const char* name_, 
				int x_, int y_, uint width_, uint height_,
				int depth, Visual* visual, Colormap colormap_,
				char* resourceFileName):
  WtkRange (display, className_, name_, x_, y_, width_, height_,
	    depth, visual, colormap_, resourceFileName)
{
  //do nothing
}

WtkLockedRange::WtkLockedRange (Display* display,
				const char* className_, const char* name_,
				int x_, int y_, uint width_, uint height_,
				int depth, Visual* visual, Colormap colormap_,
				XrmDatabase displayRdb_):
  WtkRange (display, className_, name_, x_, y_, width_, height_,
	    depth, visual, colormap_, displayRdb_)
{
  //do nothing
}


WtkLockedRange::WtkLockedRange (WtkWidget* parent,
				const char* className_, const char* name_,
				int x_, int y_, uint width_, uint height_):
  WtkRange (parent, className_, name_, x_, y_, width_, height_)
{
  //do nothing
}

WtkLockedRange::~WtkLockedRange ()
{
  //do nothing
}


void WtkLockedRange::widgetButtonReleased (XEvent* event)
{
  if (isSliderDragged)
    scrolled (limit, calcPosition (event), scope);
  isSliderDragged = false;
}

void WtkLockedRange::widgetPointerMotion (XEvent* event)
{
  if (isSliderDragged)
    unlockedSetPosition (calcPosition (event), false);
}


