#ifndef WtkLockedRange_H
#define WtkLockedRange_H

#include "WtkRange.h"

//WtkRange$B$O(Bslider$BEy$N@_Dj$O$G$-$J$$!#(B(X event$B$K$h$C$F$N$_JQ2=$9$k!#(B)
//$B2?8N$J$i%G!<%?$N%m%C%/$r$7$F$$$J$$$?$a!#(B
//$B$=$N0Y$K%m%C%/$rDI2C$7$?%/%i%9(B
//$B%$%+%s!"LLE]$@$C$?$+$i(Bmonitor lock$B$KF($2$F$7$^$C$?!#(B
//$B$7$+$7(BWtkRange$B$N$^$^$G$O$A$c$s$H%m%C%/$9$k$N$OLLE]!#(B
//($B$A$c$s$H$9$k$J$i%$%A$+$iD>$5$J$$$HBLL\$+(B?)
class WtkLockedRange:public WtkRange
{
private:
  mutable Mutex monitorLock;
  class Monitor;
  friend WtkLockedRange::Monitor;
  class Monitor
  {
  private:
    const WtkLockedRange* wtkLockedRange;
  public:
    Monitor (const WtkLockedRange* me):wtkLockedRange (me)
      {wtkLockedRange->monitorLock.lock ();};
    ~Monitor () {wtkLockedRange->monitorLock.unlock ();};
  };
  
  virtual void widgetButtonReleased (XEvent* event);
  virtual void widgetPointerMotion (XEvent* event);
public:
  WtkLockedRange (Display* display, const char* className_, const char* name_, 
		  int x_, int y_, uint width_, uint height_,
		  int depth, Visual* visual, Colormap colormap_,
		  char* resourceFileName);
  WtkLockedRange (Display* display, const char* className_, const char* name_,
		  int x_, int y_, uint width_, uint height_,
		  int depth, Visual* visual, Colormap colormap_,
		  XrmDatabase displayRdb_);
  //for create child of some widget
  //get from resource manager if x,y,width,height==0
  WtkLockedRange (WtkWidget* parent, const char* className_, const char* name_,
		  int x_, int y_, uint width_, uint height_);
  virtual ~WtkLockedRange ();

  virtual void setLimit (double limit_, bool isNeedScrolled)
    {Monitor monitor (this);unlockedSetLimit (limit_, isNeedScrolled);};
  virtual void setScope (double scope_, bool isNeedScrolled)
    {Monitor monitor (this);unlockedSetScope (scope_, isNeedScrolled);};
  virtual void setPosition (double position_, bool isNeedScrolled)
    {Monitor monitor (this);unlockedSetPosition (position_, isNeedScrolled);};
  virtual void setLimit (double limit_) {setLimit (limit_, true);};
  virtual void setScope (double scope_) {setScope (scope_, true);};
  virtual void setPosition (double position_) {setPosition (position_);};
  virtual double getLimit () const
    {Monitor monitor (this);return WtkRange::getLimit ();};
  virtual double getScope () const
    {Monitor monitor (this);return WtkRange::getScope ();};
  virtual double getPosition () const
    {Monitor monitor (this);return WtkRange::getPosition ();};
  
  virtual void exposed (XEvent* event)
    {Monitor monitor (this);WtkRange::exposed (event);};
  virtual void buttonPressed (XEvent* event)
    {Monitor monitor (this);WtkRange::buttonPressed (event);};
  virtual void buttonReleased (XEvent* event)
    {Monitor monitor (this);WtkRange::buttonReleased (event);};
  virtual void pointerMotion (XEvent* event)
    {Monitor monitor (this);WtkRange::pointerMotion (event);};
  virtual void enterNotify (XEvent* event)
    {Monitor monitor (this);WtkRange::enterNotify (event);};
  virtual void leaveNotify (XEvent* event)
    {Monitor monitor (this);WtkRange::leaveNotify (event);};
};

#endif WtkLockedRange_H
