/*
    WtkMaxedLevel.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef WtkMaxedLevel_H
#define WtkMaxedLevel_H

#include "WtkWidget.h"

class WtkMaxedLevel:public WtkWidget
{
protected:
  double level;////0<= level_<=1
  double maxLevel;//0<= maxLevel_<=1
  // WtkLevel::level<=maxLevelǤ롣
  uint levelWidth;//ºݤΥ٥ͭϰ=width-style.verticalShadowWidth*2

  ///////////////////////////////
  static const char* const defaultResource;
  void initialize ();//non virtual
public:
  //for create toplevel
  //get from resource manager if x<0,y<0,width==0,height==0
  //ignored if resourceFileName==NULL
  WtkMaxedLevel (Display* display,const char* className_,const char* name_,
		 int x_,int y_,uint width_,uint height_,
		 int depth,Visual* visual,Colormap colormap_,
		 char* resourceFileName);
  WtkMaxedLevel (Display* display,const char* className_,const char* name_,
		 int x_,int y_,uint width_,uint height_,
		 int depth,Visual* visual,Colormap colormap_,
		 XrmDatabase displayRdb_);
  //for create child of some widget
  //get from resource manager if x,y,width,height==0
  WtkMaxedLevel (WtkWidget* parent,const char* className_,const char* name_,
		 int x_,int y_,uint width_,uint height_);
  virtual ~WtkMaxedLevel ();

  virtual void exposed (XEvent* event);//expose event롣
  virtual void setLevel (double level_,double maxLevel_);
};
#endif // WtkMaxedLevel_H
