/*
    WtkMessage.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef WtkMessage_H
#define WtkMessage_H

#include "WtkWidget.h"

class WtkMessage:public WtkWidget
{
protected:
  static const char* const defaultResource;
  static const int MAX_MESSAGE_NUMBER=128;
  static const int MAX_MESSAGE_LENGTH=512;
  char messageBuffer[MAX_MESSAGE_NUMBER][MAX_MESSAGE_LENGTH];
  XFontSetExtents* fontSetExtents;
  int maxLines;//$B2?9TIA$1$k$+(B?
  int readpos;//$B8=:_FI$_9~$s$G$$$k9T!#(B
  int leftLines;//readpos$B$+$i2?9TI=<($9$k$+!#(B
  int top;//$BJ8;z$r=q$-;O$a$k0LCV!#(B
  int charHeight;//$BJ8;z$N9b$5!#(B
    
  
  void initialize ();//non virtual
  void getResource ();//resource manager$B$+$i@_Dj$r<hF@(B non virtual
  char* getResource (char* resourceName,char* resouceClass)
    {return WtkWidget::getResource (resourceName,resouceClass);};
  void setResource (){};//resource$B$r@_Dj!#(B non virtual
public:
  //for create toplevel
  //get from resource manager if x<0,y<0,width==0,height==0
  //ignored if resourceFileName==NULL
  WtkMessage (Display* display,const char* className_,const char* name_,
            int x_,int y_,uint width_,uint height_,
            int depth,Visual* visual,Colormap colormap_,
            char* resourceFileName);
  WtkMessage (Display* display,const char* className_,const char* name_,
            int x_,int y_,uint width_,uint height_,
            int depth,Visual* visual,Colormap colormap_,
            XrmDatabase displayRdb_);
  //for create child of some widget
  //get from resource manager if x,y,width,height==0
  WtkMessage (WtkWidget* parent,const char* className_,const char* name_,
            int x_,int y_,uint width_,uint height_);
  virtual ~WtkMessage ();

  virtual void coutMessage (const char* message);//message$B$r=PNO$9$k!#(B
  virtual void exposed (XEvent* event);//expose event$B$r=hM}$9$k!#(B
};
#endif WtkMessage_H
