/*
    WtkStyle.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "WtkStyle.h"

WtkStyle::WtkStyle ():
  shadowType (SHADOW_UP),verticalShadowWidth (0),horizontalShadowWidth (0)
{
  //do nothing
}

WtkStyle::~WtkStyle ()
{
  //do nothing
}

void WtkStyle::setColormap (Display* display,Colormap colormap_)
{
  colormap=colormap_;
  white.allocNamed (display,colormap,"White");
  black.allocNamed (display,colormap,"Black");
}


void WtkStyle::allocColor (Display* display,ColorType type,char* colorName)
{
  WdkColor* color=NULL;
  switch (type)
    {
    case FOREGROUND:
      color=&fg;
      break;
    case BACKGROUND:
      color=&bg;
      break;
    case LIGHT:
      color=&light;
      break;
    case MID:
      color=&mid;
      break;
    case DARK:
      color=&dark;
      break;
    case TEXTCOLOR:
      color=&text;
      break;
    }
  color->allocNamed (display,colormap,colorName);
#if 0
  //XXX
  if (type==BACKGROUND)
    {
      light.allocMultiplied (color,LIGHTNESS_MULTI);
      dark.allocMultiplied (color,DARKNESS_MULTI);
      mid.allocMiddle (light,dark);
    }
#endif
}

Bool WtkStyle::createFontSet (Display* display,char* baseFontNameList)
{
  char** mclr;
  char* dsr;
  int mccr;
  fontSet=XCreateFontSet (display,baseFontNameList,&mclr,&mccr,&dsr);
  if (mclr!=NULL || mccr!=0 || dsr!=NULL)
    {
      if (mclr != NULL)
	XFreeStringList (mclr);
      return False;
    }
  else
    return True;
}

