/*
    WtkStyle.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef WtkStyle_H
#define WtkStyle_H

#include "WdkTypes.h"

enum Direction
{
  VERTICAL,
  HORIZONTAL,
  DIRECTION_UP,
  DIRECTION_DOWN,
  DIRECTION_RIGHT,
  DIRECTION_LEFT,
};

enum ColorType
{
  FOREGROUND,
  BACKGROUND,
  LIGHT,
  MID,
  DARK,
  TEXTCOLOR
};

enum ShadowType
{
  SHADOW_UP,
  SHADOW_FLAT,
  SHADOW_DOWN
};


class WtkStyle
{
private:
    Colormap colormap;

public:
  WtkStyle ();
  ~WtkStyle ();
  WdkColor white;
  WdkColor black;
  WdkColor fg;
  WdkColor bg;
  WdkColor light;
  WdkColor mid;
  WdkColor dark;
  WdkColor text;
  ShadowType shadowType;
  uint verticalShadowWidth;
  uint horizontalShadowWidth;

  //$B$3$l$i$O%G%3%l!<%7%g%s$NI}$r3P$($F$*$/!#(B($BOH$NI}(B)
  uint leftOffset;
  uint rightOffset;
  uint topOffset;
  uint bottomOffset;
  
  XFontSet fontSet;
  void setColormap (Display* display,Colormap colormap_);
  Colormap getColormap (){return colormap;};
  void allocColor (Display* display,ColorType type,char* name);
  Bool createFontSet (Display* display,char* baseFontNameList);
};
#endif // WtkStyle_H
