#include <cstdio>
#include <unistd.h>

#include "WtkEventHandler.h"
#include "WtkMeter.h"

main ()
{
  Display* display=XOpenDisplay (NULL);
  int screen=DefaultScreen (display);
  Colormap colormap=DefaultColormap (display,screen);
  int depth=DefaultDepth (display,screen);
  Visual* visual=DefaultVisual (display,screen);

  XrmInitialize ();
  WtkMeter meter (display,"Test","test",0,0,640,400,depth,visual,colormap,
		  "testWtkWidget.ad");
  meter.setMeter (0.0);
  meter.map ();

  WtkEventHandler eventHandler (display);
  eventHandler.addWidget (&meter);
  eventHandler.createEventLoopThread ();
  XFlush (display);

  XFlush (display);
  cerr << "event loop" << endl;

  //#define SAMPLE_NUMBER 1024
  //#define SAMPLE_NUMBER 512
  //#define SAMPLE_NUMBER 256
#define SAMPLE_NUMBER 128
  for (int i=-SAMPLE_NUMBER;i<SAMPLE_NUMBER;i++)
    {
      usleep (1);
      meter.setMeter (i/static_cast<double>(SAMPLE_NUMBER));
      XFlush (display);
    }

#if 0
  for (int i=-SAMPLE_NUMBER;i<SAMPLE_NUMBER;i++)
    {
      usleep (1);
      meter.setMeter (-i/static_cast<double>(SAMPLE_NUMBER));
      XFlush (display);
    }
#endif
#undef SAMPLE_NUMBER
  meter.setMeter (1.0);
  XFlush (display);
  getchar ();
}
