#include <cstdio>
#include <unistd.h>

#include "WtkEventHandler.h"
#include "WtkRange.h"
#include "WtkLabel.h"
#include "WtkViewPort.h"

class Oops
{
public:
  WtkLabel* label;
  WtkViewPort* viewPort;
  Oops (WtkLabel* label_,WtkViewPort* viewPort_):
    label (label_),viewPort (viewPort_)
    {/*do nothing*/};
  ~Oops (){/*do nothging*/};
  
  void update (double /*limit*/,double position,double /*scope*/)
    {
      label->setLabel ((int) position);
    };
  void scrollX (double /*limit*/,double position,double /*scope*/)
    {
      //cerr << "Oops::scrollX" << endl;
      viewPort->scrollX ((int) position);
    }
  void scrollY (double /*limit*/,double position,double /*scope*/)
    {
      //cerr << "Oops::scrollY" << endl;
      viewPort->scrollY ((int) position);
    }

};

main ()
{
  Display* display=XOpenDisplay (NULL);
  int screen=DefaultScreen (display);
  Colormap colormap=DefaultColormap (display,screen);
  int depth=DefaultDepth (display,screen);
  Visual* visual=DefaultVisual (display,screen);

  XrmInitialize ();
  WtkWidget widget (display,"Test","test",0,0,640,400,depth,visual,colormap,
		    "testWtkWidget.ad");
  const int height=30;
  const int width=50;

  const uint viewPortWidth=3000;
  const uint viewPortHeight=3000;
  WtkViewPort viewPort (&widget,"ViewPort","viewPort",
			10,100,400,250,viewPortWidth,viewPortHeight);

  
  WtkRange hrange  (&widget,"Range","hrange",100,50,200,height);
  hrange.setLimit (viewPort.getVirtualWidth ());
  hrange.setScope (viewPort.getWidth ());
  WtkLabel hmin (&widget,"Min","hmin",10,50,width,height);
  hmin.setLabel (0);
  WtkLabel hmax (&widget,"Max","hmax",310,50,width,height);
  hmax.setLabel ((int) hrange.getLimit ());
  WtkLabel hposition (&widget,"Position","hposition",20,0,width,height);
  hposition.setLabel ((int) hrange.getPosition ());
  Oops hoops (&hposition,&viewPort);
  hrange.scrolled.connect (&hoops,&Oops::update);
  hrange.scrolled.connect (&hoops,&Oops::scrollX);
  
  const uint vwidth=30;
  WtkRange vrange  (&widget,"Range","vrange",450,100,vwidth,200);
  vrange.setLimit (viewPort.getVirtualHeight ());
  vrange.setScope (viewPort.getHeight ());
  WtkLabel vmin (&widget,"Min","vmin",450,50,vwidth,height);
  vmin.setLabel (0);
  WtkLabel vmax (&widget,"Max","vmax",450,300,vwidth,height);
  vmax.setLabel ((int) vrange.getLimit ());
  WtkLabel vposition (&widget,"Position","vposition",480,200,50,height);
  vposition.setLabel ((int) vrange.getPosition ());
  Oops voops (&vposition,&viewPort);
  vrange.scrolled.connect (&voops,&Oops::update);
  vrange.scrolled.connect (&voops,&Oops::scrollY);
  
  WtkEventHandler eventHandler (display);

  const uint labelWidth=80;
  const uint labelHeight=80;
  for (int x=0;(uint) x<viewPortWidth;x+=100)
    {
      for (int y=0;(uint) y<viewPortHeight;y+=100)
	{
	  WtkLabel* label=new WtkLabel (&viewPort,"Label","label",x,y,
					labelWidth,labelHeight);
	  char buff[100];
	  sprintf (buff,"(%d,%d)",x,y);
	  label->setLabel (buff);
	  label->map ();
	  eventHandler.addWidget (label);
	}
    }

  
  viewPort.map ();

  hposition.map ();
  hmax.map ();
  hmin.map ();
  hrange.map ();
  vposition.map ();
  vmax.map ();
  vmin.map ();
  vrange.map ();
  widget.map ();
  //widget.rmPutFileDatabase ("result.ad");
  
  eventHandler.addWidget (&widget);
  eventHandler.addWidget (&hmin);
  eventHandler.addWidget (&hmax);
  eventHandler.addWidget (&hposition);
  hrange.registerEventHandler (&eventHandler);
  eventHandler.addWidget (&vmin);
  eventHandler.addWidget (&vmax);
  eventHandler.addWidget (&vposition);
  vrange.registerEventHandler (&eventHandler);
  viewPort.registerEventHandler (&eventHandler);

  
  eventHandler.createEventLoopThread ();
  XFlush (display);
  

  for (;;)
    {
      sleep (10);
    }
  eventHandler.cancelEventLoopThread ();

  getchar ();
}
