#include <cstdio>
#include <unistd.h>

#include "WtkLabel.h"
#include "WtkViewPort.h"

main ()
{
  Display* display=XOpenDisplay (NULL);
  int screen=DefaultScreen (display);
  Colormap colormap=DefaultColormap (display,screen);
  int depth=DefaultDepth (display,screen);
  Visual* visual=DefaultVisual (display,screen);

  XrmInitialize ();
  WtkViewPort viewPort (display,"Test","test",0,0,640,400,1000,1000,
			depth,visual,colormap,
			"testWtkWidget.ad");
  WtkEventHandler eventHandler (display);
  viewPort.registerEventHandler (&eventHandler);

  const uint width=80;
  const uint height=80;
  for (int x=0;x<1000;x+=100)
    {
      for (int y=0;y<1000;y+=100)
	{
	  WtkLabel* label=new WtkLabel (&viewPort,"Label","label",x,y,width,height);
	  char buff[100];
	  sprintf (buff,"label(%d,%d)",x,y);
	  label->setLabel (buff);
	  label->map ();
	  eventHandler.addWidget (label);
	}
    }
  
  eventHandler.createEventLoopThread ();
  viewPort.map ();
  XFlush (display);
  cerr << "event loop" << endl;

  for (;;)
    {
      sleep (5);
    }

  getchar ();
}
