/*
    XBase.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include <X11/Xlib.h>
#include <X11/Xlocale.h>
#include <X11/Xresource.h>

#include <iostream>

#include <stdlib.h>

#include "XBase.h"

using namespace std;

pthread_once_t XBase::xinitthreads = PTHREAD_ONCE_INIT;

void XBase::XInitThreads ()
{
  if (!::XInitThreads ())
    {
      //XXX error$B=hM}(B
      cerr << "libX11 is not thread-safe." << endl;
      exit (1);
    }
  setlocale (LC_ALL, "");//XXX$BK\Ev$O(Bmain()$BFb$G$9$k$Y$-(B?
  if (!XSupportsLocale ())
    {
      cerr << "Warning:XBase::XInitThreads:locale " << getenv ("LANG")
	   << " is not supported by Xlib"  << endl;
    }
  XrmInitialize ();
}

XBase::XBase ():
  display (NULL), screenNumber (0)
{
  pthread_once (&xinitthreads, XInitThreads);
}

XBase::XBase (Display* display_):
  display (display_)
{
  pthread_once (&xinitthreads, XInitThreads);
  screenNumber = DefaultScreen (display);//???
}

XBase::XBase (Display* display_, int screenNumber_):
  display (display_), screenNumber (screenNumber_)
{
  pthread_once (&xinitthreads, XInitThreads);
}


XBase::~XBase ()
{
  //do nothing
}
