/*
    XBase.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef IOXBase_H
#define IOXBase_H

#include <pthread.h>
#include <cassert>

#include <X11/Xlib.h>

using namespace std;

class XBase
{
private:
  static pthread_once_t xinitthreads;
  static void XInitThreads ();
protected:
  Display* display;
  int screenNumber;
  
public:
  XBase ();
  XBase (Display* display_);
  XBase (Display* display_, int screenNumber_);
  virtual ~XBase ();
  void XFlush ()
    {
      assert (display!=NULL);
      ::XFlush (display);
    };
  void XSync (Bool discard)
    {
      assert (display!=NULL);
      ::XSync (display,discard);
    };
};
#endif IOXBase_H
