#ifndef IOXSherry_H
#define IOXSherry_H

#include <X11/Xlib.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>

#include "PlugIn/Sherry/SherryWrd.h"
#include "PlugIn/X/XBase/XBase.h"
#include "PlugIn/X/WidiToolkit/WdkWindow.h"
#include "PlugIn/X/WidiToolkit/WdkPixmap.h"


class IOXSherry:public SherryWrd,public XBase
{
private:
  //resource
  static const char* const defaultResource =
  "Widi*XSherry*Fontset: "
  "-adobe-courier-medium-r-normal--16-110-100-0-m-*-iso8859-*,"
  "-jis-fixed-medium-r-normal--16-110-100-100-*-*-jisx0208.1983-*,"
  "-misc-fixed-medium-r-normal--16-110-100-*-*-*-jisx0201.1976-*\n";
  static const char* const resourceFileName = WIDI_DATA_DIR"/WidiXSherry.ad";
  static const char* const className = "Widi.XSherry";
  static const char* const resourceName = "widi.xsherry";
  XrmDatabase displayRdb;
  XrmDatabase privateRdb;
  void allocateXResource ();
  void releaseXResource ();
  
  int depth;//XбƤ뿧ο
  Visual* visual;
  int visualClass;
  bool isPrivateColormapAllocated;
  Colormap colormap;
  unsigned long basePixel;//base pixel
  unsigned long planePixel[MAX_PLANES];//plane pixel
  //paletteбpixelͤФƤ
  unsigned long palette2Pixel[MAX_COLORS];
  XFontSet fontSet;
  //GC,ȤäclipMaskꤵƤʤ褦ˤƤȡ
  //ʳʪϲäƤ뤫ʤΤǤꤷƤȤȡ
  //äplaneMask
  WdkGC* gc;
  WdkGC* defaultGC;//defaultͤgc(̤ι˻)
  WdkWindow* window;
  WdkPixmap* realScreen;
  WdkPixmap* virtualScreen[MAX_VIRTUAL_SCREENS];
  unsigned long whitePixel;
  unsigned long blackPixel;
    
public:
  IOXSherry (State* state__, WidiController* widiController__,
	     Option* option__);
  ~IOXSherry ();

  virtual void initialize ();
  virtual void release ();
  virtual void prePlay ();
  virtual void postPlay ();

  bool isPrivateColormapUsed () const {return isPrivateColormapAllocated;};
protected:
  //ºݤž̿¹Ԥ롣
  //NOTE allocatecommandˤդ뤳ȡ
  //(Ūˤ,transfer̿,delete̿Ȥʤ뤳Ȥͭ롣)
  virtual void realTransferScreen (uint16 screen,
				   uint16 fromLeft, uint16 fromTop,
				   uint16 toLeft, uint16 toTop,
				   uint16 width, uint16 height);
  //žºݤɽƤʪup date롣
  virtual void updatePalette ();
  virtual void updateScreen ();
  //ºݤvirtual screenݤ롣ϰϤˤݾڤ롣
  virtual void doNewScreen (const SherryParameter::ScreenParameter* screens,
			    int arraySize);
  //ºݤvirtual screen롣ϰϤˤݾڤ롣
  virtual void doDeleteScreen (const uint16* screens, int arraySize);
  virtual void doNewScreenAndLoadPng (uint16 screen, uint16 palett,
				      const PNG* png);
  //ºݤʸ褹롣
  //ݾڤ롣
  virtual void doDrawText (uint16 screen,
			   uint8 planeMask, uint8 mode,
			   uint8 foreground, uint8 background,
			   uint16 left, uint16 top,
			   const char* eucStr, int eucLength);
  //ºݤ˥ܥå
  //Ȥݾڤ롣
  virtual void doDrawBox (uint16 screen, uint8 planeMask,
			  uint16 x1, uint16 y1,
			  uint16 x2, uint16 y2,
			  uint8 foreground);
  //ºݤʬ
  //Ȥݾڤ롣
  virtual void doDrawLine (uint16 screen, uint8 planeMask,
			   uint16 x1, uint16 y1,
			   uint16 x2, uint16 y2,
			   uint8 foreground);
  //ºݤ˥ԡԤ
  //Ȥݾڤ롣
  virtual void doCopyArea (uint16 fromScreen, uint16 toScreen,
			   uint8 planeMask, uint8 transparencyFlag,
			   uint16 x1, uint16 y1,
			   uint16 x2, uint16 y2,
			   uint16 toX, uint16 toY);
  //ºݤ˥ԡԤ
  //Ȥݾڤ롣
  virtual void doMaskCopy (uint16 fromScreen, uint16 toScreen,
			   uint8 planeMask, uint8 transparencyFlag,
			   uint16 x1, uint16 y1,
			   uint16 x2, uint16 y2,
			   uint16 toX, uint16 toY,
			   uint8 maskX, uint8 maskY,
			   const uint8* maskData, int arraySize);
  //ºݤ˥ԡԤ
  //Ȥݾڤ롣
  virtual void doPlaneCopy (uint16 fromScreen, uint16 toScreen,
			    uint8 planeMask, uint8 transparencyFlag,
			    uint8 fromPlane, uint8 toPlane,
			    uint8 planeNumber,
			    uint16 x1, uint16 y1,
			    uint16 x2, uint16 y2,
			    uint16 toX, uint16 toY);

  //////////////////////////////////////////////////////Ūʥ᥽å
  void setGC (WdkGC* gc__, uint8 planeMask, uint8 foreground)
    {
      assert (gc__ != NULL);
      gc__->setForeground (palette2Pixel[foreground]);
      setPlaneMask (gc__, planeMask);
    };

  void setPlaneMask (WdkGC* gc__, uint8 planeMask)
    {
      assert (gc__ != NULL);

      if (planeMask == 0xff)
	{//planeMask11111111ʤplane maskɬפ̵
	  //ZPixmapʤplane maskν򤷤ʤʤ(?)ΤǤ᤯ʤ뤫?
	  //gc__->setPlaneMask (~0UL);
	  gc__->setPlaneMask (0xffffffff);
	}
      else
	{
	  //XǤplane mask롣
	  //unsigned long xPlaneMask = 0;
	  unsigned long xPlaneMask = basePixel;
	  for (int i = 0; i < MAX_PLANES; i++)
	    {
	      if (planeMask & (1 << i))
		xPlaneMask |= planePixel[i];
	    }
	  gc__->setPlaneMask (xPlaneMask);
	}
    }

  ////////////////////////////////////////////////////////////event handling
  pthread_t eventHandleThread;
  void createEventHandleThread ();
  void cancelEventHandleThread ();
  bool isEventHandleThreadCreated;

  //ºݤevent handler
  void handleEvent ();
  static void* startEventHandleThread (void* me);

  //XA_ATOMȤ˰̣Ϥʤ(ȥʤ鲿Ǥɤ)
  //see XClientMessageEvent
  static const Atom XSHERRY_EVENT_HANDLER_LOOP_END_ATOM = XA_ATOM;
  static const int CLIENT_MESSAGE_LENGTH = 20;
  static const char XSHERRY_EVENT_HANDLER_LOOP_CANCEL_MESSAGE[CLIENT_MESSAGE_LENGTH] = "XShryEntHdlThrdCncl";
};
#endif // IOXSherry_H
