#ifndef SherryArea_H
#define SherryArea_H

#include <algorithm>
#include <functional>

using namespace std;

class SherryArea
{
private:
  const int left;
  const int top;
  const uint width;
  const uint height;
public:
  //(x1, y1)-(x2, y2)$B$GI=$5$l$kNN0h$r(B(left, top, width, height)$B$GI=8=$7D>$9!#(B
  SherryArea (uint16 x1, uint16 y1, uint16 x2, uint16 y2):
    left (min (x1, x2)),
    top (min (y1, y2)),
    width (max (x1, x2)-min (x1, x2)+1),
    height (max (y1, y2)-min (y1, y2)+1)
    {};
  ~SherryArea () {};
  
  int getLeft () const {return left;};
  int getTop () const {return top;};
  uint getWidth () const {return width;};
  uint getHeight () const {return height;};
};
#endif // SherryArea_H
