/*
    WtkContainerKeyboard.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef WtkContainerKeyboard_H
#define WtkContainerKeyboard_H

#include "Widi/State.h"
#include "WidiToolkit/WtkEventHandler.h"
#include "WtkKeyboard.h"

class WtkContainerKeyboard:public WtkWidget
{
protected:
  static const char* const defaultResource;
  //resource$B$NL>A0$NHV9f$O(B(port*MIDI::MAX_CHANNEL+channel+1)$B$r$D$1$k(B
  WtkKeyboard* keyboard[MIDI::MAX_PORT][MIDI::MAX_CHANNEL];
  
  void initialize ();//non virtual
  char* getResource (char* resourceName,char* resouceClass)
    {return WtkWidget::getResource (resourceName,resouceClass);};
  void getResource (){};//resource manager$B$+$i@_Dj$r<hF@(B non virtual
  void setResource (){};//resource$B$r@_Dj!#(B non virtual
public:
  //for create toplevel
  //get from resource manager if x<0,y<0,width==0,height==0
  //ignored if resourceFileName==NULL
  WtkContainerKeyboard (Display* display,const char* className_,const char* name_,
			int x_,int y_,uint width_,uint height_,
			int depth,Visual* visual,Colormap colormap_,
			char* resourceFileName);
  WtkContainerKeyboard (Display* display,const char* className_,const char* name_,
			int x_,int y_,uint width_,uint height_,
			int depth,Visual* visual,Colormap colormap_,
			XrmDatabase displayRdb_);
  //for create child of some widget
  //get from resource manager if x,y,width,height==0
  WtkContainerKeyboard (WtkWidget* parent,const char* className_,const char* name_,
			int x_,int y_,uint width_,uint height_);
  virtual ~WtkContainerKeyboard ();

  virtual void map ();
  virtual void unmap ();
  //XXX
  virtual void update (const State& nowState);//$B$3$l$GFbIt$N>uBV$r99?7$9$k!#(B
  virtual void exposed (XEvent* /*event*/){decorate ();};//expose event$B$r=hM}$9$k!#(B
  //event handler$B$K(Bwidget$B$rEPO?$9$k!#(B
  virtual void registerEventHandler (WtkEventHandler* eventHandler);

  virtual void printResource () const;
};
#endif// WtkContainerKeyboard_H
