/*
    WtkLCD.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef WtkLCD_H
#define WtkLCD_H

#include "IO/ioutil/LevelInfo.h"
#include "IO/ioutil/LCDInfo.h"
#include "WidiToolkit/WtkWidget.h"
#include "WidiToolkit/WdkPixmap.h"

class WtkLCD:public WtkWidget
{
protected:
  static const char* const defaultResource;
  LevelInfo levelInfo[MIDI::MAX_PORT][MIDI::MAX_CHANNEL];
  LCDInfo lcdInfo;
  LCDInfo oldLCDInfo;
  void resetInfo ();
  struct Position
  {
    int x;
    int y;
  };
  Position lcdPosition[LCDInfo::LCD_LINES][LCDInfo::LCD_COLS];//lcd$B$N0LCV(B
  Position letterPosition[MIDI::MAX_CHANNEL];//letter$B$N0LCV(B
  
  
  //lcd$B$NBg$-$5$HNY$H$N5wN%$rDj$a$k!#(B
  uint lcdWidth;
  uint lcdHeight;
  uint lcdHorizontalDistance;
  uint lcdVerticalDistance;
  //ascii$B$N%I%C%H$NBg$-$5$HNY$H$N5wN%$rDj$a$k!#(B
  uint letterWidth;
  uint letterHeight;
  //lcd$B$N(Boff$B$K$J$C$??'(B
  WdkColor lcdOffColor;
  //on$B$K$J$C$??'$O(Bforegournd
  //lcd$B$N(Bback$B$N?'$O(Bbackground$B$G$"$k!#(B
  WdkPixmap* pixmap;//background$B$KD%$k(Bpixmap
#define LCD_LETTERS 96 //0x20 - 0x7F (0x7F-0x20=128-32=96)
  WdkPixmap* letters[LCD_LETTERS];//$BJ8;z(B
#define MAX_DISPLAYABLE_LETTERS 16
  char nowLetters[MAX_DISPLAYABLE_LETTERS+1];
  static const char defaultLetters[MAX_DISPLAYABLE_LETTERS+1];
  void displayLetter ();//lcd letter$B$rI=<((B
  
  void initialize ();//$B=i4|2=(B
  void getResource ();//resource manager$B$+$i@_Dj$r<hF@(B non virtual
  char* getResource (char* resourceName,char* resouceClass)
    {return WtkWidget::getResource (resourceName,resouceClass);};
  void setResource ();//resource$B$r@_Dj!#(B non virtual
public:
  //for create toplevel
  //get from resource manager if x<0,y<0,width==0,height==0
  //ignored if resourceFileName==NULL
  WtkLCD (Display* display,const char* className_,const char* name_,
	  int x_,int y_,uint width_,uint height_,
	  int depth,Visual* visual,Colormap colormap_,
	  char* resourceFileName);
  WtkLCD (Display* display,const char* className_,const char* name_,
	  int x_,int y_,uint width_,uint height_,
	  int depth,Visual* visual,Colormap colormap_,
	  XrmDatabase displayRdb_);
  //for create child of some widget
  //get from resource manager if x,y,width,height==0
  WtkLCD (WtkWidget* parent,const char* className_,const char* name_,
	  int x_,int y_,uint width_,uint height_);
  virtual ~WtkLCD ();

  virtual void update (State& nowState);
  virtual void exposed (XEvent* event);//expose event$B$r=hM}$9$k!#(B
  virtual void reset (){resetInfo ();window->clearArea (0,0,0,0,True);};
};
#endif// WtkLCD_H
