#include <iostream>

#include "createFontSet.h"

using namespace std;

XFontSet createFontSet (Display* display, const char* fontName)
{
  char** mclr = NULL;
  int mccr = 0;
  char* dsr = NULL;
  XFontSet fontSet = XCreateFontSet (display, fontName, &mclr, &mccr, &dsr);
  if (mclr != NULL || mccr != 0)
    {
#ifdef DEBUG
      cerr << "createFontSet "
	   << "XCreateFontSet returns missing char set list." << endl;
      cerr << "fontName = " << fontName << endl;
      if (mclr != NULL)
	{
	  cerr << "mclr != NULL:";
	  for (int i = 0; i < mccr; i++)
	    cerr << mclr[i] << endl;
	}
      cerr << "mccr = " << mccr << endl;
      if (dsr != NULL)
	cerr << "dsr != NULL:dsr = " << dsr << endl;
#endif
      if (mclr != NULL)
	XFreeStringList (mclr);
      //XXX$B$b$C$H$^$7$J%(%i!<=hM}$,$"$kH&!#(B
      //throw IError ("IOXWrd::setupResource can not load fontset.");
      exit (1);
    }

  return fontSet;
}
