#include "getResource.h"

char* getResource (XrmDatabase privateRdb, XrmDatabase displayRdb,
		   const string& className_, const string& classResource_,
		   const string& name_, const string& resourceName_)
{
  const string fullClassName = className_ + "." + classResource_;
  const string fullName = name_ + "." + resourceName_;
  char* retType;
  XrmValue retValue;
  int result = (displayRdb !=NULL &&
		XrmGetResource (displayRdb,
				fullClassName.c_str (), fullName.c_str (),
				&retType, &retValue));
  if (!result)
    result = XrmGetResource (privateRdb,
			     fullClassName.c_str (), fullName.c_str (),
			     &retType, &retValue);
  if (!result)
    return NULL;
  return retValue.addr;
}

