#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <cstdio>
#include <sys/ioctl.h>
#include <iostream>

#include "SequencerALSA.h"
#include "Widi/SongManager.h"
#include "Widi/ServerCommand.h"

#include "Song/SMF/SMF.h"
#include "Song/recomposer/RCP.h"

int main (int argc,const char** argv)
{
  if (argc<=1)
    {
      exit (1);
    }
  State state;
  SongCommand songCommand;
  SongManager songManager;
  ServerCommand serverCommand;
  WidiController widiController (&serverCommand, &songManager);

  Option option;
  option.isQuickStart = true;
  option.isRealTime = true;
  MainIO* mainio = new MainIO (&state, &widiController, &option);

  pthread_t thread;
  mainio->createMainLoopThread (&thread, NULL);

  Sequencer* sequencer = new SequencerALSA (&state, &option);
  sequencer->sync ();
  sequencer->startTimer ();
  for (int i = 1; i < argc; i++)
    {
      Song* song = new SMF(argv[i], &state, &songCommand, *mainio, &option);
      //Song* song=new RCP(argv[i],&state,*mainio);
      cerr << "reading done." << endl;
#if 0
      pthread_t playThread;
      song->createPlayThread (&playThread,NULL,*sequencer);
      cerr << "now joining playing thread" << endl;
      pthread_join (playThread, NULL);
#else
      song->play (*sequencer);
#endif
    }

  pthread_join (thread, NULL);
  delete sequencer;

  cout << "all done" << endl;
  exit (0);
}





