#include "MIDI.h"

const uint MIDI::NOTE_OFF;
const uint MIDI::NOTE_ON;
const uint MIDI::KEY_PRESSURE;
const uint MIDI::CONTROL_CHANGE;
const uint MIDI::PROGRAM_CHANGE;
const uint MIDI::CHANNEL_PRESSURE;
const uint MIDI::PITCH_BEND;
const uint MIDI::SYS_EXLUSIVE;

const uchar MIDI::UNIVERSAL_REALTIME;
const uchar MIDI::UNIVERSAL_NONREALTIME;
const uchar MIDI::ROLAND_ID;
const uchar MIDI::DT1;
const uchar MIDI::YAMAHA_ID;
const uchar MIDI::EOX;


const uchar MIDI::GM_SYSTEM_ON_DATA[] = {0xF0, 0x7E, 0x7F, 0x09, 0x01, 0x7F};
const int MIDI::GM_SYSTEM_ON_LENGTH = sizeof (MIDI::GM_SYSTEM_ON_DATA);

const uchar MIDI::GS_RESET_DATA[] = {0xF0, 0x41, 0x10, 0x42, 0x12, 0x40, 0x00, 0x7F, 0x00, 0x41, 0xF8};
const int MIDI::GS_RESET_LENGTH = sizeof (MIDI::GS_RESET_DATA);


const uchar MIDI::SYSTEM_MODE_SET_DATA[] = {0xF0, 0x41, 0x10, 0x42, 0x12, 0x00, 0x00, 0x7F, 0x00, 0x01, 0xF7};
const int MIDI::SYSTEM_MODE_SET_LENGTH = sizeof (MIDI::SYSTEM_MODE_SET_DATA);

const uchar MIDI::XG_SYSTEM_ON_DATA[] = {0xF0, 0x43, 0x10, 0x4C, 0x00, 0x00, 0x7E, 0x00, 0xF7};
const int MIDI::XG_SYSTEM_ON_LENGTH = sizeof (MIDI::XG_SYSTEM_ON_DATA);

const int MIDI::MAX_CHANNEL;
const MIDI::PORT MIDI::PORT_A;
const MIDI::PORT MIDI::PORT_B;
const int MIDI::MAX_PORT;
const int MIDI::MAX_PARTS;
