/*
    Sequcner.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef Sequencer_H
#define Sequencer_H

#include <cassert>

#include "util/DlHandler.h"
#include "Widi/Option.h"
#include "Widi/State.h"

using namespace std;

///dev/sequencer򰷤٤ݥ饹
//OSSˤϰ¸ʤ(¸ʬSequencerOSSʬΥ)
class Sequencer
{
protected:
  static const int block2Part[32];//blockֹ -> partֹ
  static const int block2Port[32];//blockֹ -> portֹ
  static const int block2Channel[32];//blockֹ -> channel
  

  Option* option;
  State* state;
  State cacheState;

  ulong machineTicks;//ߤtick

  //(port, channel)äɬפʤݡȤڤؤԤ
  //⤷ϰϳʤ(port, channel)äfalse֤
  //(port, chennel)ʤtrue֤
  virtual bool checkPortChannel (MIDI::PORT port, uchar channel) = 0;
  
  //for debug
  void dumpEvent (const uchar* udata, uint32 size);

  //SequencerStatusmuteξ֤Partmuteξ֤ȿǤ롣
  //void traceMute (SequencerStatus::MIDI_PORT port__, uchar channel__)
  void traceMute (MIDI::PORT port__, uchar channel__)
    {
      for (int port = 0; port < MIDI::MAX_PORT; port++)
	{
	  for (int channel = 0; channel < MIDI::MAX_CHANNEL; channel++)
	    {
	      if (cacheState.part[port][channel].isRecieve (port__, channel__))
		cacheState.part[port][channel].isMuted =
		  cacheState.sequencerStatus.isMuted[port__][channel__];
	    }
	}
    };

  //channelvelocityȯ(note on)뤫ɤ
  //muteseekingΰ
  bool isPronounce (int port, uchar channel, uchar velocity)
    {//velocity == 0λnote off
#if 0
      return ((isSeeking () == false && 
	       cacheState.sequencerStatus.isMuted[cacheState.sequencerStatus.port][channel] == false) ||
	      velocity == 0);
#else
      return ((isSeeking () == false && 
	       cacheState.sequencerStatus.isMuted[port][channel] == false) ||
	      velocity == 0);
#endif
    };
public:
  //DlHandlernew,opendlHandler_ˤơ
  //sequencernew֤
  //⤷饤֥꡼Ĥʤäꤷ顢
  // *dlHandler_ = NULL,SequencerOSSMIDI(libSequencerNULL)new֤
  //ƤӽФ¦delete dlHandler,delete sequencer򤹤ɬפ롣
  //factory method
  static Sequencer* newSequencer (DlHandler** dlHandler_, const string& name,
				  State* state_, Option* option_);
  

  Sequencer (State* globalState, Option* midiOption);//constructor
  virtual ~Sequencer ();//destructor
  
  //bufferdump롣
  virtual void dumpBuf () = 0;
  //globalStateupdate롣ϥåʤΤǸƤӽФ¦
  //åƤɬפ롣
  virtual void updateStatus ()
    {
      state->updatePartStatus (cacheState.part);
      state->updateSequencerStatus (cacheState.sequencerStatus);
      cacheState.songStatus = state->songStatus;
    };
  //cashƤpart[MAX_TRACK]롣
  virtual void resetPartData ();

  //ɤμͥmute뤫ꤹ롣
  class Muting
  {
  public:
    MIDI::PORT port;
    int channel;
    bool isMute;//==false mute,==true mute롣
    void copy (const Muting& src)
      {
	port = src.port;
	channel = src.channel;
	isMute = src.isMute;
      };
    static void copy (Muting* dest, const Muting* src, int size)
      {
	for (int i = 0; i < size; i++)
	  dest[i].copy (src[i]);
      };
    static Muting* newCopy (const Muting* src, int size)
      {
	Muting* ret = new Muting[size];
	copy (ret, src, size);
	return ret;
      };
  };
  //subclassǤϡˤꡢnoteOnǤȯ򤷤ʤͤˤ
  void setMute (const Muting* muting, int size)
    {
      assert (muting != NULL);
      for (int i = 0; i < size; i++)
	{
	  assert (muting[i].port < MIDI::MAX_PORT);
	  assert (muting[i].channel < MIDI::MAX_CHANNEL);
	  cacheState.sequencerStatus.isMuted[muting[i].port][muting[i].channel]=muting[i].isMute;
	  traceMute (muting[i].port, muting[i].channel);
	}
    };
  
  //muteξ֤toggle롣äơMuting[i].isMutefield̵뤵롣
  void toggleMute (const Muting* muting, int size)
    {
      assert (muting != NULL);
      for (int i = 0; i < size; i++)
	{
	  assert (muting[i].port < MIDI::MAX_PORT);
	  assert (muting[i].channel < MIDI::MAX_CHANNEL);
	  cacheState.sequencerStatus.isMuted[muting[i].port][muting[i].channel]
	    = !cacheState.sequencerStatus.isMuted[muting[i].port][muting[i].channel];
	  traceMute (muting[i].port, muting[i].channel);
	}
    };

  //devicereset롣
  virtual void reset () {traceReset ();};
  virtual void allNoteOffSoundOff () = 0;

  //isRPN == true RPN
  //channelФ
  //RPN rpnMSB,rpnLSBꤷơ
  //0xB0|channel 0x65 rpnMSB    (RPN MSB)
  //0xB0|channel 0x64 rpnLSB    (RPN LSB)
  //0xB0|channel cc1  cc1Value
  //(cc1 = 0x06(dataEntry) or 0x60(incriment) or 0x61(decriment)Ǥ롣)
  //0xB0|channel cc2  cc2Value
  //(dataEntryλΤ(cc1 == 0x06λΤ),cc2 = 0x26, increment,decriment
  //Ϥͤϰ̣ʤ)
  //롣
  //isRPN == false NRPN
  //0x63,0x62Ȥ
  //0xB0|channel 0x63 nrpnMSB    (NRPN MSB)
  //0xB0|channel 0x62 nrpnLSB    (NRPN LSB)
  void changeRPN_NRPN (bool isRPN,
		       int port, uchar channel, uchar msb, uchar lsb,
		       uchar cc1, uchar cc1Value, uchar cc2, uchar cc2Value);

  //
  //midi event¹Ԥ롣
  //
  //note off
  //0x8n note velocity
  virtual void noteOff (int port, uchar channel, uchar note, uchar velocity) = 0;
  
  //note on
  //0x9n note velocity(velocity= = 0λnote off)
  //!!!NOTE!!! Part.isMuted == trueλȯʤȡ
  virtual void noteOn (int port, uchar channel, uchar note, uchar velocity) = 0;
  
  //polyphonic key pressure
  //0xAn note pressure
  virtual void polyphonicKeyPressure (int port, uchar channel,
				      uchar note,
				      uchar keyPressure) = 0;
  
  //control change & mode messate
  //0xBn control value
  virtual void controlChange (int port, uchar channel,
			      uchar control, uchar value) = 0;
  
  //program change
  //0xCn program
  virtual void programChange (int port, uchar channel, uchar  program) = 0;
  
  //channel pressure
  //0xDn pressure
  virtual void channelPressure (int port, uchar channel,
				uchar channelPressure) = 0;
  
  //pitch bend change
  //0xEn LSB MSB
  virtual void pitchBendChange (int port, uchar channel,
				uchar lsb, uchar msb) = 0;
  
  //SysEx Event
  //0xF0 ...
  virtual void exclusive (const uchar* udata, uint32 size,
			  int port =-1, int channel=-1) = 0;

  //???
  //Port pp=0 : Ρ 1 : MPU 2 : RS-232C 3 : MPU+RS-232C
  // pp=0 SMPU APort ˽ PP=1 SMPU BPort ˽
  virtual void portChange (int port) = 0;
  
  //
  //timerϢ
  //
  virtual int getCtrlRate () throw (Error) = 0;
  virtual void waitTimer (ulong ticks) = 0;
  virtual void deltaTimer (ulong ticks) = 0;
  virtual void startTimer (){traceStartTimer ();};//ϥޡ0ˤ롣
  //virtual void startTimer () = 0;
  virtual void stopTimer () = 0;
  //virtual void stopTimer () = 0;
  //virtual void continueTimer () = 0;
  //virtual void continueTimer () = 0;
  //virtual void timeBase (int timeBase) = 0;
#if 0
  virtual void setTempo (ulong tempo) = 0;
  virtual void songPosition (ulong position) = 0;
  virtual void timeSignature (ulong signature) = 0;
#endif
  //sync
  virtual void sync () = 0;

  //seek
  //seekingȯʤȡ
private:
  bool isSeeking_;
public:
  bool isSeeking () const {return isSeeking_;};
  void enterSeeking () {assert (isSeeking_ == false); isSeeking_ = true;};
  void leaveSeeking () {assert (isSeeking_ == true); isSeeking_ = false;};
  

  //satusι
  //sequencerξ֤פ˻Ȥ᥽å
protected:
  void traceDumpBuf ()
    {
      for (int port = 0; port < MIDI::MAX_PORT; port++)
	{
	  for (int channel = 0; channel < MIDI::MAX_CHANNEL; channel++)
	    {
	      if (cacheState.part[port][channel].maxVelocity > 0)
		cacheState.part[port][channel].lastMaxVelocity =
		  cacheState.part[port][channel].maxVelocity;
	      cacheState.part[port][channel].maxVelocity = 0;
	    }
	}
    };
  
  void traceReset ()
    {
      resetPartData ();
      cacheState.sequencerStatus.reset ();
      state->lock ();
      updateStatus ();
      state->broadcast ();
      state->unlock ();
      startTimer ();
    };
  
  void traceNoteOff (int port, uchar channel, uchar note, uchar velocity);
  void traceNoteOff (Part& part, uchar note);
  void traceNoteOn (int port, uchar channel, uchar note, uchar velocity);
  void traceNoteOn (Part& part, uchar note, uchar velocity);
  void tracePolyphonicKeyPressure (int port, uchar channel,
				   uchar note, uchar keyPressure);
  void tracePolyphonicKeyPressure (Part& part, uchar note, uchar keyPressure);
  void traceControlChange (int port, uchar channel,
			   uchar control, uchar value);
  void traceControlChange (Part& part, uchar control, uchar value);
  void traceDataEntry (bool isMSB, Part& part, uchar value);
  void traceProgramChange (int port, uchar channel, uchar  program);
  void traceProgramChange (Part& part, uchar program);
  void traceChannelPressure (int port, uchar channel, uchar pressure);
  void traceChannelPressure (Part& part, uchar channelPressure);
  void tracePitchBendChange (int port, uchar channel, uchar lsb, uchar msb);
  void tracePitchBendChange (Part& part, uchar LSB, uchar MSB);
  void traceExclusive (const uchar* udata, uint32 size,
		       int port = -1, int channel = -1);
  
  //exclusive
  void traceUniversalRealtimeExclusive (const uchar* udata, uint32 size);
  void traceUniversalNonrealtimeExclusive (const uchar* udata, uint32 size);
  void traceRolandExclusive (const uchar* udata, uint32 size);
     void traceRolandDisplayData (const uchar* udata, uint32 size);
        void traceRolandDisplayedLetter (const uchar* udata, uint32 size);
        void traceRolandDisplayedDotData (const uchar* udata, uint32 size);
        void traceRolandDisplayPage (const uchar* udata, uint32 size);
     void traceRolandSystemParameter (const uchar* udata, uint32 size);
  void traceYamahaExclusive (const uchar* udata, uint32 size);

  virtual void traceAllSoundOff (Part& part);
  virtual void traceResetAllController (Part& part);

  //port=0 port_a
  //port=1 port_b
  virtual void tracePortChange (int port);

  virtual void traceWaitTimer (ulong waitForMachineTicks)
    {machineTicks = waitForMachineTicks;};
  virtual void traceDeltaTimer (ulong waitForMachineTicks)
    {machineTicks += waitForMachineTicks;};
  virtual void traceStartTimer (){machineTicks = 0;};
  virtual void traceStopTimer () {/*do nothing yet now*/};
  
public:
  //exceptional class
  class SequencerError {};
  class CanNotOpenSequencerDevice:public SequencerError{};
};
#endif// Sequencer_H
