/*
    SequcnerImple.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef SequencerImple_H
#define SequencerImple_H

#include "Sequencer.h"

//sequencer򰷤٤Υ饹
//ʬimplement롣
class SequencerImple:public Sequencer
{
protected:

public:
  SequencerImple (State* globalState, Option* midiOption);//constructor
  virtual ~SequencerImple ();//destructor

  virtual void allNoteOffSoundOff ();
  
  //
  //midi event¹Ԥ롣
  //
  //note off
  //0x8n note velocity
  virtual void noteOff (int port, uchar channel, uchar note, uchar velocity);
  
  //note on
  //0x9n note velocity(velocity= = 0λnote off)
  //!!!NOTE!!! Part.isMuted == trueλȯʤȡ
  virtual void noteOn (int port, uchar channel, uchar note, uchar velocity);
  
  //polyphonic key pressure
  //0xAn note pressure
  virtual void polyphonicKeyPressure (int port, uchar channel,
				      uchar note,
				      uchar keyPressure);
  
  //control change & mode messate
  //0xBn control value
  virtual void controlChange (int port, uchar channel,
			      uchar control, uchar value);
  
  //program change
  //0xCn program
  virtual void programChange (int port, uchar channel, uchar  program);
  
  //channel pressure
  //0xDn pressure
  virtual void channelPressure (int port, uchar channel,
				uchar channelPressure);
  
  //pitch bend change
  //0xEn LSB MSB
  virtual void pitchBendChange (int port, uchar channel,
				uchar lsb, uchar msb);
  
  //SysEx Event
  //0xF0 ...
  virtual void exclusive (const uchar* udata, uint32 size,
			  int port =-1, int channel=-1);

protected:
  //ºݤ˥٥Ȥroutine
  virtual void doNoteOff (int port, uchar channel,
			  uchar note, uchar velocity) = 0;
  virtual void doNoteOn (int port, uchar channel,
			 uchar note, uchar velocity) = 0;
  virtual void doPolyphonicKeyPressure (int port, uchar channel,
					uchar note,
					uchar keyPressure) = 0;
  virtual void doControlChange (int port, uchar channel,
				uchar control, uchar value) = 0;
  virtual void doProgramChange (int port, uchar channel, uchar  program) = 0;

  virtual void doChannelPressure (int port, uchar channel,
				  uchar channelPressure) = 0;
  virtual void doPitchBendChange (int port, uchar channel,
				  uchar lsb, uchar msb) = 0;
  virtual void doExclusive (const uchar* udata, uint32 size,
			    int port =-1, int channel=-1) = 0;
};
#endif// SequencerImple_H
