/*
    SequencerStatus.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */



#include <cstring>

#include "SequencerStatus.h"

using namespace std;

//const SequencerStatus::MIDI_PORT SequencerStatus::PORT_A;
//const SequencerStatus::MIDI_PORT SequencerStatus::PORT_B;
//const int SequencerStatus::MAX_MIDI_PORT;

const SequencerStatus::DeviceMode SequencerStatus::DEVICE_UNKNOWN;
// data for GS
const SequencerStatus::DeviceMode SequencerStatus::DEVICE_GS_ON;
// data for GM
const SequencerStatus::DeviceMode SequencerStatus::DEVICE_GM_ON;
// data for SC-88
const SequencerStatus::DeviceMode SequencerStatus::DEVICE_SC88_ON;
// data for SC-88Pro
const SequencerStatus::DeviceMode SequencerStatus::DEVICE_SC88PRO_ON;
// data for XG
const SequencerStatus::DeviceMode SequencerStatus::DEVICE_XG_ON;

const int SequencerStatus::MAX_LETTERS;
const int SequencerStatus::PAGE_NUM;
const int SequencerStatus::DOT_SIZE;
const uint32 SequencerStatus::MAX_MASTER_VOLUME;
const char SequencerStatus::MAX_MASTER_PAN;
const char SequencerStatus::CENTER_MASTER_PAN;



SequencerStatus::SequencerStatus ()
{
  reset ();
}


void SequencerStatus::reset ()
{
  port = MIDI::PORT_A;
  deviceMode = DEVICE_UNKNOWN;
  for (int port = 0; port < MIDI::MAX_PORT; port++)
    {
      for (int channel = 0; channel < MIDI::MAX_CHANNEL; channel++)
	isMuted[port][channel] = false;
    }
  
  
  memset(displayedLetter, 0, sizeof (displayedLetter));
  letterTicks = 0;
  letterMachineTicks = 0;
  memset (dotData, 0, sizeof (dotData));
  dotTicks = 0;
  dotMachineTicks = 0;
  masterVolume = MAX_MASTER_VOLUME;
  masterPan = CENTER_MASTER_PAN;
  changedPage = -1;
  displayPage = 0;
  displayTime = 0x06;
  pageTicks = 0;
  pageMachineTicks = 0;
}
