#ifndef SerialDevice_H
#define SerialDevice_H

#include <termios.h>

#include <string>

#include "util/mytype.h"

using namespace std;

class SerialDevice
{
public:
  static const char* const DEFAULT_SERIAL_DEVICE;
  static const int DEFAULT_BPS;
  
private:
  static const speed_t B31250 = B50;
  int serialfd;
  void open (const string& device, int bps);
  
public:
  //bps$B$O(B35400,31250$B$N$_(Bsupport
  SerialDevice ();
  SerialDevice (const string& device);
  SerialDevice (const string& device, int bps);
  ~SerialDevice ();
  
  void write (const uchar* data, ssize_t length);
  
  //exeptional classes
  class Error {};
  class BogusBPS:public Error {};
  class CanNotOpenDevice:public Error {};
  class CanNotGetDeviceAttribute:public Error {};
  class CanNotSetDeviceAttribute:public Error {};
};

#endif // SerialDevice_H
