/*
    SMF.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef SMF_H
#define SMF_H


#include "IO/MainIO.h"
#include "Song/Song.h"

#include "SMFTrack.h"
#include "SMFInputStream.h"
#include "SMFBufferStream.h"


class SMF:public Song
{
protected:
  int32 length;//headerĹ(̾=6)
  SMFTrack** smfTrack;//줬ƥȥåФƤ
  
public:
  //constructors
  //for playing
  SMF (State* state_, SongCommand* songCommand_,
       MainIO& userIO, Option* option_);
  SMF (const string& fileName, State* state_, SongCommand* songCommand_,
       MainIO& userIO, Option* option_);
  SMF (SongInputStream& songInputStream, State* state_,
       SongCommand* songCommand_, MainIO& userIO, Option* option_);

#if 0
  //for convert
  SMF (const string& fileName, State* state_, SongCommand* songCommand_,
       MainIOConvert2Dumb& userIO, Option* option_,
       DumbEventList& dumbEventList_);
#endif
  
  //destructor
  virtual ~SMF ();
  //ΥեˤбƤ뤫?
  static bool isSupported (const string& fileName);
  
protected://methd for load buffer
  //loadBuffer,ºݤ˥ǡɤ߹ࡣ
  virtual void doLoadBuffer (const char* buffer, int bufferSize);//throw (Error)
  //֤侮Ȥ롣
  virtual void preSearch ();
  //SMFheaderɤ߹ࡣ
  virtual void readHeader (SMFBufferStream& smfBufferStream) throw (Error);
  
private:
  //play method
  void doPlay (Sequencer& sequencer);//ºݤˤǱդ롣
  //ʲdoPlay
  //event롣
  void doMidiEvent (Sequencer& sequencer, SMFTrack* track, uchar tmpCommand);
  //meta event롣
  //ɤmeta eventȽꤹ롣
  void doMetaEvent (int playTrack,
		    uint32& oldTempo, uint32& setTempoTicks,
		    Sequencer& sequencer);
  //ʲ줾meta event
  void sequencerNumber (int playTrack);
  void text (int playTrack);
  void channelPrefix (int playTrack);
  void endOfTrack (int playTrack);
  void setTempo (int playTrack);
  void smpteOffset (int playTrack);
  void timeSignature (int playTrack);
  void keySignature (int playTrack);
  void sequencerSpecific (int playTrack);
  void portChange (int playTrack, Sequencer& sequencer);
  
  //////////////////////////////////////////////////////////for play control
  //հ֤ǽ˴᤹(ϱհ֤֤ޤǰư롣)
  virtual void realRewind ();
};

#endif // SMF_H
