/*
    SMF.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "util/KanjiConvert.h"
#include "SMF.h"

using namespace std;

//礷򤷤ƤǤ̵ΤĹ
void SMF::preSearch ()
{
  //հ֤ǽ˰֤롣
  realRewind ();
  cacheSongStatus->reset ();

  //DEBUG_MESSAGE ("DEBUG:SMF::doPlay");
  uint32 lastTicks = 0;//waitTimeȤtick
  
  double logicalTicks = 0;//߱դƤlogical ticks
  double dLogicalTicks = 0;//׻ѡ

  cacheSongStatus->lastMeasureTicks = 0;//νäticks
  cacheSongStatus->lastMeasureLogicalTicks = 0;//νälogicalTicks
  cacheSongStatus->ticksFromLastMeasure = 0;//ticks
  uint32 setTempoTicks = 0;//set tempoȤλַ׻ѡ
  uint32 oldTempo = cacheSongStatus->getTempo ();//set tempoȤλַ׻ѡ
  uint16 nEndOfTracks = 0;//դνλȥå
  int playTrack = 0;//ܤƤȥå

  cacheSongStatus->events = 0;//midi eventο
 
  /////////ºݤα
  while (nEndOfTracks<cacheSongStatus->getNTracks ())
    {
      /////ɤΥȥåǽ˱դ뤫Ƚꡣ
      for (int i = 0; i < cacheSongStatus->getNTracks (); i++)
	{
	  if (smfTrack[i]->getABSTicks () <
	      smfTrack[playTrack]->getABSTicks () &&
	      !smfTrack[i]->isEnd ())
	    playTrack = i;
	}

      //Ԥȯbufferdump롣
      //Ԥַ׻MIDI ticksmachine ticks׻
      dLogicalTicks = 0;
      const uint32 playTicks = smfTrack[playTrack]->getABSTicks ();
      if (lastTicks<playTicks)
	{
	  dLogicalTicks =
	    calcDLogicalTicks (playTicks, lastTicks, setTempoTicks,
			       cacheSongStatus->getTempo (), oldTempo,
			       cacheSongStatus->getDivision ());

	  //쾮դticks=division*4*nn/ddʤΤǡ
	  const int measureAdd=//ʤ
	    (playTicks-cacheSongStatus->lastMeasureTicks)*
	    cacheSongStatus->getDd ()/(uint)cacheSongStatus->getDivision()/
	    cacheSongStatus->getNn ()/4;
	  if (measureAdd>0)
	    {
	      cacheSongStatus->lastMeasureTicks += measureAdd*
		cacheSongStatus->getDivision ()*cacheSongStatus->getNn ()*4/
		cacheSongStatus->getDd ();
	      cacheSongStatus->lastMeasureLogicalTicks = logicalTicks;
	      cacheSongStatus->measures += measureAdd;
	    }
	  cacheSongStatus->ticksFromLastMeasure =
	    playTicks-cacheSongStatus->lastMeasureTicks;
      
	  if (static_cast<ulong> (logicalTicks+dLogicalTicks)-static_cast<ulong>(logicalTicks)>0)
	    {
	      cacheSongStatus->lastTicks = lastTicks;
	      cacheSongStatus->ticks = playTicks;
	      cacheSongStatus->logicalTicks = logicalTicks;
	      logicalTicks += dLogicalTicks;
  
	      lastTicks = playTicks;
	      setTempoTicks = playTicks;
	      oldTempo = cacheSongStatus->getTempo ();
	    }
	}
      
      //eventϤ롣(ɬפʤΰʳ̵롣)
      SMFTrack* track = smfTrack[playTrack];
      uchar tmpCommand = track->peekUChar ();
      if ((tmpCommand&0xF0) != 0xF0)
	{//normal MIDI Event
	  assert ((tmpCommand&0xF0)!=0xF0);
	  if ((tmpCommand&0x80)!=0)
	    {//midi eventä
	      //running statusФƤ
	      track->setRunningStatus (tmpCommand);
	      switch (tmpCommand&0xF0)
		{
		case 0x80://falling through
		case 0x90://falling through
		case 0xA0://falling through
		case 0xB0://falling through
		case 0xE0:
		  track->seekgCur (3);
		  break;
		case 0xC0://falling through
		case 0xD0:
		  track->seekgCur (2);
		  break;
		default:
		  DEBUG_MESSAGE ("DEBUG:SMF::doEvent There's Error!!!!!!!!!");
		  break;
		}
	    }
	  else
	    {//running statusä
	      if (!track->isSetRunningStatus ())
		{
		  cerr << "unkown event type event=" << hex << track->get8 () << dec
		       << endl;
		}
	      else
		{
		  char data = track->getRunningStatus ();//running status
		  switch (data & 0xF0)
		    {
		    case 0x80://falling through
		    case 0x90://falling through
		    case 0xA0://falling through
		    case 0xB0://falling through
		    case 0xE0:
		      track->seekgCur (2);
		      break;
		    case 0xC0://falling through
		    case 0xD0:
		      track->seekgCur (1);
		      break;
		    default:
		      DEBUG_MESSAGE ("DEBUG:SMF::doEvent Running Status "
				     "There's Error!!!!!!!!!!!!");
		      break;
		    }
		}
	    }
	}
      else
	{//sys exclusive
	  track->seekgCur (1);
	  if (tmpCommand == 0xF0 || tmpCommand == 0xF7)
	    {//SysEx Event
	      track->offRunningStatus ();
	      uint32 length = track->getVariableLength ();
	      track->seekgCur (length);
	    }
	  else if (tmpCommand == 0xFF)
	    {//Meta Event
	      switch (track->peekChar ())
		{
		case 0x2F:
		  endOfTrack (playTrack);
		  nEndOfTracks++;
		  break;
		case 0x51:
		  oldTempo=cacheSongStatus->getTempo ();
		  setTempoTicks=smfTrack[playTrack]->getABSTicks ();
		  setTempo (playTrack);
		  break;
		  //SMPTE Offset
		case 0x54:
		  smpteOffset (playTrack);
		  break;
		  //Time Signature
		case 0x58:
		  timeSignature (playTrack);
		  break;
		  
		case 0x03://Sequencer/Track Name
		  {
		    track->seekgCur (1);//skip meta event type
		    const uint32 length=track->getVariableLength ();
		    if (cacheSongStatus->isTitleSet () == false)
		      {
			char* title = new char[length+1];
			track->read (title, length);
			title[length] = '\0';
			char* eucTitle = new char[length*2+1];
			convertSjis2Euc (title, eucTitle);
			delete[] title;
			cacheSongStatus->setTitle (eucTitle);
			delete[] eucTitle;
		      }
		    else
		      track->seekgCur (length);
		    break;
		  }

		case 0x00://falling through
		case 0x01://falling through
		case 0x02://falling through
		case 0x04://falling through
		case 0x05://falling through
		case 0x06://falling through
		case 0x07://falling through
		case 0x20://falling through
		case 0x21://falling through
		case 0x59://falling through
		case 0x7F:
		  {
		    track->seekgCur (1);//skip meta event type
		    const uint32 length=track->getVariableLength ();
		    track->seekgCur (length);
		    break;
		  }
		default:
		  DEBUG_MESSAGE ("SMF::preSearch metaevent CRASH!!!");
		  break;
		}//Meta Event
	    }
	  else
	    {
	      DEBUG_MESSAGE ("DEBUG:SMF::doPlay:crash!!!!!!!!!!!!!!!");
	      cerr << "track=" << playTrack 
		   << " tmpCommand=" << hex << (int) tmpCommand << dec << endl;
	    }
	}

      cacheSongStatus->events++;
      ///////////////////////////////////tick׻
      if (smfTrack[playTrack]->isEnd ())
	smfTrack[playTrack]->setEnd ();
      else
	smfTrack[playTrack]->getABSDeltaTicks ();
    }

  

  //᤿ʪФƤ
  cacheSongStatus->totalTicks = cacheSongStatus->ticks;
  cacheSongStatus->totalLogicalTicks =
    static_cast<uint32> (cacheSongStatus->logicalTicks);
  cacheSongStatus->totalMeasures = cacheSongStatus->measures;
  cacheSongStatus->totalEvents = cacheSongStatus->events;

  realRewind ();
  cacheSongStatus->reset ();
}


