#include <string>

#include "SongFactory.h"

using namespace std;

SongFactory SongFactory::songFactory;
Mutex SongFactory::lock;

SongFactory::SongFactory ()
{
  //do nothing
}

SongFactory::~SongFactory ()
{
  for (list<DlHandler*>::iterator i = dlHandlerList.begin ();
       i != dlHandlerList.end ();
       i++)
    delete *i;
}


void SongFactory::__addSongModule (const string& songModuleName,
				   Option* option__)
{
  SongFactory::MonitorLock monitorLock ();
  
  DlHandler* dlHandler = new DlHandler (option__);
  if (dlHandler->openLibSo ("Song", songModuleName) != NULL)
    {
      string songInfoName = "InfoSong";
      songInfoName += songModuleName;
      void* infoSong = dlHandler->sym (songInfoName);
      if (infoSong != NULL)
	{
	  infoSongList.push_front (static_cast<InfoSong*>(infoSong));
	}
      else
	{//fail to sym
	  cerr << "SongFactory::addSongModule can not sym "
	       << songInfoName << endl;
	  delete dlHandler;
	}
    }
  else
    {//fail to open dynamic library
      cerr << "SongFactory::addSongModule can not open "
	   << "libSong" << songModuleName << ".so" << endl;
      delete dlHandler;
    }
}
