#ifndef SongFactory_H
#define SongFactory_H

#include <list>

#include "InfoSong.h"
#include "util/DlHandler.h"
#include "util/Mutex.h"

using namespace std;

class SongFactory
{
private:
  static Mutex lock;
  class MonitorLock
  {
  public:
    MonitorLock () {SongFactory::lock.lock ();};
    ~MonitorLock () {SongFactory::lock.unlock ();};
  };
  friend MonitorLock;


  SongFactory ();
  list<InfoSong*> infoSongList;
  list<DlHandler*> dlHandlerList;
  static SongFactory songFactory;
  Song* __newSong  (const string& fileName, State* state,
		    SongCommand* songCommand, MainIO& userIO,
		    Option* option__);
  void __addSongModule (const string& songModuleName, Option* option__);

  static SongFactory& instance ()
    {return songFactory;};
public:
  ~SongFactory ();

  static void addSongModule (const string& songModuleName, Option* option__)
    {instance ().__addSongModule (songModuleName, option__);};
  ////////////////////////////////////////////////////////////factory mathod
  static Song* newSong (const string& fileName, State* state,
			SongCommand* songCommand, MainIO& userIO,
			Option* option__)
    {return instance ().__newSong (fileName,
				   state, songCommand, userIO, option__);};
};

#endif // SongFactory_H
