/*
    SongInputStream.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "SongInputStream.h"

SongInputStream::SongInputStream (const string& filename_,
				  int mode = ios::in|ios::nocreate):
  ifstream (filename_.c_str (), mode),fileName (filename_)
{
  //do nothing
  seekg(0, ios::end); // եνü seek
  fileSize = tellg();  // ե륵

  if (fileSize<0)
    {// ե뤬¸ߤʤ
      Error error ("SongInputStream::SongInputStream can not open ", fileName);
      throw (error);
    }
  
  seekg(0, ios::beg); // եƬ seek
}

SongInputStream::~SongInputStream ()
{
  
}


int SongInputStream::get8 () throw (Error)
{
  if (--fileSize < 0)
    { // ⤦ɤǤʤǡʤ
      close();
      Error error ("SongInputStream:get8 Unexpected end of file:", fileName);
      throw (error);
    }
  
  return get (); // 8 bit ǡ
}


int SongInputStream::get16B () throw (Error)
{
  int value;
  value = (get8 () << 8);
  value |= get8 ();
  return value;
}

int SongInputStream::get24B () throw (Error)
{
  int value;
  value  = (get8 () << 16);
  value |= (get8 () <<  8);
  value |=  get8 ();
  return value;
}

int SongInputStream::get32B () throw (Error)
{
  int value;
  value  = (get8 () << 24);
  value |= (get8 () << 16);
  value |= (get8 () <<  8);
  value |=  get8 ();
  return value;
}

istream& SongInputStream::read (char* ptr, streamsize n) throw (Error)
{
  fileSize -= n;
  if (fileSize < 0)
    {//ɤ߹٤dataĤäƤ뤫check
      close();
      Error error ("SongInputStream:read Unexpected end of file:", fileName);
      throw (error);
    }

  return ifstream::read(ptr, n);
}
