/*
    SongInputStream.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef SongInputStream_H
#define SongInputStream_H

#include <iostream>
#include <fstream>

#include "util/Error.h"

using namespace std;

class SongInputStream:public ifstream
{
private:
  int fileSize;
  const string fileName;
public:
  SongInputStream (const string& filename_, int mode = ios::in|ios::nocreate);
  virtual ~SongInputStream ();//default destructor
  int getFileSize () const {return fileSize;};
  int get8 () throw (Error);
  int get16B () throw (Error);//big endian
  int get24B () throw (Error);//big endian
  int get32B () throw (Error);//big endian
  istream& read (char* ptr, streamsize n) throw (Error);
  istream& read (signed char *ptr, streamsize n)
    {return read ((char*)ptr,n);};
  istream& read(unsigned char* ptr, streamsize n)
    {return read ((char*)ptr,n);};
};

#endif//  SongInputStream_H
