/*
    SongEvent.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef SongEvent_H
#define SongEvent_H

#include "Song/Song.h"
#include "MidiEventList.h"

class SongEvent:public  Song
{
protected:
  MidiEventList* midiEventList;
public:
  SongEvent (const char* const fileName, State* state_,
	     SongCommand* songCommand_, MainIO& userIO, Option* option_);
  virtual ~SongEvent ();
  virtual void loadFile (const char* /*fileName*/) //throw (Error)
    {cerr << "Error:SongEvent::loadFile (const char*) called." << endl;};
  virtual void loadFile (SongInputStream& /*songInputStream*/) //throw (Error)
    {cerr << "Error:SongEvent::loadFile (SongInputStrea&) called." << endl;};


protected:
  virtual void doLoadBuffer (const char* /*buffer*/,int /*bufferSize*/) //throw (Error)
    {cerr << "Error:SongEvent::doLoadbuffer () called." << endl;};
  virtual void preSearch () {};//XXX not implemented yet
  virtual void dumpBuffer (Sequencer& /*sequencer*/,
			   uint32 /*lastTicks*/,uint32 /*playTicks*/,
			   double& /*machineTicks*/,double /*dMachineTicks*/,
			   double& /*logicalTicks*/, double /*dLogicalTicks*/,
			   double& /*lastDumpTicks*/)
    {cerr << "Error:SongEvent::dumpBuffer () called." << endl;};
  virtual void doPlay (Sequencer& sequencer);
  
  //////////////////////////////////////////////////////////for play control
  //$B1iAU0LCV$r:G=i$K4,$-La$9!#(B($B0?$O1iAU0LCV$r;XDj0LCV$^$G0\F0$9$k!#(B)
  virtual void realRewind ();
};
#endif //SongEvent_H
