/*
    newSong.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "Song/SMF/SMF.h"
#include "Song/recomposer/RCP.h"
#include "Song/recomposer/G36.h"

#include "Song/SongFactory.h"

//fileName$B$r1iAU=PMh$kE,@Z$J(BSong$B$N(Bsub class$B$r(Bnew$B$7$F$=$l$X$N%]%$%s%?!<$rJV$9!#(B
//for playing
Song* SongFactory::__newSong (const string& fileName,
			      State* state, SongCommand* songCommand,
			      MainIO& userIO, Option* option__)
{
  for (list<InfoSong*>::iterator i = infoSongList.begin ();
       i != infoSongList.end ();
       i++)
    {
      if ((*i)->isSupported (fileName))
	return (*i)->newSong (fileName, state, songCommand, userIO, option__);
    }

  if (SMF::isSupported (fileName))
    return new SMF (fileName, state, songCommand, userIO, option__);
  else if (RCP::isSupported (fileName))
    return new RCP (fileName, state, songCommand, userIO, option__);
  else if (G36::isSupported (fileName))
    return new G36 (fileName, state, songCommand, userIO, option__);
  
  return NULL;
}

