/*
    G36.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef G36_H
#define G36_H

#include "RCP.h"

class G36:public RCP
{
protected:
  static const int G36_MAGIC_LENGTH = 32;
  //magic number
  static const char G36_MAGIC[] = "COME ON MUSIC RECOMPOSER RCP3.0\0";
  static const int G36_RYTHMS_NUMBER = 128;
  char controlFileNameGSD1[RCP_MAX_FILENAME_LENGTH+1];//config file name .GSD1
public:
  //for playing
  G36 (State* state_, SongCommand* songCommand_,
       MainIO& userIO, Option* option_);
  G36 (const string& fileName, State* state_, SongCommand* songCommand_,
       MainIO& userIO, Option* option_);
  G36 (SongInputStream& songInputStream, State* state_,
       SongCommand* songCommand_, MainIO& userIO, Option* option_);
#if 0
  //for converting
  G36 (const string& fileName, State* state_, SongCommand* songCommand_,
       MainIOConvert2Dumb& userIO, 
       Option* option_, DumbEventList& dumbEventList_);
#endif
  ~G36 ();
  static bool isSupported (const string& fileName);
  virtual void dumpTrack ();
protected:
  virtual RCPTrack* newTrack ();
  //G36$B$N(Bheader$B$rFI$_9~$`!#(B
  virtual void readHeader (RCPBufferStream& rcpBufferStream) throw (Error);

  virtual void getParameter (int playTrack,
			     uchar& note, uint32& stepTime, uchar& gateTime,
			     uchar& velocity);
  virtual void channelExclusive (Sequencer& sequencer, int playTrack,
				 const uchar command, const uchar gateTime,
				 const uchar velocity);
  virtual void externalCommand (int playTrack, uchar gateTime, uchar velocity);
  void bankAndProgramLSB (Sequencer& sequencer,
			  int playTrack, uchar gateTime, uchar velocity);
  virtual void tempoChange (int playTrack,
			    uint32& oldTempo, uint32& setTempoTicks,
			    uchar gateTime, uchar velocity);//XXX
  virtual void commentStart (int playTrack);//XXX
  virtual void sameMeasure (int playTrack);

};
#endif // G36_H
