/*
    RCP.cc  
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#include <strstream>

#include "RCP.h"

using namespace std;

//#define USE_NOTE_OFF

//SMF::preSearch$B$HF1MMD9$9$.!#(B
void RCP::preSearch ()
{
  //$B1iAU0LCV$r:G=i$K0LCV$5$;$k!#(B
  realRewind ();
  cacheSongStatus->reset ();
  
  uint32 lastTicks = 0;//$BA02s(BwaitTime$B$7$?$H$-$N@dBP(Btick$B?t!#(B
  double logicalTicks = 0;//$B8=:_1iAU$7$F$$$k@dBP(Blogical ticks
  double dLogicalTicks = 0;//$B7W;;MQ!#(B
  uint32 setTempoTicks = 0;//set tempo$B$7$?$H$-$N;~4V7W;;$NJd@5MQ!#(B
  uint32 oldTempo = cacheSongStatus->getTempo ();//set tempo$B$7$?$H$-$N;~4V7W;;$NJd@5MQ!#(B

  cacheSongStatus->events = 0;//midi event$B$N?t(B
  
  uint16 nEndOfTracks = 0;//$B1iAU$N=*N;$7$?%H%i%C%/?t(B
  int playTrack = 0;//$B8=:_CmL\$7$F$$$k%H%i%C%/(B

  bool isNoteOff = false;//RCP$B$N(Bevent$B$h$j$b(Bnote off$B$,@h$K$"$k$+(B
  
  while (nEndOfTracks<cacheSongStatus->getNTracks () || isNoteOff)
    {
      /////$B$I$N%H%i%C%/$,:G=i$K1iAU$5$l$k$+0?$O!"(Bnote off$B$+H=Dj!#(B
      for (int i = 0; i < cacheSongStatus->getNTracks (); i++)
	{
	  if ((rcpTrack[i]->getABSTicks ()<rcpTrack[playTrack]->getABSTicks ())
	      && (!rcpTrack[i]->isEnd ()))
	    playTrack = i;
	}
      uint32 playTicks = rcpTrack[playTrack]->getABSTicks ();//$B<!$N%$%Y%s%H$,5/$-$k(Bticks

      
#ifdef USE_NOTE_OFF
      //note off$B$N0Y$NA0=hM}!#(B
      uint32 nextNoteOffTicks = ~static_cast<uint32> (0);
      for (int i = 0;i<cacheSongStatus->getNTracks ();i++)
	{
	  for (int note = 0;note<Part::MAX_NOTES;note++)
	    {
	      if (rcpTrack[i]->gateTimes[note] != RCPTrack::RCP_NOTE_OFF)
		{
		  if ((uint32) rcpTrack[i]->gateTimes[note] <= 0)
		    {
		      rcpTrack[i]->gateTimes[note] = RCPTrack::RCP_NOTE_OFF;
		    }
		  else
		    {
		      //$B<!$N(B0$B0J>e$N(Bnote off$B$N;~4V$r7W;;(B
		      if ((uint32) rcpTrack[i]->gateTimes[note]<nextNoteOffTicks)
			nextNoteOffTicks = rcpTrack[i]->gateTimes[note];
		    }
		}
	    }
	}
  
      isNoteOff = false;
      if (nextNoteOffTicks <= playTicks-lastTicks)
	//if (nextNoteOffTicks<playTicks-lastTicks)
	{//note off event$B$NJ}$,@h$K5/$-$k!#(B
	  playTicks = lastTicks+nextNoteOffTicks;
	  isNoteOff = true;
	}
#endif //USE_NOTE_OFF
      
      dLogicalTicks = 0;
      assert (lastTicks <= playTicks);
      if (lastTicks<playTicks)
	{
	  dLogicalTicks =
	    calcDLogicalTicks (playTicks, lastTicks, setTempoTicks,
			       cacheSongStatus->getTempo (), oldTempo,
			       cacheSongStatus->getDivision ());
	  
	  cacheSongStatus->ticksFromLastMeasure = 
	    playTicks-cacheSongStatus->lastMeasureTicks;
	  if (static_cast<ulong> (logicalTicks+dLogicalTicks)-static_cast<ulong>(logicalTicks)>0)
	    {
	      cacheSongStatus->lastTicks = lastTicks;
	      cacheSongStatus->ticks = playTicks;
	      cacheSongStatus->logicalTicks = logicalTicks;
	      logicalTicks += dLogicalTicks;
#ifdef USE_NOTE_OFF
	      for (int i = 0; i < cacheSongStatus->getNTracks (); i++)
		{
		  for (int note = 0; note < Part::MAX_NOTES; note++)
		    {
		      if (rcpTrack[i]->gateTimes[note] >= 0)
			{
			  rcpTrack[i]->gateTimes[note]-=(playTicks-lastTicks);
			  assert (rcpTrack[i]->gateTimes[note]  >=  0);
			}
		    }
		}
	      nextNoteOffTicks = 0;
#endif // USE_NOTE_OFF
	      lastTicks = playTicks;
	      setTempoTicks = playTicks;
	      oldTempo = cacheSongStatus->getTempo ();
	    }
	}
      
      //event$B$r2r@O$9$k!#(B
#ifdef USE_NOTE_OFF
      if (isNoteOff)
	{
	  for (int i = 0; i < cacheSongStatus->getNTracks (); i++)
	    {
	      for (int note = 0; note < Part::MAX_NOTES; note++)
		{
		  if (rcpTrack[i]->gateTimes[note] != RCPTrack::RCP_NOTE_OFF)
		    {
		      if ((uint32) rcpTrack[i]->gateTimes[note] <= nextNoteOffTicks)
			{
			  rcpTrack[i]->gateTimes[note] = RCPTrack::RCP_NOTE_OFF;
			}
		    }
		}
	    }
	}
#endif //USE_NOTE_OFF
      else
	{
	  if (rcpTrack[playTrack]->peekUChar () >= 0x80)
	    {//rcp$B$N(Bcommand$B$@$C$?!#(B
	      uchar command;
	      uint32 stepTime;
	      uchar gateTime;
	      uchar velocity;
	      getParameter (playTrack, command, stepTime, gateTime, velocity);
	      switch (command)
		{
		case 0x98://channel exclusive
		  while (rcpTrack[playTrack]->peekUChar () == 0xF7)
		    rcpTrack[playTrack]->seekgCur (4);
		  rcpTrack[playTrack]->addTicks (stepTime);
		  break;
		case 0x99://$B30It(Bccommand$B$N<B9T(B
		  while (rcpTrack[playTrack]->peekUChar () == 0xF7)
		    rcpTrack[playTrack]->seekgCur (4);
		  break;
		case 0xE7://tempo change
		  tempoChange (playTrack, oldTempo, setTempoTicks, gateTime, velocity);
		  rcpTrack[playTrack]->addTicks (stepTime);
		  break;
		case 0xF5://key change
		  break;
		case 0xF6://falling through
		case 0xF7:
		  while (rcpTrack[playTrack]->peekUChar () == 0xF7)
		    rcpTrack[playTrack]->seekgCur (4);
		  break;
		case 0xF8://loop end
		  loopEnd (playTrack, stepTime);
		  break;
		case 0xF9://loop start
		  loopStart (playTrack);
		  break;
		case 0xFC://same measure
		  sameMeasure (playTrack, logicalTicks, logicalTicks);
		  break;
		case 0xFD://mesure end
		  measureEnd (playTrack, logicalTicks, logicalTicks);
		  break;
		case 0xFE://end of track
		  rcpTrack[playTrack]->setEnd ();
		  nEndOfTracks++;
		  break;
		  
		case 0x90://falling through
		case 0x91://falling through
		case 0x92://falling through
		case 0x93://falling through
		case 0x94://falling through
		case 0x95://falling through
		case 0x96://falling through
		case 0x97://falling through
		case 0xE1://falling through
		case 0xE2://falling through
		case 0xE5://falling through
		case 0xE6://falling through
		case 0xEA://falling through
		case 0xEB://falling through
		case 0xEC://falling through
		case 0xED://falling through
		case 0xEE://falling through
		case 0xD0://falling through
		case 0xD1://falling through
		case 0xD2://falling through
		case 0xD3://falling through
		case 0xDD://falling through
		case 0xDE://falling through
		case 0xDF://falling through
		case 0xC0://falling through
		case 0xC1://falling through
		case 0xC2://falling through
		case 0xC3://falling through
		case 0xC5://falling through
		case 0xC6://falling through
		case 0xC7://falling through
		case 0xC8://falling through
		case 0xC9://falling through
		case 0xCA://falling through
		case 0xCB://falling through
		case 0xCC://falling through
		case 0xCD://falling through
		case 0xCE://falling through
		case 0xCF://falling through
		case 0xDC:
		  rcpTrack[playTrack]->addTicks (stepTime);
		  break;
	
		default:
		  DEBUG_MESSAGE ("DEBUG:RCP::doRCPCommand:unkown command!!!!");
		  break;
		}
	      
	      cacheSongStatus->events++;
	    }
	  else
	    {//note on
	      uchar note;
	      uint32 stepTime;
	      uchar gateTime;
	      uchar velocity;
	      getParameter (playTrack, note, stepTime, gateTime, velocity);
	      note+=rcpTrack[playTrack]->keyPlus+playBias;
	      if (note>127)
		note&=0x7F;
	      assert (velocity <= 127);
	      assert (note <= 127);

	      if (rcpTrack[playTrack]->gateTimes[note] == RCPTrack::RCP_NOTE_OFF && velocity>0)
		rcpTrack[playTrack]->gateTimes[note] = gateTime;
	      else if (rcpTrack[playTrack]->gateTimes[note] != RCPTrack::RCP_NOTE_OFF && velocity == 0)
		rcpTrack[playTrack]->gateTimes[note] = RCPTrack::RCP_NOTE_OFF;
	      else if (rcpTrack[playTrack]->gateTimes[note] != RCPTrack::RCP_NOTE_OFF && velocity>0)
		rcpTrack[playTrack]->gateTimes[note] = gateTime;
	      rcpTrack[playTrack]->addTicks (stepTime);

	      cacheSongStatus->events++;
	    }
	  
	}
    }//while (nEndOfTracks<nTracks)
  
  
  //$B5a$a$?J*$r3P$($F$*$/!#(B
  cacheSongStatus->totalTicks=cacheSongStatus->ticks;
  cacheSongStatus->totalLogicalTicks=static_cast<uint32> (cacheSongStatus->logicalTicks);
  cacheSongStatus->totalMeasures=cacheSongStatus->measures;
  cacheSongStatus->totalEvents = cacheSongStatus->events;
  
  realRewind ();
  cacheSongStatus->reset ();
}
