/*
    UserExclusive.h    
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef UserExclusive_H
#define UserExclusive_H

#include "Song/recomposer/RCPBufferStream.h"

class UserExclusive
{
protected:
  bool isG36;//.g36,.g18$B$+(B
  //=true .g18,or .36
  //=false .rcp or .r36
public:
  UserExclusive ();
  ~UserExclusive ();
  void load (RCPBufferStream& rcpBufferStream,bool midiIsG36=false);
  static const int RCP_MAX_MEMO_LENGTH=24;
  char memo[RCP_MAX_MEMO_LENGTH];
  static const int RCP_MAX_USER_EXCLUSIVE_LENGTH=25;
  uchar exclusive[RCP_MAX_USER_EXCLUSIVE_LENGTH];
  static const uchar GATE_DATA;
  static const uchar VELOCITY;
  static const uchar MIDI_CHANNEL;
  static const uchar CLEAR_CHECK_SUM;
  static const uchar CHECK_SUM;
  static const uchar END_OF_EXCLUSIVE;
  uchar storeData (uchar storedData[RCP_MAX_USER_EXCLUSIVE_LENGTH],
		   const uchar gateData,const uchar velocity,
		   const uchar rcpMidiChannel);
  
};
#endif // UserExclusive_H
