#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <iostream>

#include "IO/MainIO.h"
#include "Song/recomposer/G36.h"
#include "Widi/ServerCommand.h"
#include "Widi/SongManager.h"
#include "Widi/WidiController.h"


int
main (int argc,const char** argv)
{
  if (argc<=1)
    exit (1);

  State state;
  SongCommand songCommand;
  ServerCommand serverCommand;
  SongManager songManager;
  WidiController widiController (&serverCommand, &songManager);
  Option option;
  MainIO io (&state, &widiController, &option);

  for (int i=1;i<argc;i++)
    {
      G36 g36(argv[i],&state,&songCommand,io,&option);
      cerr << "now dumping G36 file="  << argv[i] << endl;
      g36.dumpTrack ();
    }

  exit (0);
}
