#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <iostream>


#include "IO/MainIO.h"
#include "Song/recomposer/RCP.h"
#include "Widi/ServerCommand.h"
#include "Widi/SongManager.h"
#include "Widi/WidiController.h"

int
main (int argc,const char** argv)
{
  if (argc<=1)
    exit (1);

  Option option;
  State state;
  ServerCommand serverCommand;
  SongManager songManager;
  WidiController widiController (&serverCommand, &songManager);
  MainIO io (&state, &widiController, &option);
  SongCommand songCommand;

  for (int i=1;i<argc;i++)
    {
      RCP rcp(argv[i],&state,&songCommand,io,&option);
      rcp.dumpTrack ();
    }

  exit (0);
}
