#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <cstdio>
#include <sys/ioctl.h>
#include <iostream>
#include <unistd.h>

#include "IO/MainIO.h"
#include "Sequencer/OSS/MIDI/SequencerMIDI.h"

#include "Song/recomposer/RCP.h"

#define DEVICE_SEQUENCER "/dev/sequencer"



int
main (int argc,const char** argv)
{
  if (argc<=1)
    {
      exit (1);
    }
  State state;
  SongCommand songCommand;
  ServerCommand serverCommand;
  Option option;
  MainIO* io=new MainIO (&state,&serverCommand,&option);
  //pthread_t thread;
  //io->createMainLoopThread (&thread,NULL);

  //Sequencer* sequencer=new SequencerMIDI (&state,0,&option);
  Sequencer* sequencer=new SequencerMIDI (&state,1,&option);
  sequencer->sync ();


  for (int i=1;i<argc;i++)
    {
      Song* song=new RCP(argv[i],&state,&songCommand,*io,&option);
      cerr << "reading done." << endl;
#if 1
# if 1
      song->play (*sequencer);
# else    
      pthread_t playThread;
      song->createPlayThread (&playThread,NULL,*sequencer);
      cerr << "now joining playing thread" << endl;
      void* retVal;
      pthread_join (playThread,&retVal);
# endif
#endif
      cerr << "now deleting song" << endl;
      delete song;
      cerr << "next song." << endl;
    }
  
  delete sequencer;
  
  delete io;
  cout << "all done" << endl;
  exit (0);
}





