#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <cstdio>
#include <sys/ioctl.h>
#include <iostream>

#include "IO/X/Xlib/IOXlib.h"
#include "Sequencer/OSS/MIDI/SequencerMIDI.h"

#include "Song/SMF/SMF.h"
#include "Song/recomposer/RCP.h"

#include "IO/NCurses/IONVolume.h"
#include "IO/NCurses/IONLevel.h"
#include "IO/NCurses/IONTrace.h"

int
main (int argc,const char** argv)
{
  if (argc<=1)
    {
      exit (1);
    }
  State state;
  SongCommand songCommand;
  ServerCommand serverCommand;
  Option option;
  option.isQuickStart=true;
  option.isRealTime=true;
  //MainIO* mainio=new MainIO (&state,&serverCommand);
  //MainIO* mainio=new IONCurses (&state,&serverCommand);
  //MainIO* mainio=new IONVolume (&state,&serverCommand);
  //MainIO* mainio=new IONLevel (&state,&serverCommand);
  //MainIO* mainio=new IONTrace (&state,&serverCommand,&option);
  IOXlib* xio=new IOXlib (&state,&serverCommand,&option);
  MainIO* mainio=xio;
  //MainIO* mainio=new IOXlib (&state,&serverCommand,&option);
#if 0
  IO* io=new IONLevel (&state,&serverCommand,&option);
  IO* io=new IONCurses (&state,&serverCommand,&option);
  io->initialize ();
  pthread_t ioThread;
  io->createMainLoopThread (&ioThread,NULL);
#endif

  pthread_t thread;
  mainio->createMainLoopThread (&thread,NULL);

  SequencerOSS::open ();
  Sequencer* sequencer=new SequencerMIDI (&state,0,&option);
  //Sequencer* sequencer=new SequencerMIDI (&state,1,&option);
  sequencer->sync ();

  for (int i=1;i<argc;i++)
    {
      Song* song=new SMF(argv[i],&state,&songCommand,*mainio,&option);
      //Song* song=new RCP(argv[i],&state,*mainio);
      cerr << "reading done." << endl;

      pthread_t playThread;
      song->createPlayThread (&playThread,NULL,*sequencer);
      cerr << "now joining playing thread" << endl;
      void* retVal;
      pthread_join (playThread,&retVal);
    }

  void* retVal;
  pthread_join (thread,&retVal);
  delete sequencer;
  SequencerOSS::close ();

  cout << "all done" << endl;
  exit (0);
}





