#ifndef BufferStream_H
#define BufferStream_H

#include <fstream>

#include "MemoryBuffer2.h"
#include "DataStream.h"
#include "Threaded.h"

using namespace std;

//adapter memoryBuffer2 to 'DataStream'
class BufferStream:public DataStream,public Threaded<MemoryBuffer2>
{
protected:
  const long maxBufferSize;
  static void setDataTypeInfo (BufferStream* me)
    {me->dataTypeInfo="Buffer on Memory.";};

public:
#define MEMORY_BUFFER2_DEFUALT_MAX_BUFFER_SIZE 8182L //??? ĤŬ?
  BufferStream (DataStream* dataStream_,
		long maxBufferSize_=MEMORY_BUFFER2_DEFUALT_MAX_BUFFER_SIZE,
		bool doesCreateRetrieveThread=true);
  virtual ~BufferStream ();

  virtual void close ();//buffer˴
  virtual long read (char* buffer,long size){return read (buffer,size,true);};
  virtual long read (char* buffer,long size,bool doesBlock);
  virtual long seekg (long pos,Whence whence=cur)
    {assert (false);throw UnavailableOperation ();return 0;};
  virtual long rewind ()
    {assert(false);throw UnavailableOperation();return memoryBuffer->tellg();};
  virtual long tellg () {return memoryBuffer->tellg ();};
  virtual bool eod () const {return memoryBuffer->eod ();};

  virtual bool isRandomAccessible () const {return false;};

  //for debug
  void printNodeInfo () const {memoryBuffer->printNodeInfo ();};
};
#endif // BufferStream_H
