#include "DataStream.h"

DataStream::DataStream (const char* name_):
  name (name_)
{
  //Ǹ'/'
  if (name.find_last_not_of ('/')!=string::npos)
    name.resize (name.find_last_not_of ('/')+1);
  
  //parentbase nameʬ
  const size_t fileDelimiter=name.rfind ('/');
  const size_t archiveDelimiter=name.rfind ('#');
  if (fileDelimiter!=string::npos || archiveDelimiter!=string::npos)
    {
      size_t delimiter;
      if (fileDelimiter!=string::npos && archiveDelimiter!=string::npos)
	delimiter=max (fileDelimiter,archiveDelimiter);
      else if (fileDelimiter==string::npos)
	delimiter=archiveDelimiter;
      else if (archiveDelimiter==string::npos)
	delimiter=fileDelimiter;
      
      if (delimiter<name.length ())
	{
	  //delimiter==0λparent=='/'λ
	  baseName.assign (name,delimiter+((delimiter>0)? 1:0));
	}
      if (delimiter>0)
	{
	  parentName.assign (name,0,delimiter+1);
	  //Ǹ'/'롣
	  if (parentName.find_last_not_of ('/')!=string::npos)
	    parentName.resize (name.find_last_not_of ('/')+1);
	}
#ifdef DEBUG
      cerr << "fileDelimiter=" << fileDelimiter
	   << ":archiveDelimiter=" << archiveDelimiter
	   << ":delimiter=" << delimiter
	   << ":name length=" << name.length ()
	   << endl;
#endif
    }
  else
    {//parent=='/' or relative path ľ
      //const_cast<string> (baseName)=name;
      baseName=name;
    }

#ifdef DEBUG
  cerr << "DataStream::StatStream parentName=" << parentName
       << " :baseName=" << baseName << " :name=" << name << endl;
#endif
}


DataStream::DataStream (const char* parentName_,const char* baseName_):
  parentName (parentName_),baseName (baseName_)
{
  name=parentName+"/"+baseName;
}

DataStream::DataStream (const string parentName_,const string baseName_):
  parentName (parentName_),baseName (baseName_)
{
  name=parentName+"/"+baseName;
}

DataStream::~DataStream ()
{
  for (ChildrenList::iterator i=children.begin ();i!=children.end ();i++)
    delete (*i);
}

DataStream* DataStream::newChild (uint n)
{
  if (children.size ()<n)
    return NULL;

  ChildrenList::iterator i=children.begin ();
  for (uint j=0;j<n;j++)
    i++;
  
  return newChild (i);
}

DataStream* DataStream::newChild (const string childname)
{
  for (ChildrenList::iterator i=children.begin ();i!=children.end ();i++)
    {
      if ((*i)->filename==childname)
	return newChild (i);
    }
  
  return NULL;
}
