#ifndef Directory_H
#define Directory_H

#include "Archive.h"

class Directory:public Archive
{
protected:
  static void setDataTypeInfo (Directory* me)
    {assert (me!=NULL);me->dataTypeInfo="Directory";};

  virtual void makeFileList ();
public:
  Directory (const char* path);
  Directory (const char* parentDir,const char* dirName);
  virtual ~Directory (){/*do nothing*/};

  virtual void close (){/*do nothing*/};
  
  virtual bool isRandomAccessible () const {return false;};
  
  virtual DataStream* newChild (ChildrenList::iterator& i);

  static bool isSupport (const char* filename);
  static bool isSupport (const char* data,long size){return false;};
  static bool isSupport (DataStream& dataStream){return false;};

  //$BNc30=hM}MQ$N%/%i%9(B
  class CanNotOpenDirectory:public CanNotOpen {};
  class CanNotCloseDirectory:public CanNotClose {};
};

#endif // Directory_H
