#ifndef FileStream_H
#define FileStream_H

#include <fstream>

#include "DataStream.h"

using namespace std;

class FileStream:public DataStream
{
protected:
  ifstream* file;
  long fileSize;
  virtual void openIfstream ();

  static void setDataTypeInfo (FileStream* me)
    {assert (me!=NULL);me->dataTypeInfo="Regular file";};
public:
  FileStream (const char* path);
  FileStream (const char* parentDirectory,const char* baseName);
  virtual ~FileStream ();

  virtual void close ();
  virtual long read (char* buffer,long size);
  virtual long seekg (long pos,Whence whence=cur);
  virtual long tellg () {return file->tellg ();};
  virtual bool eod ();

  long getFileSize () const {return fileSize;};
  virtual bool isRandomAccessible () const {return true;};

  static bool isSupport (const char* filename);
  static bool isSupport (const char* data,long size){return false;};
  static bool isSupport (DataStream& dataStream){return false;};

  //exception class
  class InvalidFileSize:public ErrorOccured {};
};

#endif // FileStream_H
