#ifndef LZH_H
#define LZH_H

#include "Archive.h"
#include "MemoryStream.h"

class LZH:public Archive
{
public:
  static bool isSupport (const char* fileName);
  static bool isSupport (const char* data_,long size_);
  static bool isSupport (DataStream& dataStream);
  
private:
  //(static_cast<ArchiveEntryNode*>(EntryNode.userdata))
  //->userData=&LZHEntryNode
  //ȤƻȤ
  //class LZHEntryNode:public EntryNode::UserData//this cause egcs's bug!!!
  class LZHEntryNode:public DataStream::EntryNode::UserData
  {
  public:
    int headerSize;//size of total header size
    //level=2λϤΤޤ,level=0,1λheade size+2ʪ
    int headerCheckSum;//header check sum (level=2 λϰ̵̣)
#define LZH_METHOD_ID_LENGTH 5
    char methodID[LZH_METHOD_ID_LENGTH];//method ID
    //ArchiveEntryNode->commpressedSize=packed size/skip size
    //ArchiveEntryNode->uncommpressedSize=original size
    uchar headerLevel;//lzh header level
    uint16 crc;//CRC-16 of original data

    long offset;//offset from top of the data. ???
    DataStream* dataStream;//data stream ???
    LZHEntryNode ():
      headerSize (-1),headerLevel (0),offset (-1),dataStream (NULL)
      {memset (methodID,0,LZH_METHOD_ID_LENGTH);};
    ~LZHEntryNode (){delete dataStream;};
  };

  //read the data and make the list of this archive.
  void makeArchiveList ();
  EntryNode* readHeaderAndSkipData ();//throw (UnexpectedEndOfData)
  void readExtendedHeader
  (MemoryStream& header,EntryNode* entryNode,
   ArchiveEntryNode* archiveEntryNode,
   LZHEntryNode* lzhEntryNode);//throw (UnexpectedEndOfData)
public:
  LZH (const char* path);
  LZH (const char* parentDirectory,const char* baseName);
  LZH (const char* name,const char* data,long size);
  //dataStream_򿷤newͿɬפ롣
  //destructdata_ϼưŪdelete롣
  //Ĥޤꡢ¾data_򻲾ȤƤϤʤ
  //!!! dataStream_destruct˲롣!!!
  LZH (DataStream* dataStream);
  ~LZH ();
  
  virtual void close () {};//Ÿʪbuffer˴//XXX

  virtual bool isRandomAccessible () const {return false;};

  //LZHMember* lzhMember=dynamic_cast<LZHMember*>(lzh->newChild (n));
  //ȤƻȤ
  virtual DataStream* newChild (ChildrenList::iterator& i);

};
#endif //LZH_H
