#include "LZHMember.h"

#ifdef USE_DYNAMIC_CAST
long LZHMember::readFunc
(char* data,long size,/*DataStream**/void* dataStream)
{
  assert (dataStream!=NULL);
  return dynamic_cast<DataStream*>(dataStream)->read (data,size);
}
#else
long LZHMember::readFunc (char* data,long size,DataStream* dataStream)
{
  assert (dataStream!=NULL);
  return  dataStream->read (data,size);
}
#endif

LZHMember::LZHMember (EntryNode* entryNode_):
  Extracter ((dynamic_cast<LZH::LZHEntryNode*>
	     (dynamic_cast<Archive::ArchiveEntryNode*>(entryNode_->userData)
	      ->userData)->dataStream)->getParentName ().c_str (),
	     (dynamic_cast<LZH::LZHEntryNode*>
	     (dynamic_cast<Archive::ArchiveEntryNode*>(entryNode_->userData)
	      ->userData)->dataStream)->getBaseName ().c_str ()),
  entryNode (entryNode_),
  archiveEntryNode (dynamic_cast<Archive::ArchiveEntryNode*>(entryNode->userData)),
  lzhEntryNode (dynamic_cast<LZH::LZHEntryNode*>(archiveEntryNode->userData))
{
  assert (entryNode!=NULL);
  assert (archiveEntryNode!=NULL);
  assert (lzhEntryNode!=NULL);
#define METHOD_ID_LENGTH 5
  char method[METHOD_ID_LENGTH+1];
  memcpy (method,lzhEntryNode->methodID,METHOD_ID_LENGTH+1);
  method[METHOD_ID_LENGTH]='\0';
#undef METHOD_ID_LENGTH
  unlzhHandler=open_unlzh_handler
    (&LZHMember::readFunc,method,
     archiveEntryNode->compressedSize,
     archiveEntryNode->uncompressedSize,
     static_cast<void*>(lzhEntryNode->dataStream));
  assert (unlzhHandler!=NULL);
}


LZHMember::~LZHMember ()
{
  close_unlzh_handler (unlzhHandler);
  delete entryNode;
}

long LZHMember::read (char* buffer,long size)
{
  //XXX dataStreamΤ踫ߤǥ֥å뤫ɤˤɬפꡣ
  const long retSize=unlzh (unlzhHandler,buffer,size);
  readSize+=retSize;
  return retSize;
}

