#include <iostream>

#include "MemoryBuffer.h"

using namespace std;

MemoryBuffer::MemoryBuffer ()
{
  //do nothing
}

MemoryBuffer::~MemoryBuffer ()
{
  MemoryBufferNode* now=head;
  while (now!=NULL)
    {
      MemoryBufferNode* tmp=now;
      now=now->getNext ();
      delete tmp;
    }
}

long MemoryBuffer::read (char* buffer,const long size,const bool doesBlock=true)
{
  long readSize=0;//read size
  lock.lock ();

  while (current==NULL)
    {
      assert (head==NULL);
      assert (tail==NULL);
      if (doesBlock && (!eodUnlocked ()))
	dataFilled.wait (lock);
      else
	{
	  lock.unlock ();
	  return 0;
	}
    }
  
  while (readSize<size)
    {
      //nodeν
      if (current->leftBufferSize (currentNodePosition)==0)
	{//nodeɤ߽Ф
	  if (current==tail)
	    {//Ǹnodeä
	      assert (current->getNext ()==NULL);
	      if (doesBlock)
		{//ɬפʤǡɤ߹뤫eodˤʤޤԤġ
		  if (eodUnlocked ())
		    break;//dataκǸޤɤ߽Ф
		  //Ԥġ
		  while (current->leftBufferSize (currentNodePosition)==0 &&
			 current->getNext ()==NULL &&
			 (!eodUnlocked ()))
		    dataFilled.wait (lock);
		}
	      else
		break;//blockΥ᥽åɤ֤롣
	    }
	  else
	    {//node˰ܤ롣
	      assert (current->leftMemorySize ()==0);
	      current=current->getNext ();
	      currentNodePosition=0;
	      assert (current!=NULL);
	    }
	  continue;
	}
      
      //datanodeɤ߹ࡣ
      //cerr << "from currentNodePosition=" << currentNodePosition;
      const long n=current->read (buffer,&currentNodePosition,size-readSize);
      buffer+=n;
      currentPosition+=n;
      readSize+=n;
#if 0
      cerr << " to MemoryBuffer::n=" << n
	   << " currentNodePosition=" << currentNodePosition
	   << " currentPisition=" << currentPosition
	   << " readSize=" << readSize
	   << endl;
#endif
    }

  
  lock.unlock ();
  return readSize;
}

long MemoryBuffer::seekg (long offset,const Whence whence=cur) throw (Error)
{
  lock.lock ();
  if (head==NULL)
    {
      assert (current==NULL);
      assert (tail==NULL);
      lock.unlock ();
      return 0;
    }
  
  
  //ޤsingle linked listʤΤoffset>=0Ȥʤ褦Ĵ
  switch (whence)
    {
    case beg:
      assert (offset>=0);
      //dataƬ˰֤롣
      current=tail;
      currentNodePosition=0;
      currentPosition=0;
      //fall through
    case cur:
      if (offset<0)
	{//Single linked listʤΤǥǡƬéľ
	  offset=currentPosition+offset;
	  if (offset<0) offset=0;
	  current=head;
	  currentPosition=0;
	  currentNodePosition=0;
	}
      if (currentPosition+offset>=totalSize-1)
	{
	  offset=0;
	  current=tail;
	  currentNodePosition=current->getSize ();
	  currentPosition=totalSize;
	}
      break;
    case end:
      if (!isEod)
	throw (Error ("MemoryBuffer::seekg whence=end,but data is not ended"));
      assert (offset<=0);
      offset=totalSize-1+offset;
      if (offset<0) offset=0;
      if (offset>=totalSize-1)
	{//dataκǸ˹Ԥ
	  offset=0;
	  current=tail;
	  currentNodePosition=current->getSize ();
	  currentPosition=totalSize;
	}
      else
	{//ΤǥǡƬéľ
	  current=head;
	  currentPosition=0;
	  currentNodePosition=0;
	}
      break;
    }


  //offsetʤ롣
  assert (offset>=0);
  while (offset>0)
    {
      if (offset<current->leftBufferSize (currentNodePosition))
	{//nodeΰưǺѤࡣ
	  currentNodePosition+=offset;
	  currentPosition+=offset;
	  offset=0;
	}
      else
	{//node˰ư롣
	  if (current==tail)
	    {//줬Ǹnode
	      offset=0;
	      currentNodePosition+=current->leftBufferSize (currentNodePosition);
	      currentPosition+=current->leftBufferSize (currentNodePosition);
	      assert (currentNodePosition==current->getSize ());
	      assert (currentPosition==totalSize);
	    }
	  else
	    {
	      current=current->getNext ();
	      const long n=current->leftBufferSize (currentNodePosition);
	      offset-=n;
	      currentNodePosition=0;
	      currentPosition+=n;
	    }
	}
    }
  
  const long ret=currentPosition;
  lock.unlock ();

  return ret;
}




void MemoryBuffer::cat (const char* buffer,long size)
{
  assert (size>0);
  lock.lock ();
  if (head==NULL)
    {
      assert (current==NULL);
      assert (tail==NULL);
      head=new MemoryBufferNode (size);
      tail=head;
      current=head;
    }
  
  while (size>0)
    {
      if (tail->leftMemorySize ()==0)
	{
	  tail->setNext (new MemoryBufferNode (size));
	  tail=tail->getNext ();
	}
      const long n=min (tail->leftMemorySize (),size);
      tail->cat (buffer,n);
      totalSize+=n;
      buffer+=n;
      size-=n;
    }
  lock.unlock ();
  dataFilled.broadcast ();
}


void MemoryBuffer::printNodeInfo ()
{
  lock.lock ();
  cout << "MemoryBufferInfo totalSize=" << totalSize << endl;
  long i=0;
  long summedSize=0;
  for (const MemoryBufferNode* tmp=head;tmp!=NULL;tmp=tmp->getNext ())
    {
      summedSize+=tmp->getSize ();
      cout << i << "-th node:allocatedSize=" << tmp->getAllocatedSize ()
	   << " size=" << tmp->getSize ()
	   << " totalSize=" << summedSize << endl;
      
      i++;
    }
  lock.unlock ();
}
