#include <iostream>

#include "util/mytype.h"
#include "MemoryBuffer2.h"

using namespace std;

MemoryBuffer2::MemoryBuffer2 ():
  bufferSize (0)
{
  /*do nothing*/
}

MemoryBuffer2::~MemoryBuffer2 ()
{
  MemoryBufferNode* now=current;
  while (now!=NULL)
    {
      MemoryBufferNode* tmp=now;
      now=now->getNext ();//??? should be locked?
      delete tmp;
    }
}

long MemoryBuffer2::read
(char* buffer,const long size,const bool doesBlock=true)
{
  long readSize=0;//read size
  lock.lock ();
  
  while (readSize<size)
    {
      if (current==NULL)
	{
	  DEBUG_MESSAGE ("MemoryBuffer2::read current==NULL");
	  if (doesBlock==false || eodUnlocked ()) break;
	  dataFilled.wait (lock);
	  continue;
	}
      
      //nodeν
      assert (current!=NULL);
      if (current->leftBufferSize (currentNodePosition)==0)
	{//nodeɤ߽Ф
	  if (current==tail)
	    {//Ǹnodeä
	      if (current->leftMemorySize ()==0)
		{
		  DEBUG_MESSAGE ("MemoryBuffer2::read current==tail"
				 " leftMemory=0");
		  assert (current->getNext ()==NULL);
		  bufferSize-=current->getAllocatedSize ();
		  assert (bufferSize==0);
		  delete current;
		  current=NULL;
		  tail=NULL;
		  currentNodePosition=0;
		}
	      else
		{
		  DEBUG_MESSAGE ("MemoryBuffer2::read current->leftBufferSize ()==0,currnet->leftMemorySize ()>0");
		  if (doesBlock==false || eodUnlocked ()) break;
#ifdef DEBUG
		  cerr << "MemoryBuffer2:read totalSize=" << totalSize
		       << ":currentPosition=" << currentPosition
		       << endl;
#endif
		  assert (current->getNext ()==NULL);
		  DEBUG_MESSAGE ("MemoryBuffer2::read current->leftBufferSize ()==0,currnet->leftMemorySize ()>0 waiting");
		  dataFilled.wait (lock);
		  DEBUG_MESSAGE ("MemoryBuffer2::read current->leftBufferSize ()==0,currnet->leftMemorySize ()>0 wait done");
		}
	    }
	  else
	    {//node˰ܤ롣
	      assert (current->leftMemorySize ()==0);
	      bufferSize-=current->getAllocatedSize ();
	      MemoryBufferNode* tmp=current->getNext ();
	      assert (tmp!=NULL);
	      delete current;
	      current=tmp;
	      currentNodePosition=0;
	      assert (current!=NULL);
	    }
	  continue;
	}

      //datanodeɤ߹ࡣ
      //cerr << "from currentNodePosition=" << currentNodePosition;
      const long n=current->read (buffer,&currentNodePosition,size-readSize);
      assert (n>0);
      buffer+=n;
      currentPosition+=n;
      readSize+=n;
#if 0
      cerr << " to MemoryBuffer2::n=" << n
	   << " currentNodePosition=" << currentNodePosition
	   << " currentPisition=" << currentPosition
	   << " readSize=" << readSize
	   << endl;
#endif

    }
  lock.unlock ();
  return readSize;
}

void MemoryBuffer2::cat (const char* buffer,long size)
{
  assert (size>0);
  lock.lock ();
  
  while (size>0)
    {
      if (current==NULL)
	{//memory̵
	  assert (tail==NULL);
	  current=new MemoryBufferNode (size);
	  tail=current;
	  assert (bufferSize==0);
	  bufferSize+=tail->getAllocatedSize ();
	}
      
      assert (tail!=NULL);
      if (tail->leftMemorySize ()==0)
	{
	  tail->setNext (new MemoryBufferNode (size));
	  tail=tail->getNext ();
	  bufferSize+=tail->getAllocatedSize ();
	}
      assert (tail!=NULL);
      const long n=min (tail->leftMemorySize (),size);
      tail->cat (buffer,n);
      totalSize+=n;
      buffer+=n;
      size-=n;
    }
  lock.unlock ();
  dataFilled.broadcast ();
}


void MemoryBuffer2::printNodeInfo ()
{
  lock.lock ();
  cout << "MemoryBuffer2Info totalSize=" << totalSize << endl;
  long i=0;
  long summedSize=0;
  for (const MemoryBufferNode* tmp=current;tmp!=NULL;tmp=tmp->getNext ())
    {
      summedSize+=tmp->getSize ();
      cout << i << "-th node:allocatedSize=" << tmp->getAllocatedSize ()
	   << " size=" << tmp->getSize ()
	   << " totalSize=" << summedSize << endl;
      
      i++;
    }
  lock.unlock ();
}
