#ifndef MemoryBufferBase_H
#define MemoryBufferBase_H

#include <cassert>
#include <algorithm>

#include "util/CondVar.h"
#include "MemoryBufferNode.h"

class MemoryBufferBase
{
protected:
  mutable Mutex lock;//data locking(monitor lock)
  mutable CondVar dataFilled;//data are catted or eod?
  MemoryBufferNode* head;//linked listƬ(MemoryBuffer2ǤϻѤʤ)
  MemoryBufferNode* tail;//linked listκǸ
  MemoryBufferNode* current;//ɤ߽ФƤnode
  long totalSize;//total allocated memory size
  long currentNodePosition;//currentˤ븽ߤɤ߽Ф֡
  long currentPosition;//ɤ߽Фΰ
  bool isEod;//eodƤӽФ줿?
  bool eodUnlocked () const
    {return (isEod && (totalSize-1<=currentPosition));};
public:
  MemoryBufferBase ():
    head (NULL),tail (NULL),current (NULL),totalSize (0),
    currentNodePosition (0),currentPosition (0),isEod (false)
    {};
  virtual ~MemoryBufferBase (){};
  
  ///////////////////////////////////////////////////////////////dataɤ߽Ф
  //size byteɤ߽Фɤ߹Хȿ֤롣
  //block==trueλsize byteɤ߹뤫eodˤʤޤǥ֥å롣
  //block==falseλsize byteʲǡɤ߹ʤäɤ߹
  //ɤ߹롣
  virtual long read (char* buffer,const long size,const bool doesBlock=true)=0;
  long tellg () const
    {
      lock.lock ();
      long ret=currentPosition;
      lock.unlock ();
      return ret;
    };
  //ȤɤͭǡĤäƤ뤫
  //(ϥǡκǸޤǤȤ̣ǤϤʤcat뤫Τʤ)
  long readyBufferSize () const
    {
      lock.lock ();
      const long leftSize=totalSize-currentPosition;
      lock.unlock ();
      return leftSize;
    };
  //Ƥbuffersize֤
  long getTotalBufferSize () const
    {
      lock.lock ();
      const long retTotalSize=totalSize;
      lock.unlock ();
      return retTotalSize;
    };
  //isEod֤(???lock򤹤ɬ?)
  bool isAllStored () const
    {
      lock.lock ();
      const bool ret=isEod;
      lock.unlock ();
      return ret;
    };
  bool eod () const
    {
      lock.lock ();
      const bool ret=eodUnlocked ();
      lock.unlock ();
      return ret;
    };
  
  //////////////////////////////////////////////////////////////dataɲ
  virtual void cat (const char* buffer,long size)=0;//dataɲ

  //ʹߤϥǡɲä̵ȤΤ餻롣
  void doEOD ()
    {
      lock.lock ();
      isEod=true;
      lock.unlock ();
      dataFilled.broadcast ();
    };
  
  //////////////////////////////////////////////////////////////for debug
  virtual void printNodeInfo ()=0;
};
#endif // MemoryBufferBase_H
