#ifndef MemoryBufferNode_H
#define MemoryBufferNode_H

#include <cassert>
#include <algorithm>

#include "util/CondVar.h"

class MemoryBufferNode
{
#define MEMORY_BUFFER_SIZE_MIN 8192L //??? ĤŬʤΤ餦
private:
  MemoryBufferNode* next;//single linked list
  const long allocatedSize;//ݤ줿memory size(>=MEMROY_BUFFER_SIZE_MIN)
  long size;//߻ѤƤmemory size
  //ѤƤmemory size(׵ᤵ줿<MEMORY_BUFFER_SIZE_MINΤȤ
  //size<allocatedSize==MEMORY_BUFFER_SIZE_MINȤʤ롣)
  char* const buffer;//allocated memory
public:
  MemoryBufferNode::MemoryBufferNode (long size_):
    next (NULL),
    allocatedSize (max (MEMORY_BUFFER_SIZE_MIN,size_)),
    size (0),
    buffer (new char[allocatedSize])
    {/*do nothing*/};
  ~MemoryBufferNode ()
    {
      delete[] buffer;
    };
  MemoryBufferNode* getNext () const {return next;};
  void setNext (MemoryBufferNode* next_) {assert (next==NULL);next=next_;};
  long getSize () const {return size;};
  long getAllocatedSize () const {return allocatedSize;};
    
  /////////////////////////////////////////////////////////dataɤ߽Ф
  //buffer_positionΰ֤size byteɤ߽Ф
  //ɤ߽ФХȿ֤
  //ݥɤ߹ʬû롣
  long read (char* const buffer_,long* position,const long size_) const
    {
      assert (*position>=0);
      assert (*position<size);
      assert (size_>0);
      const long readSize=min (size_,leftBufferSize (*position));
      assert (readSize>=0);
      assert (*position+readSize<=size);
      memcpy (buffer_,buffer+*position,readSize);
      *position+=readSize;
      assert (*position<=size);
      return readSize;
    };
  //positionΰ֤ɤ߹Хȿ֤
  long leftBufferSize (const long position) const {return size-position;};
  
  /////////////////////////////////////////////////////////dataɲ
  //ѤǤ꡼ХȤ֤
  long leftMemorySize () const {return allocatedSize-size;};
  //size<allocatedSizeλ(i.e. leftMemorySize ()>0λ)
  //dataդ­size+size_<=allocatedSizeǤɬפ롣
  void cat (const char* buffer_,long size_)
    {
      assert (leftMemorySize ()>=size_);
      memcpy (buffer+size,buffer_,size_);
      size+=size_;
      assert (size<=allocatedSize);
    };
#undef MEMORY_BUFFER_SIZE_MIN
};
#endif // MemoryBufferNode_H
