#ifndef MemoryStream_H
#define MemoryStream_H

#include <fstream>

#include "MemoryBuffer.h"
#include "DataStream.h"


//adapter MemoryBuffer to 'DataStream'
class MemoryStream:public DataStream
{
protected:
  //store the data to
  MemoryBuffer* memoryBuffer;

  static void setDataTypeInfo (MemoryStream* me)
    {me->dataTypeInfo="Buffer on Memory.";};
public:
  MemoryStream (const char* path);
  MemoryStream (const char* parentDirectory,const char* baseName);
  MemoryStream (const char* path,const char* data_,long size_);
  MemoryStream (const char* parentDirectory,const char* baseName,
		const char* data_,long size_);
  virtual ~MemoryStream ();

  virtual void close ();//buffer˴
  virtual long read (char* buffer,long size){return read (buffer,size,true);};
  virtual long read (char* buffer,long size,bool doesBlock);
  virtual long seekg (long pos,Whence whence=cur);
  virtual long rewind ()
    {assert (memoryBuffer!=NULL);memoryBuffer->rewind ();return 0;};
  virtual long tellg () {return memoryBuffer->tellg ();};
  virtual bool eod () const {return memoryBuffer->eod ();};

  virtual bool isRandomAccessible () const {return true;};
  
  //data_,size_ɲä롣
  void cat (const char* data_,long size_)
    {assert (memoryBuffer!=NULL);memoryBuffer->cat (data_,size_);};
  virtual void doEOD (){assert (memoryBuffer!=NULL);memoryBuffer->doEOD ();};
};
#endif // MemoryStream_H
