#include <ctime>
#include <unistd.h>
#include <stdlib.h>

#include <iostream>

#include "MemoryBuffer.h"

int main ()
{
  timeval time;
  gettimeofday (&time,NULL);
  srand (static_cast<unsigned int>(time.tv_usec));

  cout << "now buffer initializing" << endl;
#define BUFFER_SIZE (1024*1024)
  char buffer[BUFFER_SIZE];
  for (long size=0;size<BUFFER_SIZE;size++)
    buffer[size]=static_cast<char> (size);

  cout << "now storerint memory" << flush;
  MemoryBuffer memoryBuffer;
  long size=0;
  while (size<BUFFER_SIZE)
    {
      const long tmp=static_cast<long>
	((static_cast<double>(BUFFER_SIZE/3)*rand ()/RAND_MAX));
      const long tmpSize=min (tmp,BUFFER_SIZE-size);
      cout << " size=" << tmpSize << flush;
      memoryBuffer.cat (buffer+size,tmpSize);
      size+=tmpSize;
    }
  cout << endl << "stored size=" << size << endl;
  
  cout << "now getting from memory" << flush;
  char result[BUFFER_SIZE];
  size=0;
  while (size<BUFFER_SIZE)
    {
      const long tmp=static_cast<long>
	((static_cast<double>(BUFFER_SIZE/3)*rand ()/RAND_MAX));
      const long tmpSize=min (tmp,BUFFER_SIZE-size);
      cout << " size=" << tmpSize
	   << " tmpSize=" << tmpSize
	   << " totalsize=" << size+tmpSize
	   << flush;
      
      memoryBuffer.read (result+size,tmpSize);
      size+=tmpSize;
    }
  cout << endl;
  cout << "read form memory size=" << size << endl;

  memoryBuffer.printNodeInfo ();
  
  if (memcmp (buffer,result,BUFFER_SIZE)!=0)
    {
      cerr << "There's error(s)." << endl;
    }

  for (long i=0;i<BUFFER_SIZE;i++)
    {
      if (buffer[i]!=static_cast<char>(i))
	{
	  cout << i << "-th" << "buffer data is broken." << endl;
	}
    }

  for (long i=0;i<BUFFER_SIZE;i++)
    {
      if (result[i]!=buffer[i])
	{
	  cout << i << "-th" << " result data is broken." << endl;
	  for (long j=i-10;j<i+10;j++)
	    {
	      cout << static_cast<int>(static_cast<char>(j)) << " "
		   << static_cast<int>(result[j]) << endl;
	    }
	}
    }
  

      
  cout << "all done." << endl;
}
