#include <ctime>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>

#include <iostream>

#include "MemoryBuffer.h"

#define BUFFER_SIZE (1024*1024*2)

MemoryBuffer memoryBuffer;

void* store (void* data)
{
  const char* buffer=static_cast<char*>(data);

  cout << "now storerint memory" << endl;
  long size=0;
  while (size<BUFFER_SIZE)
    {
      const long tmp=static_cast<long>
	((static_cast<double>(BUFFER_SIZE/3)*rand ()/RAND_MAX));
      const long tmpSize=(tmp<(BUFFER_SIZE-size)?tmp:BUFFER_SIZE-size);
      cout << "store size=" << tmpSize << endl;
      memoryBuffer.cat (buffer+size,tmpSize);
      size+=tmpSize;
    }
  memoryBuffer.doEOD ();
  cout << "total stored size=" << size << endl;

  return NULL;
}

void* retrieve (void* buffer)
{
  char* result=static_cast<char*>(buffer);

  cout << "now getting from memory" << endl;
  long size=0;
  while (size<BUFFER_SIZE)
    {
      const long tmp=static_cast<long>
	((static_cast<double>(BUFFER_SIZE/3)*rand ()/RAND_MAX));
      const long tmpSize=(tmp<(BUFFER_SIZE-size)?tmp:BUFFER_SIZE-size);
      cout << "retrieve size=" << tmpSize << endl;
      memoryBuffer.read (result+size,tmpSize,true);
      //memoryBuffer.read (result+size,tmpSize);
      size+=tmpSize;
    }
  cout << "read form memory size=" << size << endl;

  return NULL;
}


int main ()
{
  timeval time;
  gettimeofday (&time,NULL);
  srand (static_cast<unsigned int>(time.tv_usec));

  cout << "now buffer initializing" << endl;
  char buffer[BUFFER_SIZE];
  for (long size=0;size<BUFFER_SIZE;size++)
    buffer[size]=static_cast<char> (size);


  char result[BUFFER_SIZE];
  pthread_t thread1;
  pthread_create (&thread1,NULL,&retrieve,result);

  pthread_t thread2;
  pthread_create (&thread2,NULL,&store,buffer);

  cout << "joining storing thread" << endl;
  pthread_join (thread2,NULL);
  cout << "joining storing thread" << endl;
  cout << "joined retrieve thread" << endl;
  pthread_join (thread1,NULL);
  cout << "joined retrieving thread" << endl;
  





  memoryBuffer.printNodeInfo ();
  
  if (memcmp (buffer,result,BUFFER_SIZE)!=0)
    {
      cerr << "There's error(s)." << endl;
    }

  for (long i=0;i<BUFFER_SIZE;i++)
    {
      if (buffer[i]!=static_cast<char>(i))
	{
	  cout << i << "-th" << "buffer data is broken." << endl;
	}
    }

  for (long i=0;i<BUFFER_SIZE;i++)
    {
      if (result[i]!=buffer[i])
	{
	  cout << i << "-th" << " result data is broken." << endl;
	  for (long j=i-10;j<i+10;j++)
	    {
	      cout << static_cast<int>(static_cast<char>(j)) << " "
		   << static_cast<int>(result[j]) << endl;
	    }
	}
    }
      
  cout << "all done." << endl;
}

