/*
    Option.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef Option_H
#define Option_H

#include <list>
#include <string>

#include "PlayingStyle.h"
#include "DeviceResetType.h"

using namespace std;

class Option
{
public:
  int midiDeviceNum;
  bool isRealTime;
  bool isQuickStart;
  bool isQuiet;
  PlayingStyle::PlayingStyle playingStyle;
  PlayingStyle::LoopStyle loopStyle;
  PlayingStyle::PlayingMode playingMode;
  DeviceResetType::DeviceResetType deviceResetType;
  enum PortChangeType
    {
      IGNORE,//0-15$B0J30$OL5;k!#(B
      SERIAL,//0xF5 pp$B$rMxMQ(B
      USE_ROLAND_SYS_EX,//rolland sys ex(CHANNEL MSG RX POR)$B$rMxMQ(B
      //needs more?
    };
  PortChangeType portChangeType;
  bool doesUseMITSHM;
  list<string> modulePath;//dynamic link$B$9$k;~$KC5$9(Bpath
  list<string> preloadIoNames;
  //$BI=<($9$k%b%8%e!<%k$NL>A0!#(B
  list<string> ioNames;//should be NULL terminated
  //kanjiInType;
  //kanjiOutType;
  //int deviceType;//GS,GM,sc-88,sc-88 pro,XG

  //Wrd$B$G<B9T$7$?%^%/%m$N9T$r(Bcerr$B$KI=<(!#(B
  bool wrdDoesCerrDebug;
  //XWrd$B$G(Bplane mask$B$rM-8z$K$9$k$+(B?(true$B$@$H(Bplane mask$B$r;HMQ!#(B)
  bool xwrdDoesPlaneMask;
  Option ():
    midiDeviceNum (0),
    isRealTime (false),isQuickStart (false),isQuiet (false),
    playingStyle (PlayingStyle::DEFAULT_PLAYING_STYLE),
    loopStyle (PlayingStyle::DEFAULT_LOOP_STYLE),
    playingMode (PlayingStyle::DEFAULT_PLAYING_MODE),
    deviceResetType (DeviceResetType::NONE),
    portChangeType (IGNORE),
    doesUseMITSHM (false),
    wrdDoesCerrDebug (false), xwrdDoesPlaneMask (true)
    {/*do nothing*/;};
};
#endif // Option_H
