#include "SongFileItem.h"
#include "IO/MainIONull.h"
#include "Song/SongFactory.h"
#include "ServerCommand.h"
#include "SongManager.h"

void SongFileItem::setPlayTime (uint32 playTime__)
{
  assert (!isPlayTimeSet ());
  isPlayTimeSet__ = true;
  playTime = playTime__;
}

void SongFileItem::setTitle (const string& title__)
{
  assert (!isTitleSet ());
  isTitleSet__ = true;
  title = title__;
}

void SongFileItem::set (const Song* song)
{
  setPlayTime (song->getPlayTime ());
  setTitle (song->getTitle ());
}

bool SongFileItem::search ()
{
  assert (!isPlayTimeSet ());
  assert (!isTitleSet ());
  
  State dummyState;
  Option dummyOption;
  dummyOption.isQuickStart = true;
#if 0
  try
    {
#endif
      ServerCommand* serverCommand = new ServerCommand;
      SongManager* songManager = new SongManager ();
      WidiController dummyWidiController (serverCommand, songManager);
      MainIO* dummyMainIONull = new MainIONull (&dummyState,
						&dummyWidiController,
						&dummyOption);
#if 0
    }
    catch ()
    {
    }
#endif
  SongCommand dummySongCommand;

  bool isSearchSuccessed = false;
  Song* song = SongFactory::newSong (fileName, &dummyState, &dummySongCommand,
				     *dummyMainIONull, &dummyOption);
  if (song != NULL)
    {
      isSearchSuccessed = true;
      set (song);
    }
  
  delete song;
  delete dummyMainIONull;
  delete serverCommand;
  delete songManager;
  
  return isSearchSuccessed;
}
