#include "SongFileList.h"
#include "IO/MainIONull.h"
#include "Song/SongFactory.h"
#include "util/Random.h"

void SongFileList::searchAppend (const string& filename)
{
  DEBUG_MESSAGE ("SongFileList::append called");
  SongFileItem songFileItem (filename);
  if (songFileItem.search ())
    {//fileäƱղǽեä
      DEBUG_MESSAGE ("SongFileList::append appending.");
      push_back (songFileItem);
    }
  DEBUG_MESSAGE ("SongFileList::append done.");
}

void SongFileList::append (const string& filename)
{
  DEBUG_MESSAGE ("SongFileList::append called");
  SongFileItem songFileItem (filename);
  push_back (songFileItem);
  DEBUG_MESSAGE ("SongFileList::append done.");
}


SongFileList::SongItem SongFileList::getRidOf (uint i)
{
  if (i >= size ())
    return end ();
  
  iterator j = begin ();
  for (uint k = 0; k < i; i++, j++)
    /*do nothing*/;
  
  return erase (j);
}


SongFileList::SongItem SongFileList::getRidOf (const string& filename)
{
  for (iterator i = begin (); i != end (); i++)
    {
      if ((*i).getFileName () == filename)
	return erase (i);
    }

  return end ();
}

SongFileList::SongItem SongFileList::getRidOf (const SongFileItem& songFileItem)
{
  for (iterator i = begin (); i != end (); i++)
    {
      if (*i == songFileItem)
	return erase (i);
    }

  return end ();
}

void SongFileList::randomShuffle ()
{
  Random random;
  uint j = 1;//1ʤΤ% jͤ[0,j)ʤΤ
  for (iterator i = begin (); i != end (); i++, j++)
    {
      iter_swap (i, get (random () % j));
    }
  
  //list is not random accessible
  //so, can not use random_shuffle
  //random_shuffle (begin (), end ());
}
