#ifndef SongFileList_H
#define SongFileList_H

#include <algorithm>
#include <list>

#include "SongFileItem.h"

using namespace std;

class SongFileList:public list<SongFileItem>
{
public:
  typedef SongFileList::const_iterator SongItem;
public:
  SongFileList () {};
  ~SongFileList () {};
  
  void fileNameSortLess () {sort (SongFileItem::FileNameLess ());};
  void fileNameSortGreater () {sort (SongFileItem::FileNameGreater ());};
  void playTimeSortLess () {sort (SongFileItem::PlayTimeLess ());};
  void playTimeSortGreater () {sort (SongFileItem::PlayTimeGreater ());};
  void titleSortLess () {sort (SongFileItem::TitleLess ());};
  void titleSortGreater () {sort (SongFileItem::TitleGreater ());};

  void unique () {list<SongFileItem>::unique (SongFileItem::Equal ());};
  
  //filenamesearchfileäƱղǽʤ
  //SongFileItempush_bask롣
  void searchAppend (const string& filename);

  //filename¸ߤ뤫뤤ϱղǽ˴ؤ餺
  //SongFileItempush_back롣
  void append (const string& filename);
  
  SongItem getRidOf (uint i);//iܤǤ
  //filename˹פʪκǽΰĤ
  SongItem getRidOf (const string& filename);
  SongItem getRidOf (const SongFileItem& songFileItem);


  iterator get (uint n)
    {
      if (n > size ())
	end ();

      iterator ret = begin ();
      for (uint j = 0; j < n; j++)
	ret++;

      return ret;
    };
  
  void randomShuffle ();

  iterator find (const SongFileItem& songFileItem) //const //begin,end are not const iterator :-<
    {
      iterator ret = std::find (begin (), end (), songFileItem);
      assert (ret != end ());
      return ret;
    };

  iterator find (const string& fileName) //const //begin,end are not const iterator :-<
    {
      for (iterator i = begin (); i != end (); i++)
	{
	  if ((*i).getFileName () == fileName)
	    return i;
	}
      
      return end ();
    };
};
#endif // SongFileList_H
