#include "TimerSignal.h"

TimerSignal::~TimerSignal ()
{
  for (Connections::reverse_iterator i = connections.rbegin ();
       i != connections.rend ();
       i++)
    delete (*i).second;
}
  
void TimerSignal::connect (Tag tag, TimerConnection* timerConnection__)
{
  assert (timerConnection__ != NULL);
  connections.push_back (pair<Tag, TimerConnection*> (tag, timerConnection__));
}

bool TimerSignal::disconnect (Tag tag)
{
  for (Connections::iterator i = connections.begin ();
       i != connections.end ();
       i++)
    {
      if ((*i).first == tag)
	{
	  delete (*i).second;
	  connections.erase (i);
	  return true;
	}
    }

  return false;
}


void TimerSignal::operator () ()
{
  for (Connections::iterator i = connections.begin ();
       i != connections.end ();
       i++)
    (*i).second->call ();
}

