#ifndef TimerSignal_H
#define TimerSignal_H

#include <list>

#include "util/mytype.h"
#include "TimerConnection.h"

using namespace std;

class TimerSignal
{
public:
  typedef uint Tag;
  
private:
  typedef list<pair<Tag, TimerConnection*> > Connections;
  Connections connections;
  
public:
  TimerSignal () {};
  ~TimerSignal ();

  void connect (Tag tag, TimerConnection* timerConnection__);

  template <typename T>
  void connect (Tag tag, T* t,
		void (T::*method) (void*), void* arg)
    {
      return connect (tag, new TimerConnectionImple<T> (t, method, arg));
    };
  
  bool disconnect (Tag tag);
  Connections::size_type size ()
    {
      return connections.size ();
    };

  //tags뤿access method
  Connections::iterator getBegin () {return connections.begin ();};
  Connections::iterator getEnd () {return connections.end ();};
  
  void operator ()();
};
#endif //TimerSignal_H
