/*
    DlHandler.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef DlHandler_H
#define DlHandler_H

#include <string>
#include <dlfcn.h>

#include "Widi/Option.h"

using namespace std;

class DlHandler
{
protected:
  Option* const option;
  
  void* handle;
public:
  DlHandler (Option* option_);
  ~DlHandler ();
#ifdef RTLD_GLOBAL
  const void* open (const string& filename, int flag = RTLD_GLOBAL | RTLD_LAZY);
#else
  const void* open (const string& filename, int flag = RTLD_LAZY);//Does this work well?
#endif

  const void* openLibSo (const string& prefix, const string& name);
  void* sym (string& symbol);
  void close ();
  static DlHandler* newOpenDlHandler (const string& prefix, const string& name,
				      Option* option);
};
#endif //DlHandler_H
