/*
    IOtest.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "IOtest.h"
#include "util/schedYield.h"
#include "util/PThreadStartRoutine.h"


int IOtest::createPlayLoopThread (pthread_t* thread, pthread_attr_t* attr)
{
  assert (thread != NULL);
  //return pthread_create (thread,attr,IOtest::startPlayLoopThread,this);
  return pthread_create (thread, attr,
			 &PThreadStartRoutine<IOtest, &playLoop>,
			 static_cast<void*> (this));
}

void IOtest::playLoop ()
{
  DEBUG_MESSAGE ("IOtest::playLoop called");
  uint32 lastTicks = 0;
  for (;;)
    {
      //$B>uBV$NJQ2=BT$A(B
      state->lock ();
      while ((lastTicks == state->songStatus.ticks) &&
	     (state->songStatus.state != SongStatus::DONE))
	state->waitChange ();
      state->getState (&cacheState);
      state->unlock ();
      
      lastTicks = cacheState.songStatus.ticks;

      //$B6qBNE*$J=hM}!#(B
      update ();
      if (cacheState.songStatus.state == SongStatus::DONE)
	break;
      schedYield ();
    }
}


void IOtest::update ()
{
}

    
