/*
    IOtest.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef IOtest_H
#define IOtest_H

#include <iostream>
#include <pthread.h>

#include "util/mytype.h"
#include "Widi/Option.h"
#include "Widi/State.h"
#include "Widi/ServerCommand.h"

using namespace std;

class IOtest
{
public:
  virtual void playLoop ();//$B$3$l$O(BMainIO$B$GL5$$;~$K(Bloop$B$9$kJ*!#(B
  //MainIO$B$H$7$FF0:n$9$k$H$-$O(BmainLoop$B$r;H$&!#(B

protected:
  Option* option;
  State* state;
  State cacheState;
  ServerCommand* serverCommand;

protected:
  virtual void update ();
  
public:
  IOtest (State* state_, ServerCommand* serverCommand_, Option* option_):
    option (option_), state(state_), cacheState (),
    serverCommand (serverCommand_)
    {
      assert (state != NULL);
      assert (option != NULL);
      assert (serverCommand != NULL);
    };
  virtual ~IOtest (){/* do nothing*/;};


  //$B$3$l$G(Bthread$B$H$7$FAv$k!#(B
  int createPlayLoopThread (pthread_t* thread, pthread_attr_t* attr);

};

#endif // IOtest_H
