/*
    KanjiConvert.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "mytype.h"

//sjis$B$r(Beuc$B$KJQ49$9$k!#(B
//char *sjis$B$KF~$C$F$$$k(Bsjis code$B$r(Beuc code$B$KJQ49$7$F(Bchar *euc$B$KF~$l$FJV$9!#(B
//length$B$K$O(Bsjis$B$N(Bbyte$B?t!#(B
//euc$B$O(Blength*2$B0J>e3NJ]$7$F$*$/$3$H!#(B
//$BJV$jCM$O(Beuc$B$N%P%$%H?t!#(B
int convertSjis2Euc (const char* sjis,int length,char* euc)
{
  const uchar* src=(uchar*) sjis;
  uchar* dest=(uchar*) euc;
  int j=0;
  for (int i=0;i<length;i++)
    {
      if (src[i]>=0xa1 && src[i]<=0xdf)
        {//$BH>3Q2>L>$@$C$?(B
          dest[j++]=0x8e;
          dest[j++]=src[i];
        }
      else if ((0x81<=src[i] && src[i]<=0x9f)||
               (0xe0<=src[i] && src[i]<=0xfc))
        {//2byte code$B$@$C$?!#(B
          dest[j++]=src[i]*2
            -((src[i]<=0x9f)?0xe1:0x161)+0x80;
          dest[j++]=src[++i];
          if (src[i]<0x9f)
            dest[j-1]+=(src[i]>0x7f)?0x60:0x61;
          else 
            {
              dest[j-1]+=2;
              dest[j-2]++;
            }
        }
      else dest[j++]=src[i];//1byte code$B$@$C$?!#(B
    }
  return(j);
}

int convertSjis2Euc (const char* sjis,char* euc)
{
  int length=convertSjis2Euc (sjis,strlen (sjis),euc);
  euc[length++]='\0';
  return length;
}

int convertEuc2Sjis (const char* euc,int length,char* sjis)
{
  const uchar* src=(uchar*) euc;
  uchar* dest=(uchar*) sjis;

  int j=0;
  for (int i=0;i<length && src[i]!='\0';i++,j++)
    {
      if (src[i]==0x8E && src[i+1])
	dest[j]=src[++i];
      else if (0xA1<=src[i] && src[i]<=0xFE)
	{
	  dest[j++]=((src[i]-0x81) >> 1)+((src[i]<0xdf)?0x71:0xb1);
	  dest[j]=src[++i]-0x80;
	  if (src[i-1]&1)
	    dest[j]+=(src[i]<0xe0)?0x1f:0x20;
	  else
	    dest[j]+=0x7e;
	}
      else
	dest[j] = src[i];
    }
  return (j);
}

int convertEuc2Sjis (const char* euc,char* sjis)
{
  int length=convertEuc2Sjis (euc,strlen (euc),sjis);
  sjis[length++]='\0';
  return length;
}

int convertEuc2Jis (const char* euc,int length,char* jis)
{
  return 0;//XXX
}

int convertEuc2Jis (const char* euc,char* jis)
{
  int length=convertEuc2Jis (euc,strlen (euc),jis);
  jis[length++]='\0';
  return length;
}
