/*
    KanjiConvert.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#ifndef KanjiConvert_H
#define KanjiConvert_H
const unsigned char SSO = 0x8e;  // EUC SS0 X0201

inline bool iskanji(unsigned char c) {return (c > 0x80 && c != SSO);}
inline bool iskana(unsigned char c) {return (c == SSO);}
inline bool isiso(unsigned char c) {return (0x1f < c && c < 0x80);}

inline bool iskanji(char c) {return iskanji (static_cast<unsigned char> (c));}
inline bool iskana(char c) {return iskana (static_cast<unsigned char> (c));}
inline bool isiso(char c) {return isiso (static_cast<unsigned char>(c));}


// SJIS (MS KANJI)
inline bool issjkana(unsigned char c) { return (0xa0 <= c && c <= 0xdf); }
// JIS X0201 kana
inline bool issjkanji(unsigned char c) { return (c > 0x80 && !issjkana(c)); }



int convertSjis2Euc (const char* sjis,int length,char* euc);
int convertSjis2Euc (const char* sjis,char* euc);
int convertEuc2Sjis (const char* euc,int length,char* sjis);
int convertEuc2Sjis (const char* euc,char* sjis);
int convertEuc2Jis (const char* euc,int length,char* jis);
int convertEuc2Jis (const char* euc,char* jis);
#endif // KanjiConvert_H
