#ifndef PThreadAttribure_H
#define PThreadAttribure_H

class PThreadAttribute
{
private:
  pthread_attr_t threadAttribute;
public:
  PThreadAttribute ()
    {
      const int ret = pthread_attr_init (&threadAttribute);
      if (ret != 0)
	{
	  //XXX$B$b$&$A$g$C$H$^$7$J%(%i!<=hM}$N;EJ}$,$"$kH&!#(B
	  cerr << "PThreadAttribute::ThreadAttribute"
	       << " can not initalize pthread_t:"
	       << strerror (ret) << endl;
	  exit (1);
	}
      setScope (PTHREAD_SCOPE_SYSTEM);

#ifdef __FreeBSD__
      setStackSize (1024*1024);//$B4v$D$,E,Ev(B?
#endif //__FreeBSD__
    };
  
  ~PThreadAttribute ()
    {
      const int ret = pthread_attr_destroy (&threadAttribute);
      if (ret != 0)
	{
	  //XXX$B$b$&$A$g$C$H$^$7$J%(%i!<=hM}$N;EJ}$,$"$kH&!#(B
	  cerr << "PThreadAttribute::createPlayThread:"
	       << "can not destroy thread attribut:"
	       << strerror (ret) << endl;
	  exit (1);
	}
    };

  void setDetachState (int detachstate)
    {
      const int ret = pthread_attr_setdetachstate (&threadAttribute,
						   detachstate);
      if (ret != 0)
	{
	  //XXX$B$b$&$A$g$C$H$^$7$J%(%i!<=hM}$N;EJ}$,$"$kH&!#(B
	  cerr << "PThreadAttribute::setDetachState can not set detach state:"
	       << strerror (ret) << endl;
	  exit (1);
	}
    };

  void setSchedPolicy (int policy)
    {
#ifdef _PTHREAD_PRIORITY_SCHEDULING //???$B$3$l$G$$$$$N(B?
      const int ret = pthread_attr_setschedpolicy (&threadAttribute, policy);
      if (ret != 0)
	{
	  //XXX$B$b$&$A$g$C$H$^$7$J%(%i!<=hM}$N;EJ}$,$"$kH&!#(B
	  cerr << "PThreadAttribute::setSchedPolicy can not set sched policy:"
	       << strerror (ret) << endl;
	  exit (1);
	}
#endif //_PTHREAD_PRIORITY_SCHEDULING
    };
  
  void setScope (int scope)
    {
#ifdef _PTHREAD_PRIORITY_SCHEDULING //???$B$3$l$G$$$$$N(B?
      const int ret = pthread_attr_setscope (&threadAttribute, scope);
      if (ret != 0)
	{
	  //XXX$B$b$&$A$g$C$H$^$7$J%(%i!<=hM}$N;EJ}$,$"$kH&!#(B
	  cerr << "PThreadAttribute::setScope:"
	       << "can not set scope to thread attribut:"
	       << strerror (ret) << endl;
	  exit (1);
	}
#endif //_PTHREAD_PRIORITY_SCHEDULING
    };

  void setStackSize (size_t stackSize)
    {
#ifdef _POSIX_THREAD_ATTR_STACKSIZE
      const int ret = pthread_attr_setstacksize (&threadAttribute, stackSize);
      if (ret != 0)
	{
	  //XXX$B$b$&$A$g$C$H$^$7$J%(%i!<=hM}$N;EJ}$,$"$kH&!#(B
	  cerr << "PThreadAttribute::setStackSzie"
	       << "can not set statcksize to thread attribut:"
	       << strerror (ret) << endl;
	  exit (1);
	}
#endif // _POSIX_THREAD_ATTR_STACKSIZE
    }
  
  
  
  //XXX
  pthread_attr_t& getPThreadAttribute () {return threadAttribute;};
};
#endif // PThreadAttribure_H
