#ifndef getABSTimeSpec_H
#define getABSTimeSpec_H

#include <unistd.h>
#include <ctime>
#include <cassert>
#include <sys/time.h> // why needs this???

using namespace std;

//$B8=:_$N;~9o$+$i(B,sec,nanosec$B8e$N@dBP;~4V$r(BtimeSpec$B$K@_Dj$9$k!#(B
inline void getABSTimeSpec (timespec* timeSpec, long sec, long nanosec)
{
  assert (timeSpec != NULL);
  assert (sec >= 0);
  assert (nanosec >= 0);
  
  timeval timeVal;
  gettimeofday (&timeVal, static_cast<struct timezone*> (NULL));
  timeSpec->tv_sec = timeVal.tv_sec+sec;
  timeSpec->tv_nsec = timeVal.tv_usec*1000+nanosec;
  if (timeSpec->tv_nsec >= 1000000000)
    {//$B7+>e$,$j=hM}(B
      timeSpec->tv_sec += timeSpec->tv_nsec/1000000000;
      timeSpec->tv_nsec %= 1000000000;
    }
};

#endif // getABSTimeSpec_H
