#include <iostream>
#include <cstring>

#include <pthread.h>

#include "PThreadStartRoutine.h"

using namespace std;

#define RAISE_BUG
//#undef RAISE_BUG

class Job
{
public:
#ifdef RAISE_BUG
  virtual void dummy ();
#endif
  virtual void doJob ();
};

class Job2:public Job
{
public:
  virtual void doJob ();
};

#ifdef RAISE_BUG
void Job::dummy ()
{
}
#endif

void Job::doJob ()
{
  const int MAX_TIMES = 10;
  for (int i = 0; i < MAX_TIMES; i++)
    cout << "Job::doJob" << endl;
}

void Job2::doJob ()
{
  const int MAX_TIMES = 10;
  for (int i = 0; i < MAX_TIMES; i++)
    cout << "Job2::doJob" << endl;
}


int main (int argc, char** argv)
{
  Job job;
  pthread_t thread;
  const int ret0 = pthread_create (&thread, NULL,
				   &PThreadStartRoutine<Job, &Job::doJob>,
				   &job);

  if (ret0 != 0)
    {
      cerr << "error:pthread_create:" << strerror (ret0) << endl;
      exit (1);
    }
  
  const int ret1 = pthread_join (thread, NULL);
  if (ret1 != 0)
    {
      cerr << "error:pthread_join:" << strerror (ret1) << endl;
      exit (1);
    }

  Job2 job2;
  const int ret2 = pthread_create (&thread, NULL,
				   &PThreadStartRoutine<Job, &Job::doJob>,
				   //&PThreadStartRoutine<Job2, &Job2::doJob>,
				   &job2);
  
  if (ret2 != 0)
    {
      cerr << "error:pthread_create:" << strerror (ret2) << endl;
      exit (1);
    }
  
  const int ret3 = pthread_join (thread, NULL);
  if (ret3 != 0)
    {
      cerr << "error:pthread_join:" << strerror (ret3) << endl;
      exit (1);
    }

  cout << "all done." << endl;
  return 0;
}
